<?php

namespace App\Entity;

use App\Repository\KategoriRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=KategoriRepository::class)
 */
class Kategori
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $seourl;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $title;

    /**
     * @ORM\Column(type="text", nullable=true)
     */
    private $keywords;

    /**
     * @ORM\Column(type="text", nullable=true)
     */
    private $description;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $adi;

    /**
     * @ORM\Column(type="integer")
     */
    private $ustid;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $resim;

    /**
     * @ORM\Column(type="integer")
     */
    private $dilgrup;

    /**
     * @ORM\Column(type="integer")
     */
    private $sira;

    /**
     * @ORM\ManyToOne(targetEntity=Sayfa::class, inversedBy="kat")
     * @ORM\JoinColumn(nullable=false)
     */
    private $sayfa;

    /**
     * @ORM\ManyToOne(targetEntity=Dil::class, inversedBy="kategori")
     * @ORM\JoinColumn(nullable=false)
     */
    private $dil;

    public function __construct()
    {

    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getSeourl(): ?string
    {
        return $this->seourl;
    }

    public function setSeourl(string $seourl): self
    {
        $this->seourl = $seourl;

        return $this;
    }

    public function getTitle(): ?string
    {
        return $this->title;
    }

    public function setTitle(string $title): self
    {
        $this->title = $title;

        return $this;
    }

    public function getKeywords(): ?string
    {
        return $this->keywords;
    }

    public function setKeywords(?string $keywords): self
    {
        $this->keywords = $keywords;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(?string $description): self
    {
        $this->description = $description;

        return $this;
    }

    public function getAdi(): ?string
    {
        return $this->adi;
    }

    public function setAdi(string $adi): self
    {
        $this->adi = $adi;

        return $this;
    }

    public function getUstid(): ?int
    {
        return $this->ustid;
    }

    public function setUstid(int $ustid): self
    {
        $this->ustid = $ustid;

        return $this;
    }

    public function getResim(): ?string
    {
        return $this->resim;
    }

    public function setResim(?string $resim): self
    {
        $this->resim = $resim;

        return $this;
    }

    public function getDilgrup(): ?int
    {
        return $this->dilgrup;
    }

    public function setDilgrup(int $dilgrup): self
    {
        $this->dilgrup = $dilgrup;

        return $this;
    }

    public function getSira(): ?int
    {
        return $this->sira;
    }

    public function setSira(int $sira): self
    {
        $this->sira = $sira;

        return $this;
    }

    public function getSayfa(): ?Sayfa
    {
        return $this->sayfa;
    }

    public function setSayfa(?Sayfa $sayfa): self
    {
        $this->sayfa = $sayfa;

        return $this;
    }

    public function getDil(): ?Dil
    {
        return $this->dil;
    }

    public function setDil(?Dil $dil): self
    {
        $this->dil = $dil;

        return $this;
    }
}
