<?php

namespace App\Controller;

use App\Entity\Dil;
use Doctrine\Persistence\ManagerRegistry;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Controller\BaseController;
use App\Entity\Ayarlar;

class PanelAyarlarController extends BaseController
{

    /**
     * @Route("/rv/ayarlar", name="ayarlar_homepage")
     */
    public function index() : Response
    {
        $yetkilerim = $this->yetkiler($this->getUser()->getYetkiler());
        if ($yetkilerim!=1 and $yetkilerim['Site Ayarları']['gorme']==0){
            return $this->redirectToRoute('panel_homepage');
        }


        $em = $this->getDoctrine()->getManager();

        $qb = $em->createQueryBuilder();
        $ayarlar=$qb->select('a.position,a.hataPage,a.slider,a.debug,a.bEposta,a.whatsapp,a.siteAdi,a.siteYolu,a.logo,a.beyazLogo,a.favicon,a.ozelHead,a.title,a.keywords,a.description,a.region,a.placeName,a.id,a.uploadFolder')
            ->from('App:Ayarlar', 'a')
            ->join('a.dil','d')
            ->orderBy('d.id')
            ->getQuery()
            ->getScalarResult();

        $qb = $em->createQueryBuilder();
        $diller=$qb->select('d.id,d.kisa')
            ->from('App:Dil', 'd')
            ->where('d.aktif=1')
            ->orderBy('d.id')
            ->getQuery()
            ->getScalarResult();



        return $this->render('panel/ayarlar/index.html.twig',array('ayarlar'=>$ayarlar,'diller'=>$diller));
    }

    /**
     * @Route("/rv/kaydet", name="ayarlar_kaydet")
     */
    public function kaydetAction(Request $request){
        $em = $this->getDoctrine()->getManager();



        $slider = $request->request->get('slider');
        $debug = $request->request->get('debug');
        $hataPage = $request->request->get('hataPage');
        $bEposta = $request->request->get('bEposta');
        $whatsapp = $request->request->get('whatsapp');
        $siteadi = $request->request->get('siteadi');
        $siteyolu = $request->request->get('siteyolu');
        $uploadFolder = $request->request->get('uploadFolder');
        $ozelHead = $request->request->get('ozelHead');
        $title= $request->request->get('title');
        $keywords= $request->request->get('keywords');
        $description= $request->request->get('description');
        $region= $request->request->get('region');
        $placeName= $request->request->get('placeName');
        $position= $request->request->get('position');





        if (!empty($_FILES['logo']['name'])) {

            $logo='logo';
            move_uploaded_file($_FILES['logo']['tmp_name'], "gecici_yukleme/".$logo.$this->uzantiBul($_FILES['logo']['type']));
            $logo = $this->imageResizer($logo.$this->uzantiBul($_FILES['logo']['type']),$logo,400);
            $this->deleteFile($logo);
            $this->uploadFile($logo);
        }

        if (!empty($_FILES['beyazLogo']['name'])) {
            $beyazLogo='beyazLogo';
            move_uploaded_file($_FILES['beyazLogo']['tmp_name'], "gecici_yukleme/".$beyazLogo.$this->uzantiBul($_FILES['beyazLogo']['type']));
            $beyazLogo = $this->imageResizer($beyazLogo.$this->uzantiBul($_FILES['logo']['type']),$beyazLogo,400);
            $this->deleteFile($beyazLogo);
            $this->uploadFile($beyazLogo);
        }

        if (!empty($_FILES['favicon']['name'])) {
            $favicon='favicon';
            move_uploaded_file($_FILES['favicon']['tmp_name'], "gecici_yukleme/".$favicon.$this->uzantiBul($_FILES['favicon']['type']));
            $favicon = $this->imageResizer($favicon.$this->uzantiBul($_FILES['logo']['type']),$favicon,100);
            $this->deleteFile($favicon);
            $this->uploadFile($favicon);
        }

        $qb = $em->createQueryBuilder();
        $diller=$qb->select('d.id')
            ->from('App:Dil', 'd')
            ->where('d.aktif=1')
            ->orderBy('d.id')
            ->getQuery()
            ->getScalarResult();



        foreach ($diller as $key=>$dil){

            $qb = $em->createQueryBuilder();
            $ayarBul=$qb->select('a.id')
                ->from('App:Ayarlar', 'a')
                ->join('a.dil','d')
                ->where('d.id='.$dil['id'])
                ->getQuery()
                ->getScalarResult();


            $dilSecim = $em->getReference(Dil::class,$dil['id']);

            if(count($ayarBul)>0){
                $ayar = $em->getRepository(Ayarlar::class)->findOneBy(array('dil'=>$dil['id']));
            }else{
                $ayar = new Ayarlar();
            }


            $ayar->setHataPage($hataPage);
            $ayar->setDebug($debug);
            $ayar->setSlider($slider);
            $ayar->setBEposta($bEposta);
            $ayar->setWhatsapp($whatsapp);
            $ayar->setSiteadi($siteadi);
            $ayar->setSiteyolu($siteyolu);
            $ayar->setUploadFolder($uploadFolder);
            $ayar->setOzelHead($ozelHead);
            $ayar->setTitle($title[$key]);
            $ayar->setKeywords($keywords[$key]);
            $ayar->setDescription($description[$key]);
            $ayar->setRegion($region[$key]);
            $ayar->setPlaceName($placeName[$key]);
            $ayar->setPosition($position[$key]);
            if (!empty($_FILES['logo']['name'])) {
                $ayar->setLogo($logo);
            }
            if (!empty($_FILES['beyazLogo']['name'])) {
                $ayar->setBeyazLogo($beyazLogo);
            }
            if (!empty($_FILES['favicon']['name'])) {
                $ayar->setFavicon($favicon);
            }
            $ayar->setDil($dilSecim);
            $em->persist($ayar);
            $em->flush();

        }



        $dosya = fopen('../.env','r');
        $oku = fread($dosya, filesize('../.env'));
        fclose($dosya);

        if($debug==1){
            $oku = str_replace('APP_ENV=prod','APP_ENV=dev',$oku);
        } else{
            $oku = str_replace('APP_ENV=dev','APP_ENV=prod',$oku);
        }

        $app = fopen('../.env', 'w');
        fwrite($app, $oku);
        fclose($app);

        shell_exec("php ".$_SERVER['DOCUMENT_ROOT']."/bin/console cache:clear");
        shell_exec("php ".$_SERVER['DOCUMENT_ROOT']."/bin/console cache:clear --env=prod");

        shell_exec("".$_SERVER['DOCUMENT_ROOT']."/chmod 777 -R var/");
        shell_exec("".$_SERVER['DOCUMENT_ROOT']."/chmod 777 -R var");

        return new Response('');

    }

    /**
     * @Route("/rv/anadizin", name="ayarlar_anadizin")
     */
    public function anadizin(Request $request):Response
    {
        if ($_FILES['anadizin']['type']=='text/html' or $_FILES['anadizin']['type']=='application/xml') {
            move_uploaded_file($_FILES['anadizin']['tmp_name'], $_FILES['anadizin']['name']);
        }
        return new Response('');
    }



}
