<?php

namespace App\Controller;

use App\Entity\Bildirim;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Controller\BaseController;

class PanelBildirimlerController extends BaseController
{

    /**
     * @Route("/rv/bildirimler", name="bildirimler_homepage")
     */
    public function index(): Response
    {
        $em = $this->getDoctrine()->getManager();

        $qb = $em->createQueryBuilder();
        $q = $qb->update('App:Bildirim', 'b')
            ->set('b.okuma', 1)
            ->getQuery()
            ->execute();

        return $this->render('panel/bildirimler/index.html.twig');
    }

    /**
     * @Route("/rv/bildirimler/getir", name="bildirimler_getir")
     */
    public function getir(Request $request): Response{
        $em = $this->getDoctrine()->getManager();


        $qb = $em->createQueryBuilder();
        $bildirimler=$qb->select("b.id,b.baslik,b.metin,b.okuma,b.tarih")
            ->from('App:Bildirim', 'b')
            ->orderBy('b.tarih','desc')
            ->getQuery()
            ->getScalarResult();

        return $this->render('panel/bildirimler/getir.html.twig',array('bildirimler'=>$bildirimler));

    }

    /**
     * @Route("/rv/bildirimler/sil", name="bildirimler_sil")
     */
    public function sil(Request $request): Response{
        $em = $this->getDoctrine()->getManager();

        $id = $request->request->get('id');

        $x = $em->getRepository(Bildirim::class)->findOneBy(array('id'=>$id));
        $em->remove($x);
        $em->flush();



        return new Response('');
    }
}
