<?php

namespace App\Controller;

use Gumlet\ImageResize;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Controller\BaseController;

class PanelCokVeriController extends BaseController
{

    /**
     * @Route("/rv/multi-content/{dilgrup}", name="cokveri_homepage")
     */
    public function index($dilgrup): Response
    {



        $em = $this->getDoctrine()->getManager();

        $qb = $em->createQueryBuilder();
        $sayfa=$qb->select('s.id,s.adi,m.alan,m.tip,m.bosluk,m.cokluDil,m.tabloAdi,s.dilgrup,s.kategori')
            ->from('App:Sayfa', 's')
            ->join('s.modul', 'm')
            ->where('s.id='.$dilgrup)
            ->getQuery()
            ->getScalarResult();



        $qb = $em->createQueryBuilder();
        $diller=$qb->select('d.id,d.kisa')
            ->from('App:Dil', 'd')
            ->where("d.aktif=1")
            ->orderBy('d.id')
            ->getQuery()
            ->getScalarResult();


        $qb = $em->createQueryBuilder();
        $kategoriler=$qb->select('k.id,k.dilgrup,k.adi')
            ->from('App:Kategori', 'k')
            ->join('k.sayfa','s')
            ->where('s.id='.$dilgrup.' and k.ustid=0')
            ->groupBy('k.dilgrup')
            ->orderBy('k.sira','ASC')
            ->getQuery()
            ->getScalarResult();


        return $this->render('panel/icerik/cokveri/index.html.twig',array('sayfa'=>$sayfa[0],'diller'=>$diller,'kategoriler'=>$kategoriler));

    }

    /**
     * @Route("/rv/multi-content/{dilgrup}/getir", name="cokveri_getir")
     */
    public function getir($dilgrup,Request $request): Response
    {
        $em = $this->getDoctrine()->getManager();




        $qb = $em->createQueryBuilder();
        $sayfa=$qb->select('s.id,m.alan,m.tip,m.tabloAdi,s.dilgrup,s.kategori,s.seo,s.icIcerik')
            ->from('App:Sayfa', 's')
            ->join('s.modul', 'm')
            ->where('s.id='.$dilgrup)
            ->getQuery()
            ->getScalarResult();

        $alanlar = explode(',',$sayfa[0]['alan']);
        $tipler = explode(',',$sayfa[0]['tip']);

        foreach ($alanlar as $key=>$alann) {
            $alan[] = 't.'.$this->seo(str_replace(' ', '', $alanlar[$key]));
        }


        $alan = implode(',',$alan);

        $sql = '';
        $kategori = '';
        if($sayfa[0]['kategori']==1) {
            $kategori = $request->request->get('kategori');
            if($kategori!=''){
                $sql.=' and k.id='.$kategori;
            }else{
                $sql = '';
            }
        }else{
            $sql = '';
        }


        $qb = $em->createQueryBuilder();
        $veriler=$qb->select($alan.',t.dilgrup,d.kisa as dKisa,k.adi as k_adi,k.dilgrup as k_dilgrup')
            ->from('App:'.$sayfa[0]['tabloAdi'], 't')
            ->leftjoin('t.kategori','k')
            ->join('t.sayfa','s')
            ->join('t.dil','d')
            ->where('s.id='.$dilgrup.$sql)
            ->orderBy('t.sira','ASC')
            ->groupBy('t.dilgrup')
            ->getQuery()
            ->getScalarResult();



        return $this->render('panel/icerik/cokveri/getir.html.twig',array('veriler'=>$veriler,'sayfa'=>$sayfa,'kategori'=>$kategori,'alanlar'=>$alanlar,'tipler'=>$tipler));
    }

    /**
     * @Route("/rv/multi-content/{dilgrup}/add", name="cokveri_ekle")
     */
    public function ekle($dilgrup): Response
    {



        $em = $this->getDoctrine()->getManager();

        $qb = $em->createQueryBuilder();
        $sayfa=$qb->select('s.id,s.adi,m.alan,m.tip,m.bosluk,m.cokluDil,m.tabloAdi,s.dilgrup,s.kategori,s.icIcerik')
            ->from('App:Sayfa', 's')
            ->join('s.modul', 'm')
            ->where('s.id='.$dilgrup)
            ->getQuery()
            ->getScalarResult();



        $qb = $em->createQueryBuilder();
        $diller=$qb->select('d.id,d.kisa')
            ->from('App:Dil', 'd')
            ->where("d.aktif=1")
            ->orderBy('d.id')
            ->getQuery()
            ->getScalarResult();


        $qb = $em->createQueryBuilder();
        $kategoriler=$qb->select('k.id,k.dilgrup,k.adi')
            ->from('App:Kategori', 'k')
            ->join('k.sayfa','s')
            ->where('s.id='.$dilgrup.' and k.ustid=0')
            ->groupBy('k.dilgrup')
            ->orderBy('k.sira','ASC')
            ->getQuery()
            ->getScalarResult();


        return $this->render('panel/icerik/cokveri/ekle.html.twig',array('sayfa'=>$sayfa[0],'diller'=>$diller,'kategoriler'=>$kategoriler));

    }

    /**
     * @Route("/rv/multi-content/{dilgrup}/add-save", name="cokveri_ekle_kaydet")
     */
    public function ekle_kaydet($dilgrup,Request $request): Response
    {
        $em = $this->getDoctrine()->getManager();

        $qb = $em->createQueryBuilder();
        $sayfa=$qb->select('s.id,s.adi,m.alan,m.tip,m.bosluk,m.cokluDil,s.dilgrup,m.adi as madi,m.tabloAdi,s.kategori,s.resimBoyut')
            ->from('App:Sayfa', 's')
            ->join('s.modul', 'm')
            ->where('s.id='.$dilgrup)
            ->getQuery()
            ->getScalarResult();

        if ($sayfa[0]['resimBoyut']!='') {
            $sResimBoyut = explode('x', $sayfa[0]['resimBoyut']);
        }

        $qb = $em->createQueryBuilder();
        $diller=$qb->select('d.id,d.kisa')
            ->from('App:Dil', 'd')
            ->where("d.aktif=1")
            ->orderBy('d.id')
            ->getQuery()
            ->getScalarResult();


        $alanlar = explode(',',$sayfa[0]['alan']);
        $tipler = explode(',',$sayfa[0]['tip']);
        $bosluklar = explode(',',$sayfa[0]['bosluk']);



        $dResim = [];
        $resim = '';
        $resimler = '';
        //resim yüklemeleri tamam!
        foreach ($tipler as $key=>$tip){
            if($this->seo($alanlar[$key])=='resim'){
                if($bosluklar[$key]=='false'){
                    $resim=$this->seo($sayfa[0]['adi']).'_'.time().'_'.rand(100000,999999);
                    move_uploaded_file($_FILES['rr_'.$this->seo($alanlar[$key])]['tmp_name'], "gecici_yukleme/".$resim.$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));

                    if ($sayfa[0]['resimBoyut']!='') {
                        $image = new ImageResize('gecici_yukleme/' .$resim.$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));
                        $image->resize($sResimBoyut[0], $sResimBoyut[1], $allow_enlarge = True);
                        $image->save('gecici_yukleme/' .$resim.$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));
                    }


                    $resim = $this->imageResizer($resim.$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']),$resim);
                    $this->uploadFile($resim);
                }else{
                    if (!empty($_FILES['rr_'.$this->seo($alanlar[$key])]['name'])) {
                        $resim=$this->seo($sayfa[0]['adi']).'_'.time().'_'.rand(100000,999999);
                        move_uploaded_file($_FILES['rr_'.$this->seo($alanlar[$key])]['tmp_name'], "gecici_yukleme/".$resim.$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));

                        if ($sayfa[0]['resimBoyut']!='') {
                            $image = new ImageResize('gecici_yukleme/' .$resim.$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));
                            $image->resize($sResimBoyut[0], $sResimBoyut[1], $allow_enlarge = True);
                            $image->save('gecici_yukleme/' .$resim.$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));
                        }


                        $resim = $this->imageResizer($resim.$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']),$resim);
                        $this->uploadFile($resim);
                    }
                }
            }
            elseif ($this->seo($alanlar[$key])=='resimler'){
                if (!empty($_FILES['rr_'.$this->seo($alanlar[$key])]['name'])) {
                    for ($i = 0; $i < count($_FILES['rr_' . $this->seo($alanlar[$key])]['name']); $i++) {
                        $x = $this->seo($sayfa[0]['adi']) . '_' . time() . '_' . rand(100000, 999999);
                        move_uploaded_file($_FILES['rr_' . $this->seo($alanlar[$key])]['tmp_name'][$i], "gecici_yukleme/" . $x . $this->uzantiBul($_FILES['rr_' . $this->seo($alanlar[$key])]['type'][$i]));

                        if ($sayfa[0]['resimBoyut']!='') {
                            $image = new ImageResize('gecici_yukleme/' .$x . $this->uzantiBul($_FILES['rr_' . $this->seo($alanlar[$key])]['type'][$i]));
                            $image->resize($sResimBoyut[0], $sResimBoyut[1], $allow_enlarge = True);
                            $image->save('gecici_yukleme/' .$x . $this->uzantiBul($_FILES['rr_' . $this->seo($alanlar[$key])]['type'][$i]));
                        }

                        $x = $this->imageResizer($x . $this->uzantiBul($_FILES['rr_' . $this->seo($alanlar[$key])]['type'][$i]), $x);
                        $this->uploadFile($x);

                        $resimler .= $x . ',';
                    }
                }
            }
            elseif(strpos($this->seo($alanlar[$key]),'resim')==true){
                if($bosluklar[$key]=='false'){
                    $dResim[$key]=$this->seo($sayfa[0]['adi']).'_'.time().'_'.rand(100000,999999);
                    move_uploaded_file($_FILES['rr_'.$this->seo($alanlar[$key])]['tmp_name'], "gecici_yukleme/".$dResim[$key].$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));

                    if ($sayfa[0]['resimBoyut']!='') {
                        $image = new ImageResize('gecici_yukleme/' .$dResim[$key].$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));
                        $image->resize($sResimBoyut[0], $sResimBoyut[1], $allow_enlarge = True);
                        $image->save('gecici_yukleme/' .$dResim[$key].$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));
                    }

                    $dResim[$key] = $this->imageResizer($dResim[$key].$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']),$dResim[$key]);
                    $this->uploadFile($dResim[$key]);
                }else{
                    if (!empty($_FILES['rr_'.$this->seo($alanlar[$key])]['name'])) {
                        $dResim[$key]=$this->seo($sayfa[0]['adi']).'_'.time().'_'.rand(100000,999999);
                        move_uploaded_file($_FILES['rr_'.$this->seo($alanlar[$key])]['tmp_name'], "gecici_yukleme/".$dResim[$key].$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));

                        if ($sayfa[0]['resimBoyut']!='') {
                            $image = new ImageResize('gecici_yukleme/' .$dResim[$key].$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));
                            $image->resize($sResimBoyut[0], $sResimBoyut[1], $allow_enlarge = True);
                            $image->save('gecici_yukleme/' .$dResim[$key].$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));
                        }

                        $dResim[$key] = $this->imageResizer($dResim[$key].$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']),$dResim[$key]);
                        $this->uploadFile($dResim[$key]);
                    }
                }
            }

        }

        if(empty($resim)){ $resim=null; } else{ $resim = str_replace('.belirsiz','.jpg',$resim); }
        if(empty($resimler)){ $resimler=null; } else{ $resimler = str_replace('.belirsiz','.jpg',$resimler); }

        foreach ($dResim as $keyy=>$dR){
            if(empty($dR)){ $dResim[$keyy]=null; } else{ $dResim[$keyy] = str_replace('.belirsiz','.jpg',$dR); }
        }






        if($sayfa[0]['kategori']==1) {
            $kategori = $request->request->get('kategori');
        }else{
            $kategori = 'NULL';
        }

        $s_dilgrup = $this->son_dilgrup($sayfa[0]['tabloAdi']);
        foreach ($diller as $key2=>$dil){

            $veri = [];
            $alan = [];
            foreach ($tipler as $key=>$tip){
                $alan[]=$this->seo(str_replace(' ','',$alanlar[$key]));
                $asilAlan=$this->seo(str_replace(' ','',$alanlar[$key]));

                if($this->seo($alanlar[$key])=='resim'){
                    if(empty($resim)){ $veri[]= 'NULL'; }
                    else{
                        $veri[]="'".$resim."'";
                    }

                }
                elseif ($this->seo($alanlar[$key])=='resimler'){
                    if(empty($resimler)){ $veri[]= 'NULL'; }
                    else{
                        $veri[]="'".$resimler."'";

                    }

                }
                elseif(strpos($this->seo($alanlar[$key]),'resim')==true){
                    if(empty($dResim[$key])){ $veri[]= 'NULL'; }
                    else{
                        $veri[]="'".$dResim[$key]."'";
                    }

                }
                elseif ($this->seo($alanlar[$key])=='seo-url'){
                    $veri[]="'".$this->seo($request->request->get($this->seo($alanlar[$key]))[$key2],$dil['id'])."'";

                }
                elseif ($tip=='datetime'){
                    $v = $request->request->get($this->seo($alanlar[$key]))[$key2];
                    if(empty($v)){
                        $veri[]= 'NULL';

                    }else {
                        $suan = new \DateTime('now');
                        $v = explode('/', $v);
                        $v = $v[2] . '-' . $v[1] . '-' . $v[0] . ' ' . $suan->format('H:i:s');
                        $veri[]="'".$v."'";
                    }
                }else{
                    $v = $request->request->get($this->seo($alanlar[$key]))[$key2];
                    $v = htmlentities($v, ENT_QUOTES, "UTF-8");
                    if(empty($v)){
                        $veri[]= 'NULL';

                    }else{
                        $veri[]="'".$v."'";

                    }

                }
            }
            $veri = implode(',',$veri);
            $alan = implode(',',$alan);



            $RAW_QUERY = "INSERT INTO ".$this->seo(str_replace(' ','',$sayfa[0]['madi']))."(dil_id,dilgrup,sayfa_id,kategori_id,".$alan.") VALUES(".$dil['id'].",$s_dilgrup,$dilgrup,$kategori,$veri)";
            $statement = $em->getConnection()->prepare($RAW_QUERY);
            $statement->execute();





        }



        return new Response('');
    }

    /**
     * @Route("/rv/multi-content/{dilgrup}/edit/{vDilgrup}", name="cokveri_duzenle")
     */
    public function duzenle($dilgrup,$vDilgrup): Response
    {



        $em = $this->getDoctrine()->getManager();

        $dilgrupBul = $this->dilgrupBul('Sayfa',$dilgrup);

        $qb = $em->createQueryBuilder();
        $sayfa=$qb->select('s.id,s.adi,m.alan,m.tip,m.bosluk,m.cokluDil,m.tabloAdi,s.dilgrup,s.kategori,s.seo,s.icIcerik,s.title,s.description')
            ->from('App:Sayfa', 's')
            ->join('s.modul', 'm')
            ->where('s.dilgrup='.$dilgrupBul)
            ->orderBy('s.dil')
            ->getQuery()
            ->getScalarResult();

        $alanlar = explode(',',$sayfa[0]['alan']);
        $tipler = explode(',',$sayfa[0]['tip']);
        $bosluklar = explode(',',$sayfa[0]['bosluk']);



        $qb = $em->createQueryBuilder();
        $diller=$qb->select('d.id,d.kisa')
            ->from('App:Dil', 'd')
            ->where("d.aktif=1")
            ->orderBy('d.id')
            ->getQuery()
            ->getScalarResult();

        foreach ($tipler as $key=>$tip) {
            $alan[] = 't.'.$this->seo(str_replace(' ', '', $alanlar[$key]));
        }
        $alan = implode(',',$alan);

        $qb = $em->createQueryBuilder();
        $veriler=$qb->select($alan.',t.dilgrup,k.id as k_id')
            ->from('App:'.$sayfa[0]['tabloAdi'], 't')
            ->leftjoin('t.kategori','k')
            ->where('t.dilgrup='.$vDilgrup)
            ->orderBy('t.dil')
            ->getQuery()
            ->getScalarResult();


        $qb = $em->createQueryBuilder();
        $kategoriler=$qb->select('k.id,k.dilgrup,k.adi')
            ->from('App:Kategori', 'k')
            ->join('k.sayfa','s')
            ->where('s.id='.$dilgrup.' and k.ustid=0')
            ->groupBy('k.dilgrup')
            ->orderBy('k.sira','ASC')
            ->getQuery()
            ->getScalarResult();

        return $this->render('panel/icerik/cokveri/duzenle.html.twig',array('sayfa'=>$sayfa,'diller'=>$diller,'veriler'=>$veriler,'kategoriler'=>$kategoriler,'alanlar'=>$alanlar));

    }

    /**
     * @Route("/rv/multi-content/{dilgrup}/edit/{vDilgrup}/save", name="cokveri_duzenle_kaydet")
     */
    public function duzenle_kaydet($dilgrup,$vDilgrup,Request $request): Response
    {
        $em = $this->getDoctrine()->getManager();

        $qb = $em->createQueryBuilder();
        $sayfa=$qb->select('s.id,s.adi,m.alan,m.tip,m.bosluk,m.cokluDil,s.dilgrup,m.adi as madi,m.tabloAdi,s.kategori,s.resimBoyut')
            ->from('App:Sayfa', 's')
            ->join('s.modul', 'm')
            ->where('s.id='.$dilgrup)
            ->getQuery()
            ->getScalarResult();

        if ($sayfa[0]['resimBoyut']!='') {
            $sResimBoyut = explode('x', $sayfa[0]['resimBoyut']);
        }

        $qb = $em->createQueryBuilder();
        $diller=$qb->select('d.id,d.kisa')
            ->from('App:Dil', 'd')
            ->where("d.aktif=1")
            ->orderBy('d.id')
            ->getQuery()
            ->getScalarResult();


        $alanlar = explode(',',$sayfa[0]['alan']);
        $tipler = explode(',',$sayfa[0]['tip']);
        $bosluklar = explode(',',$sayfa[0]['bosluk']);



        $resimVar = 0;
        $dResim = [];
        $dResimVar = [];
        $resim = '';
        $resimler = '';
        //resim yüklemeleri tamam!
        foreach ($tipler as $key=>$tip){
            if($this->seo($alanlar[$key])=='resim'){
                if (!empty($_FILES['rr_'.$this->seo($alanlar[$key])]['name'])) {
                    $resim=$this->seo($sayfa[0]['adi']).'_'.time().'_'.rand(100000,999999);
                    move_uploaded_file($_FILES['rr_'.$this->seo($alanlar[$key])]['tmp_name'], "gecici_yukleme/".$resim.$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));

                    if ($sayfa[0]['resimBoyut']!='') {
                        $image = new ImageResize('gecici_yukleme/' . $resim . $this->uzantiBul($_FILES['rr_' . $this->seo($alanlar[$key])]['type']));
                        $image->resize($sResimBoyut[0], $sResimBoyut[1], $allow_enlarge = True);
                        $image->save('gecici_yukleme/' . $resim . $this->uzantiBul($_FILES['rr_' . $this->seo($alanlar[$key])]['type']));
                    }


                    $resim = $this->imageResizer($resim.$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']),$resim);
                    $this->uploadFile($resim);
                    $resimVar=1;
                }
            }
            elseif ($this->seo($alanlar[$key])=='resimler'){
                if (!empty($_FILES['rr_'.$this->seo($alanlar[$key])]['name'])) {
                    for ($i = 0; $i < count($_FILES['rr_' . $this->seo($alanlar[$key])]['name']); $i++) {
                        $x = $this->seo($sayfa[0]['adi']) . '_' . time() . '_' . rand(100000, 999999);
                        move_uploaded_file($_FILES['rr_' . $this->seo($alanlar[$key])]['tmp_name'][$i], "gecici_yukleme/" . $x . $this->uzantiBul($_FILES['rr_' . $this->seo($alanlar[$key])]['type'][$i]));

                        if ($sayfa[0]['resimBoyut']!='') {
                            $image = new ImageResize('gecici_yukleme/' . $x . $this->uzantiBul($_FILES['rr_' . $this->seo($alanlar[$key])]['type'][$i]));
                            $image->resize($sResimBoyut[0], $sResimBoyut[1], $allow_enlarge = True);
                            $image->save('gecici_yukleme/' . $x . $this->uzantiBul($_FILES['rr_' . $this->seo($alanlar[$key])]['type'][$i]));
                        }

                        $x = $this->imageResizer($x . $this->uzantiBul($_FILES['rr_' . $this->seo($alanlar[$key])]['type'][$i]), $x);
                        $this->uploadFile($x);
                        $resimler .= $x . ',';
                    }
                }
            }
            elseif(strpos($this->seo($alanlar[$key]),'resim')==true){
                if (!empty($_FILES['rr_'.$this->seo($alanlar[$key])]['name'])) {
                    $dResim[$key]=$this->seo($sayfa[0]['adi']).'_'.time().'_'.rand(100000,999999);
                    move_uploaded_file($_FILES['rr_'.$this->seo($alanlar[$key])]['tmp_name'], "gecici_yukleme/".$dResim[$key].$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));

                    if ($sayfa[0]['resimBoyut']!='') {
                        $image = new ImageResize('gecici_yukleme/' .$dResim[$key].$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));
                        $image->resize($sResimBoyut[0], $sResimBoyut[1], $allow_enlarge = True);
                        $image->save('gecici_yukleme/' . $dResim[$key].$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));
                    }

                    $dResim[$key] = $this->imageResizer($dResim[$key].$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']),$dResim[$key]);
                    $this->uploadFile($dResim[$key]);
                    $dResimVar[$key]=1;
                }else{
                    $dResimVar[$key]=0;
                }
            }
        }

        if(empty($resim)){ $resim=null; } else{ $resim = str_replace('.belirsiz','.jpg',$resim); }
        if(empty($resimler)){ $resimler=null; } else{ $resimler = str_replace('.belirsiz','.jpg',$resimler); }

        foreach ($dResim as $keyy=>$dR){
            if(empty($dR)){ $dResim[$keyy]=null; } else{ $dResim[$keyy] = str_replace('.belirsiz','.jpg',$dR); }
        }





        $sAlanlar = '';
        foreach ($alanlar as $a){
            $sAlanlar.=',t.'.$this->seo(str_replace(' ','',$a));
        }

        if($resimVar==1){
            $qb = $em->createQueryBuilder();
            $bulunanVeri=$qb->select('t.id'.$sAlanlar)
                ->from('App:'.$sayfa[0]['tabloAdi'], 't')
                ->join('t.sayfa','s')
                ->where('s.id='.$dilgrup.' and t.dilgrup='.$vDilgrup)
                ->orderBy('t.dil')
                ->getQuery()
                ->getScalarResult();

            if(strstr($bulunanVeri[0]['resim'], ',')) {
                $resimlerim = explode(',', $bulunanVeri[0]['resim']);
                foreach ($resimlerim as $r) {
                    if ($r != '') {
                        //@unlink('uploads/' . $r);
                        $this->deleteFile($r);
                    }
                }
            }else{
                //@unlink('uploads/' . $bulunanVeri[0]['resim']);
                $this->deleteFile($bulunanVeri[0]['resim']);
            }
        } else {
            $qb = $em->createQueryBuilder();
            $bulunanVeri=$qb->select('t.id'.$sAlanlar)
                ->from('App:'.$sayfa[0]['tabloAdi'], 't')
                ->join('t.sayfa','s')
                ->where('s.id='.$dilgrup.' and t.dilgrup='.$vDilgrup)
                ->orderBy('t.dil')
                ->getQuery()
                ->getScalarResult();
        }





        if($sayfa[0]['kategori']==1) {
            $kategori = $request->request->get('kategori');
        }else{
            $kategori = null;
        }

        foreach ($diller as $key2=>$dil){
            if(count($bulunanVeri)>0) {
                $qb = $em->createQueryBuilder();
                $guncelVeri = $qb->update('App:'.$sayfa[0]['tabloAdi'], 't');

                $guncelVeri->set('t.kategori', ':kategori');
                $guncelVeri->setParameter('kategori', $kategori);
            }



            foreach ($tipler as $key=>$tip){

                $asilAlan=$this->seo(str_replace(' ','',$alanlar[$key]));

                if($this->seo($alanlar[$key])=='resim'){
                    if(!empty($resim)){
                        if(count($bulunanVeri)>0) {
                            $guncelVeri->set('t.' . $asilAlan, ':' . $asilAlan);
                            $guncelVeri->setParameter($asilAlan, $resim);
                        }
                    }

                }
                elseif ($this->seo($alanlar[$key])=='resimler'){
                    if(!empty($resimler)){
                        if(count($bulunanVeri)>0) {
                            $guncelVeri->set('t.' . $asilAlan, ':' . $asilAlan);
                            $guncelVeri->setParameter($asilAlan, $bulunanVeri[0]['resimler'].$resimler);
                        }
                    }

                }
                elseif(strpos($this->seo($alanlar[$key]),'resim')==true){
                    if($dResimVar[$key]==1) {
                        //@unlink('uploads/' . $bulunanVeri[0][$asilAlan]);
                        $this->deleteFile($bulunanVeri[0][$asilAlan]);
                    }
                    if(!empty($dResim[$key])){
                        if(count($bulunanVeri)>0) {
                            $guncelVeri->set('t.' . $asilAlan, ':' . $asilAlan);
                            $guncelVeri->setParameter($asilAlan, $dResim[$key]);
                        }
                    }
                }
                elseif ($this->seo($alanlar[$key])=='seo-url'){
                    if(count($bulunanVeri)>0) {
                        $guncelVeri->set('t.' . $asilAlan, ':' . $asilAlan);
                        $guncelVeri->setParameter($asilAlan, $this->seo($request->request->get($this->seo($alanlar[$key]))[$key2],$dil['id']));
                    }
                }
                elseif ($tip=='datetime'){
                    $v = $request->request->get($this->seo($alanlar[$key]))[$key2];
                    if(empty($v)){
                        if(count($bulunanVeri)>0) {
                            $guncelVeri->set('t.' . $asilAlan, ':' . $asilAlan);
                            $guncelVeri->setParameter($asilAlan, null);
                        }
                    }else {
                        $suan = new \DateTime('now');
                        $v = explode('/', $v);
                        $v = new \DateTime($v[2] . '-' . $v[1] . '-' . $v[0] . ' ' . $suan->format('H:i:s'));

                        if(count($bulunanVeri)>0) {
                            $guncelVeri->set('t.' . $asilAlan, ':' . $asilAlan);
                            $guncelVeri->setParameter($asilAlan, $v);
                        }
                    }
                }
                else{
                    $v = $request->request->get($this->seo($alanlar[$key]))[$key2];
                    if(empty($v)){
                        if(count($bulunanVeri)>0) {
                            $guncelVeri->set('t.' . $asilAlan, ':' . $asilAlan);
                            $guncelVeri->setParameter($asilAlan, null);
                        }
                    }else{
                        if(count($bulunanVeri)>0) {
                            $guncelVeri->set('t.' . $asilAlan, ':' . $asilAlan);
                            $guncelVeri->setParameter($asilAlan, $v);
                        }
                    }

                }
            }




            $guncelVeri->where("t.id = ".$bulunanVeri[$key2]['id'])
                ->getQuery()
                ->execute();





        }



        return new Response('');
    }

    /**
     * @Route("/rv/multi-content/{dilgrup}/delete", name="cokveri_sil")
     */
    public function sil($dilgrup,Request $request): Response
    {
        $em = $this->getDoctrine()->getManager();

        $dilgrupp = $request->request->get('dilgrup');

        $em = $this->getDoctrine()->getManager();

        $qb = $em->createQueryBuilder();
        $sayfa=$qb->select('m.tabloAdi,m.alan')
            ->from('App:Sayfa', 's')
            ->join('s.modul', 'm')
            ->where('s.id='.$dilgrup)
            ->getQuery()
            ->getScalarResult();

        $alanlar = explode(',',$sayfa[0]['alan']);

        $r='';
        $aa=[];
        foreach ($alanlar as $a){
            if($a =='resim'){
                $r.='k.resim,';
                $aa[]='resim';
            }
            elseif($a =='resimler'){
                $r.='k.resimler,';
                $aa[]='resimler';
            }
            elseif(strpos($a,'resim')==true){
                $r.='k.'.$this->seo(str_replace(' ','',$a)).',';
                $aa[]=$this->seo(str_replace(' ','',$a));
            }
        }


        $qb = $em->createQueryBuilder();
        $icerik=$qb->select($r.'k.id')
            ->from('App:'.$sayfa[0]['tabloAdi'], 'k')
            ->where('k.dilgrup='.$dilgrupp)
            ->orderBy('k.sira','ASC')
            ->getQuery()
            ->getScalarResult();


        foreach ($aa as $aR){
            if($aR=='resim'){
                if(!empty($icerik[0]['resim'])) {
                    //@unlink('uploads/' . $icerik[0]['resim']);
                    $this->deleteFile($icerik[0]['resim']);
                }
            }
            elseif($aR=='resimler'){
                if(!empty($icerik[0]['resimler'])) {
                    $resimler = explode(',', $icerik[0]['resimler']);
                    foreach ($resimler as $rr) {
                        if ($rr!=''){
                            //@unlink('uploads/' . $rr);
                            $this->deleteFile($rr);
                        }
                    }
                }
            }
            elseif(strpos($aR,'resim')==true){
                if(!empty($icerik[0][$aR])) {
                    //@unlink('uploads/' . $icerik[0][$aR]);
                    $this->deleteFile($icerik[0][$aR]);
                }
            }
        }

        $qb=$em->createQueryBuilder();
        $qb->delete('App:'.$sayfa[0]['tabloAdi'], 'b')
            ->where('b.dilgrup='.$dilgrupp)
            ->getQuery()
            ->execute();


        $em->flush();



        return new Response('');
    }

    /**
     * @Route("/rv/multi-content/{dilgrup}/sort", name="cokveri_sirala")
     */
    public function sirala($dilgrup, Request $request): Response
    {
        $em = $this->getDoctrine()->getManager();
        $listItem = $request->request->get('listItem');

        $qb = $em->createQueryBuilder();
        $sayfa=$qb->select('m.tabloAdi')
            ->from('App:Sayfa', 's')
            ->join('s.modul', 'm')
            ->where('s.id='.$dilgrup)
            ->getQuery()
            ->getScalarResult();

        foreach ($listItem as $sira=>$id){
            $qb = $em->createQueryBuilder();
            $q = $qb->update('App:'.$sayfa[0]['tabloAdi'], 's')
                ->set('s.sira', ':sira')
                ->where("s.dilgrup=$id")
                ->setParameter('sira', $sira)
                ->getQuery()
                ->execute();
        }

        return new Response('');
    }

    /**
     * @Route("/rv/multi-content/{dilgrup}/image-delete", name="cokveri_gorsel_sil")
     */
    public function gorsel_sil($dilgrup, Request $request): Response
    {
        $em = $this->getDoctrine()->getManager();
        $vDilgrup = $request->request->get('dilgrup');
        $adi = $request->request->get('adi');

        $qb = $em->createQueryBuilder();
        $sayfa=$qb->select('m.tabloAdi')
            ->from('App:Sayfa', 's')
            ->join('s.modul', 'm')
            ->where('s.id='.$dilgrup)
            ->getQuery()
            ->getScalarResult();

        $qb = $em->createQueryBuilder();
        $veri=$qb->select('v.id,v.resimler')
            ->from('App:'.$sayfa[0]['tabloAdi'], 'v')
            ->join('v.sayfa','s')
            ->where('s.id='.$dilgrup.' and v.dilgrup='.$vDilgrup)
            ->getQuery()
            ->getScalarResult();
        $yeni_resimler='';
        $resimler = explode(',',$veri[0]['resimler']);
        foreach ($resimler as $resim){
            if(!empty($resim)) {
                if ($adi != $resim) {
                    $yeni_resimler .= $resim . ',';
                }
            }
        }
       //@unlink('uploads/'.$adi);
        $this->deleteFile($adi);

        $qb = $em->createQueryBuilder();
        $q = $qb->update('App:'.$sayfa[0]['tabloAdi'], 's')
            ->set('s.resimler', ':resimler')
            ->where("s.dilgrup=$vDilgrup")
            ->setParameter('resimler', $yeni_resimler)
            ->getQuery()
            ->execute();

        return new Response('');


    }

    /**
     * @Route("/rv/multi-content/{dilgrup}/image-sort", name="cokveri_gorsel_sirala")
     */
    public function gorsel_sirala($dilgrup, Request $request): Response
    {
        $em = $this->getDoctrine()->getManager();
        $vDilgrup = $request->request->get('dilgrup');
        $resimler = $request->request->get('resimler');

        $qb = $em->createQueryBuilder();
        $sayfa=$qb->select('m.tabloAdi')
            ->from('App:Sayfa', 's')
            ->join('s.modul', 'm')
            ->where('s.id='.$dilgrup)
            ->getQuery()
            ->getScalarResult();


        $qb = $em->createQueryBuilder();
        $q = $qb->update('App:'.$sayfa[0]['tabloAdi'], 's')
            ->set('s.resimler', ':resimler')
            ->where("s.dilgrup=$vDilgrup")
            ->setParameter('resimler', $resimler)
            ->getQuery()
            ->execute();


        return new Response('');
    }

    /**
     * @Route("/rv/multi-content/{dilgrup}/temizle", name="cokveri_temizle")
     */
    public function temizle($dilgrup): Response
    {

        $em = $this->getDoctrine()->getManager();

        $qb = $em->createQueryBuilder();
        $sayfa=$qb->select('m.tabloAdi,m.alan')
            ->from('App:Sayfa', 's')
            ->join('s.modul', 'm')
            ->where('s.id='.$dilgrup)
            ->getQuery()
            ->getScalarResult();

        $alanlar = explode(',',$sayfa[0]['alan']);

        $r='';
        foreach ($alanlar as $a){
            if($a =='resim'){
                $r.='k.resim,';
            }
            if($a =='resimler'){
                $r.='k.resimler,';
            }
        }


        $qb = $em->createQueryBuilder();
        $icerikler=$qb->select($r.'k.id')
            ->from('App:'.$sayfa[0]['tabloAdi'], 'k')
            ->join('k.sayfa','s')
            ->where('s.id='.$dilgrup)
            ->orderBy('k.sira','ASC')
            ->getQuery()
            ->getScalarResult();

        foreach ($icerikler as $icerik){
            if($r=='k.resim,'){
                if(!empty($icerik['resim'])) {
                    //@unlink('uploads/' . $icerik['resim']);
                    $this->deleteFile($icerik['resim']);
                }
            }
            if($r=='k.resimler,'){
                if(!empty($icerik['resimler'])) {
                    $resimler = explode(',', $icerik['resimler']);
                    foreach ($resimler as $rr) {
                        if ($rr!=''){
                            //@unlink('uploads/' . $rr);
                            $this->deleteFile($rr);
                        }
                    }
                }
            }
        }

        $qb=$em->createQueryBuilder();
        $qb->delete('App:'.$sayfa[0]['tabloAdi'], 'b')
            ->where('b.sayfa='.$dilgrup)
            ->getQuery()
            ->execute();

        $em->flush();



        return new Response('');
    }
}
