<?php

namespace App\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Controller\BaseController;
use App\Entity\Form;

class PanelFormController extends BaseController
{
    /**
     * @Route("/rv/form", name="form_homepage")
     */
    public function index(): Response
    {
        return $this->render('panel/form/index.html.twig');
    }

    /**
     * @Route("/rv/form/getir", name="form_getir")
     */
    public function getir(): Response
    {
        $em = $this->getDoctrine()->getManager();

        $qb = $em->createQueryBuilder();
        $formlar=$qb->select('f.id,f.adi,f.eposta,f.alan,f.tip,f.veri,f.zorunlu')
            ->from('App:Form', 'f')
            ->getQuery()
            ->getScalarResult();

        return $this->render('panel/form/getir.html.twig',array('formlar'=>$formlar));

    }

    /**
     * @Route("/rv/form/ekle", name="form_ekle")
     */
    public function ekle(Request $request): Response
    {
        $em = $this->getDoctrine()->getManager();

        $formadi = $request->request->get('formadi');
        $eposta = $request->request->get('eposta');
        $alan = $request->request->get('alan'); $alan = implode("~", $alan);
        $tip = $request->request->get('tip'); $tip = implode("~", $tip);
        $veri = $request->request->get('veri'); $veri = implode("~", $veri);
        $zorunlu = $request->request->get('zorunlu'); $zorunlu = implode("~", $zorunlu);


        $form = new Form();
        $form->setAdi($formadi);
        $form->setAlan($alan);
        $form->setTip($tip);
        $form->setVeri($veri);
        $form->setEposta($eposta);
        $form->setZorunlu($zorunlu);
        $em->persist($form);
        $em->flush();



        return new Response('');
    }

    /**
     * @Route("/rv/form/sil", name="form_sil")
     */
    public function sil(Request $request): Response{
        $em = $this->getDoctrine()->getManager();

        $id = $request->request->get('id');

       $x = $em->getRepository(Form::class)->findOneBy(array('id'=>$id));
        $em->remove($x);
        $em->flush();

        return new Response('');
    }
}
