<?php

namespace App\Controller;

use App\Entity\User;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Controller\BaseController;
use Symfony\Component\Security\Core\Encoder\UserPasswordEncoderInterface;


class PanelKullaniciController extends BaseController
{

    /**
     * @Route("/rv/kullanici", name="kullanici_homepage")
     */
    public function index(): Response
    {
        return $this->render('panel/kullanici/index.html.twig');
    }

    /**
     * @Route("/rv/kullanici/kaydet", name="kullanici_kaydet")
     */
    public function kaydet(Request $request, UserPasswordEncoderInterface $passwordEncoder): Response
    {
        $em = $this->getDoctrine()->getManager();


        $eposta = $request->request->get('eposta');
        $sifre = $request->request->get('sifre');
        $adsoyad = $request->request->get('adsoyad'); if(empty($adsoyad)){$adsoyad=null;}
        $unvan = $request->request->get('unvan'); if(empty($unvan)){$unvan=null;}

        $qb=$em->createQueryBuilder();
        $kullaniciTara=$qb->select('k.id')
            ->from('App:User', 'k')
            ->where("(k.email='".$eposta."') and k.id not in(".$this->getUser()->getId().")")
            ->getQuery()
            ->getScalarResult();

        if(count($kullaniciTara)>0){
            return new Response('E-Posta adresi başkası tarafından kullanılıyor.');
        }else{


            $user = $em->getRepository(User::class)->findOneBy(array('id' => $this->getUser()->getId()));

            $user->setAdsoyad($adsoyad);
            $user->setUnvan($unvan);
            $user->setEmail($eposta);
            if (!empty($sifre)) {
                $user->setPassword($passwordEncoder->encodePassword($user, $sifre));
            }
            $em->persist($user);
            $em->flush();
        }


        return new Response('');
    }
}
