<?php

namespace App\Controller;

use App\Entity\FormKayit;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Controller\BaseController;

class PanelMesajlarController extends BaseController
{
    /**
     * @Route("/rv/mesajlar", name="mesajlar_homepage")
     */
    public function index(): Response
    {

        $em = $this->getDoctrine()->getManager();

        $qb = $em->createQueryBuilder();
        $formlar=$qb->select('f.adi,f.id')
            ->from('App:Form', 'f')
            ->getQuery()
            ->getScalarResult();
        return $this->render('panel/mesajlar/index.html.twig',array('formlar'=>$formlar));
    }

    /**
     * @Route("/rv/mesajlar/getir", name="mesajlar_getir")
     */
    public function getir(Request $request): Response{
        $em = $this->getDoctrine()->getManager();

        $sql = "";
        $form = $request->request->get('form');
        if(!empty($form)){
            $sql='and f.id='.$form;
        }

        $qb = $em->createQueryBuilder();
        $mesajlar=$qb->select("m.kayit,f.alan,f.adi,m.okuma,m.tarih,m.id,f.tip")
            ->from('App:FormKayit', 'm')
            ->join('m.form','f')
            ->where("f.alan is not null $sql")
            ->orderBy('f.tarih','DESC')
            ->orderBy('m.okuma','ASC')
            ->getQuery()
            ->getScalarResult();

        return $this->render('panel/mesajlar/getir.html.twig',array('mesajlar'=>$mesajlar));

    }

    /**
     * @Route("/rv/mesajlar/oku", name="mesajlar_oku")
     */
    public function oku(Request $request): Response
    {
        $em = $this->getDoctrine()->getManager();

        $id = $request->request->get('id');


        $qb = $em->createQueryBuilder();
        $fKayit=$qb->select("m.id")
            ->from('App:FormKayit', 'm')
            ->join('m.form','f')
            ->where("m.id = $id")
            ->getQuery()
            ->getScalarResult();

        if (count($fKayit)>0) {
            $qb = $em->createQueryBuilder();
            $q = $qb->update('App:FormKayit', 'm')
                ->set('m.okuma', ':okuma')
                ->where("m.id=$id")
                ->setParameter('okuma', 1)
                ->getQuery()
                ->execute();
        }

        return new Response('');
    }

    /**
     * @Route("/rv/mesajlar/sil", name="mesajlar_sil")
     */
    public function sil(Request $request): Response{
        $em = $this->getDoctrine()->getManager();

        $id = $request->request->get('id');

        $qb = $em->createQueryBuilder();
        $fKayit=$qb->select("m.id")
            ->from('App:FormKayit', 'm')
            ->join('m.form','f')
            ->where("m.id = $id")
            ->getQuery()
            ->getScalarResult();
        if (count($fKayit)>0) {
            $x = $em->getRepository(FormKayit::class)->find($id);
            $em->remove($x);
            $em->flush();
        }


        return new Response('');
    }
}
