<?php

namespace App\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Controller\BaseController;
use App\Entity\Modul;

class PanelModulController extends BaseController
{
    /**
     * @Route("/rv/modul", name="modul_homepage")
     */
    public function index(): Response
    {
        return $this->render('panel/modul/index.html.twig');
    }

    /**
     * @Route("/rv/modul/getir", name="modul_getir")
     */
    public function getir(): Response{
        $em = $this->getDoctrine()->getManager();

        $qb = $em->createQueryBuilder();
        $moduller=$qb->select('m.adi,m.tabloAdi,m.alan,m.tip,m.bosluk,m.cokluDil,m.id')
            ->from('App:Modul', 'm')
            ->getQuery()
            ->getScalarResult();

        return $this->render('panel/modul/getir.html.twig',array('moduller'=>$moduller));

    }

    /**
     * @Route("/rv/modul/ekle", name="modul_ekle")
     */
    public function ekle(Request $request): Response
    {
        $em = $this->getDoctrine()->getManager();

        $adi = $request->request->get('adi');
        $alann = $request->request->get('alan'); $alan = explode(',',$alann);
        $tipp = $request->request->get('tip'); $tip = explode(',',$tipp);
        $boss = $request->request->get('bos'); $bos = explode(',',$boss);
        $cokdil = $request->request->get('cokdil');

        $veri = '';
        $veri2 = '';
        $entity = $this->seo(str_replace(' ','',$adi));
        $dosya = fopen($_SERVER['DOCUMENT_ROOT'].'/src/Entity/'.ucfirst($entity).'.php', 'w');
        $veri .='<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity
 */
class '.ucfirst($entity).'
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;
';

        $veri2 .='
    
    public function getId(): ?int
    {
        return $this->id;
    }
    ';


        foreach ($alan as $key=>$a) {
            if($a!=''){
                $a = $this->seo(str_replace(' ','',$a));
                if($bos[$key]=='true'){ $null = ', nullable=true'; $null2='?'; $null3=' = null'; } else { $null =''; $null2 =''; $null3 =''; }
                if($tip[$key]=='string'){
                    $veri.='
    /**
     * @ORM\Column(type="string", length=255'.$null.')
     */
    private $'.$a.';
    ';

                    $veri2 .='
    public function get'.ucfirst($a).'(): ?string
    {
        return $this->'.$a.';
    }

    public function set'.ucfirst($a).'('.$null2.'string $'.$a.'): self
    {
        $this->'.$a.' = $'.$a.';

        return $this;
    }';

                }
                if($tip[$key]=='integer'){
                    $veri.='
    /**
     * @ORM\Column(type="integer"'.$null.')
     */
    private $'.$a.';
    ';

                    $veri2 .='
    public function get'.ucfirst($a).'(): ?int
    {
        return $this->'.$a.';
    }

    public function set'.ucfirst($a).'('.$null2.'int $'.$a.'): self
    {
        $this->'.$a.' = $'.$a.';

        return $this;
    }';

                }
                if($tip[$key]=='text'){
                    $veri.='
    /**
     * @ORM\Column(type="text"'.$null.')
     */
    private $'.$a.';
    ';

                    $veri2 .='
    public function get'.ucfirst($a).'(): ?string
    {
        return $this->'.$a.';
    }

    public function set'.ucfirst($a).'('.$null2.'string $'.$a.'): self
    {
        $this->'.$a.' = $'.$a.';

        return $this;
    }';

                }
                if($tip[$key]=='float'){
                    $veri.='
    /**
     * @ORM\Column(type="float"'.$null.')
     */
    private $'.$a.';
    ';

                    $veri2 .='
    public function get'.ucfirst($a).'(): ?float
    {
        return $this->'.$a.';
    }

    public function set'.ucfirst($a).'('.$null2.'float $'.$a.'): self
    {
        $this->'.$a.' = $'.$a.';

        return $this;
    }';

                }
                if($tip[$key]=='datetime'){
                    $veri.='
    /**
     * @ORM\Column(type="datetime"'.$null.')
     */
    private $'.$a.';
    ';

                    $veri2 .='
    public function get'.ucfirst($a).'(): ?\DateTimeInterface
    {
        return $this->'.$a.';
    }

    public function set'.ucfirst($a).'('.$null2.'\DateTimeInterface $'.$a.'): self
    {
        $this->'.$a.' = $'.$a.';

        return $this;
    }';

                }
            }
        }



        if($cokdil==1){

            $veri.='
    /**
     * @ORM\Column(type="integer")
     */
    private $dilgrup;

    /**
     * @ORM\ManyToOne(targetEntity=Dil::class, inversedBy="'.$entity.'")
     * @ORM\JoinColumn(nullable=false)
     */
    private $dil;';

            $veri2 .='
    public function getDilgrup(): ?int
    {
        return $this->dilgrup;
    }

    public function setDilgrup(int $dilgrup): self
    {
        $this->dilgrup = $dilgrup;

        return $this;
    }

    public function getDil(): ?Dil
    {
        return $this->dil;
    }

    public function setDil(?Dil $dil): self
    {
        $this->dil = $dil;

        return $this;
    }';

        }





            $veri.='
    /**
     * @ORM\ManyToOne(targetEntity=Sayfa::class, inversedBy="'.$entity.'")
     * @ORM\JoinColumn(nullable=false)
     */
    private $sayfa;
    
    /**
     * @ORM\ManyToOne(targetEntity=Kategori::class, inversedBy="'.$entity.'")
     * @ORM\JoinColumn(nullable=true)
     */
    private $kategori;';

            $veri2 .='
    public function getSayfa(): ?Sayfa
    {
        return $this->sayfa;
    }

    public function setSayfa(?Sayfa $sayfa): self
    {
        $this->sayfa = $sayfa;

        return $this;
    }
    
    public function getKategori(): ?Kategori
    {
        return $this->kategori;
    }

    public function setKategori(?Kategori $kategori): self
    {
        $this->kategori = $kategori;

        return $this;
    }';






        $veri.='
    /**
     * @ORM\Column(type="integer", nullable=true)
     */
    private $sira;';

        $veri2 .='
    public function getSira(): ?int
    {
        return $this->sira;
    }

    public function setSira(?int $sira): self
    {
        $this->sira = $sira;

        return $this;
    }';



        $veri2 .='
}';

        fwrite($dosya, $veri.$veri2);
        fclose($dosya);


        if($cokdil==1) {

            $dosya2 = fopen($_SERVER['DOCUMENT_ROOT'] . '/src/Entity/Dil.php', 'r');
            $icerik = fread($dosya2, filesize($_SERVER['DOCUMENT_ROOT'] . '/src/Entity/Dil.php'));


            $icerikParcasi = explode('

    public function __construct()
    {
        ',$icerik);
            $bolum = '

    public function __construct()
    {
        ';

            $icerikParcasi[0].='

    /**
     * @ORM\OneToMany(targetEntity='.ucfirst($entity).'::class, mappedBy="dil", orphanRemoval=true)
     */
    private $'.$entity.';';

            $araparca2='$this->'.$entity.' = new ArrayCollection();
        ';

            $guncelVeri = $icerikParcasi[0].$bolum.$araparca2.$icerikParcasi[1];


            $icerikParcasi = explode('

    public function getId(): ?int
    {
        return $this->id;
    }',$guncelVeri);
            $bolum = '

    public function getId(): ?int
    {
        return $this->id;
    }';


            $araparca='

    /**
     * @return Collection|'.ucfirst($entity).'[]
     */
    public function get'.ucfirst($entity).'(): Collection
    {
        return $this->'.$entity.';
    }
    
    public function add'.ucfirst($entity).'('.ucfirst($entity).' $'.$entity.'): self
    {
        if (!$this->'.$entity.'->contains($'.$entity.')) {
            $this->'.$entity.'[] = $'.$entity.';
            $'.$entity.'->setDil($this);
        }

        return $this;
    }

    public function remove'.ucfirst($entity).'('.ucfirst($entity).' $'.$entity.'): self
    {
        if ($this->'.$entity.'->removeElement($'.$entity.')) {
            // set the owning side to null (unless already changed)
            if ($'.$entity.'->getDil() === $this) {
                $'.$entity.'->setDil(null);
            }
        }

        return $this;
    }';

            $guncelVeri = $icerikParcasi[0].$bolum.$araparca.$icerikParcasi[1];


            $dosya2 = fopen($_SERVER['DOCUMENT_ROOT'] . '/src/Entity/Dil.php', 'w');
            fwrite($dosya2, $guncelVeri);
            fclose($dosya2);

        }



        // SAYFA

            $dosya2 = fopen($_SERVER['DOCUMENT_ROOT'] . '/src/Entity/Sayfa.php', 'r');
            $icerik = fread($dosya2, filesize($_SERVER['DOCUMENT_ROOT'] . '/src/Entity/Sayfa.php'));


            $icerikParcasi = explode('

    public function __construct()
    {
',$icerik);
            $bolum = '

    public function __construct()
    {
';

            $icerikParcasi[0].='

    /**
     * @ORM\OneToMany(targetEntity='.ucfirst($entity).'::class, mappedBy="sayfa", orphanRemoval=true)
     */
    private $'.$entity.';';

            $araparca2='        $this->'.$entity.' = new ArrayCollection();
';

            $guncelVeri = $icerikParcasi[0].$bolum.$araparca2.$icerikParcasi[1];


            $icerikParcasi = explode('

    public function getId(): ?int
    {
        return $this->id;
    }',$guncelVeri);
            $bolum = '

    public function getId(): ?int
    {
        return $this->id;
    }';


            $araparca='

    /**
     * @return Collection|'.ucfirst($entity).'[]
     */
    public function get'.ucfirst($entity).'(): Collection
    {
        return $this->'.$entity.';
    }
    
    public function add'.ucfirst($entity).'('.ucfirst($entity).' $'.$entity.'): self
    {
        if (!$this->'.$entity.'->contains($'.$entity.')) {
            $this->'.$entity.'[] = $'.$entity.';
            $'.$entity.'->setSayfa($this);
        }

        return $this;
    }

    public function remove'.ucfirst($entity).'('.ucfirst($entity).' $'.$entity.'): self
    {
        if ($this->'.$entity.'->removeElement($'.$entity.')) {
            // set the owning side to null (unless already changed)
            if ($'.$entity.'->getSayfa() === $this) {
                $'.$entity.'->setSayfa(null);
            }
        }

        return $this;
    }';

            $guncelVeri = $icerikParcasi[0].$bolum.$araparca.$icerikParcasi[1];


            $dosya2 = fopen($_SERVER['DOCUMENT_ROOT'] . '/src/Entity/Sayfa.php', 'w');
            fwrite($dosya2, $guncelVeri);
            fclose($dosya2);


        // KATEGORİ

            $dosya2 = fopen($_SERVER['DOCUMENT_ROOT'] . '/src/Entity/Kategori.php', 'r');
            $icerik = fread($dosya2, filesize($_SERVER['DOCUMENT_ROOT'] . '/src/Entity/Kategori.php'));


            $icerikParcasi = explode('

    public function __construct()
    {
',$icerik);
            $bolum = '

    public function __construct()
    {
';

            $icerikParcasi[0].='

    /**
     * @ORM\OneToMany(targetEntity='.ucfirst($entity).'::class, mappedBy="kategori", orphanRemoval=true)
     */
    private $'.$entity.';';

            $araparca2='        $this->'.$entity.' = new ArrayCollection();
';

            $guncelVeri = $icerikParcasi[0].$bolum.$araparca2.$icerikParcasi[1];


            $icerikParcasi = explode('

    public function getId(): ?int
    {
        return $this->id;
    }',$guncelVeri);
            $bolum = '

    public function getId(): ?int
    {
        return $this->id;
    }';


            $araparca='

    /**
     * @return Collection|'.ucfirst($entity).'[]
     */
    public function get'.ucfirst($entity).'(): Collection
    {
        return $this->'.$entity.';
    }
    
    public function add'.ucfirst($entity).'('.ucfirst($entity).' $'.$entity.'): self
    {
        if (!$this->'.$entity.'->contains($'.$entity.')) {
            $this->'.$entity.'[] = $'.$entity.';
            $'.$entity.'->setKategori($this);
        }

        return $this;
    }

    public function remove'.ucfirst($entity).'('.ucfirst($entity).' $'.$entity.'): self
    {
        if ($this->'.$entity.'->removeElement($'.$entity.')) {
            // set the owning side to null (unless already changed)
            if ($'.$entity.'->getKategori() === $this) {
                $'.$entity.'->setKategori(null);
            }
        }

        return $this;
    }';

            $guncelVeri = $icerikParcasi[0].$bolum.$araparca.$icerikParcasi[1];


            $dosya2 = fopen($_SERVER['DOCUMENT_ROOT'] . '/src/Entity/Kategori.php', 'w');
            fwrite($dosya2, $guncelVeri);
            fclose($dosya2);








        $ss_dosya = $_SERVER['DOCUMENT_ROOT'].'/templates/modul/'.$entity.'.html.twig';
        $ss_dosyaIc = $_SERVER['DOCUMENT_ROOT'].'/templates/modul/'.$entity.'_ic.html.twig';
        $ss_dosyaKategori = $_SERVER['DOCUMENT_ROOT'].'/templates/modul/'.$entity.'_kategori.html.twig';

        if(!file_exists($ss_dosya)) {
            $dd = fopen($ss_dosya, 'w');
            $veri ="{% extends 'siteBase.html.twig' %}
{% block dil %}{% endblock %} {# tr or en #}
{% block title %}{% endblock %}
{% block keywords %}{% endblock %}
{% block description %}{% endblock %}
{% block body %}{% endblock %}
{% block javascripts %}{% endblock %}
";
            fwrite($dd, $veri);
            fclose($dd);
        }
        if(!file_exists($ss_dosyaIc)) {
            $dd = fopen($ss_dosyaIc, 'w');
            $veri ="{% extends 'siteBase.html.twig' %}
{% block dil %}{% endblock %} {# tr or en #}
{% block title %}{% endblock %}
{% block keywords %}{% endblock %}
{% block description %}{% endblock %}
{% block body %}{% endblock %}
{% block javascripts %}{% endblock %}
";
            fwrite($dd, $veri);
            fclose($dd);
        }
        if(!file_exists($ss_dosyaKategori)) {
            $dd = fopen($ss_dosyaKategori, 'w');
            $veri ="{% extends 'siteBase.html.twig' %}
{% block dil %}{% endblock %} {# tr or en #}
{% block title %}{% endblock %}
{% block keywords %}{% endblock %}
{% block description %}{% endblock %}
{% block body %}{% endblock %}
{% block javascripts %}{% endblock %}
";
            fwrite($dd, $veri);
            fclose($dd);
        }




        shell_exec("php ".$_SERVER['DOCUMENT_ROOT']."/bin/console make:migration");
        shell_exec("php ".$_SERVER['DOCUMENT_ROOT']."/bin/console doctrine:migrations:migrate");






        $modul = new Modul();
        $modul->setAdi($adi);
        $modul->setTabloAdi(ucfirst($entity));
        $modul->setAlan($alann);
        $modul->setTip($tipp);
        $modul->setBosluk($boss);
        $modul->setCokluDil($cokdil);
        $em->persist($modul);
        $em->flush();

        return new Response('');
    }

    /**
     * @Route("/rv/modul/sil", name="modul_sil")
     */
    public function sil(Request $request): Response{
        $em = $this->getDoctrine()->getManager();

        $id = $request->request->get('id');

        $qb = $em->createQueryBuilder();
        $s=$qb->select('s.id')
            ->from('App:Sayfa', 's')
            ->join('s.modul','m')
            ->where('m.id='.$id)
            ->getQuery()
            ->getScalarResult();

        if(count($s)>0){
            return new Response('Modül silinemez! Bağlı sayfa bulunmaktadır.');
        }

        $qb = $em->createQueryBuilder();
        $m=$qb->select('m.tabloAdi,m.adi')
            ->from('App:Modul', 'm')
            ->where('m.id='.$id)
            ->getQuery()
            ->getScalarResult();

        $x = $em->getRepository(Modul::class)->find($id);
        $em->remove($x);
        $em->flush();


        @unlink($_SERVER['DOCUMENT_ROOT'] . '/src/Entity/'.$m[0]['tabloAdi'].'.php');
        @unlink($_SERVER['DOCUMENT_ROOT'] . '/src/Entity/'.$m[0]['tabloAdi'].'.php');

        $ss_dosya = $_SERVER['DOCUMENT_ROOT'].'/templates/modul/'.strtolower($m[0]['tabloAdi']).'.html.twig';
        $ss_dosyaIc = $_SERVER['DOCUMENT_ROOT'].'/templates/modul/'.strtolower($m[0]['tabloAdi']).'_ic.html.twig';
        $ss_dosyaKategori = $_SERVER['DOCUMENT_ROOT'].'/templates/modul/'.strtolower($m[0]['tabloAdi']).'_kategori.html.twig';

        @unlink($ss_dosya);
        @unlink($ss_dosyaIc);
        @unlink($ss_dosyaKategori);


        //Tablo silme
        $sql = 'DROP TABLE '.$this->seo($m[0]['adi']).';';
        $connection = $em->getConnection();
        $stmt = $connection->prepare($sql);
        $stmt->execute();
        $stmt->closeCursor();



        $qb = $em->createQueryBuilder();
        $moduller=$qb->select('m.id,m.adi,m.alan,m.tip,m.bosluk,m.cokluDil')
            ->from('App:Modul', 'm')
            ->getQuery()
            ->getScalarResult();

        $dosya2 = fopen($_SERVER['DOCUMENT_ROOT'] . '/public/stokD.php', 'r');
        $icerik = fread($dosya2, filesize($_SERVER['DOCUMENT_ROOT'] . '/public/stokD.php'));
        $icerikParcasi = explode('

    public function __construct()
    {
        ',$icerik);
        $bolum = '

    public function __construct()
    {
        ';

        $veri1 = '';
        $veri2 = '';
        $veri3 = '';
        foreach ($moduller as $k=>$modul){
            if($modul['cokluDil']==1){
                $entity = $this->seo(str_replace(' ','',$modul['adi']));
                $veri3.='$this->'.$entity.' = new ArrayCollection();
        ';

                $veri1.='

    /**
     * @ORM\OneToMany(targetEntity='.ucfirst($entity).'::class, mappedBy="dil", orphanRemoval=true)
     */
    private $'.$entity.';';

                $veri2.='

    /**
     * @return Collection|'.ucfirst($entity).'[]
     */
    public function get'.ucfirst($entity).'(): Collection
    {
        return $this->'.$entity.';
    }
    
    public function add'.ucfirst($entity).'('.ucfirst($entity).' $'.$entity.'): self
    {
        if (!$this->'.$entity.'->contains($'.$entity.')) {
            $this->'.$entity.'[] = $'.$entity.';
            $'.$entity.'->setDil($this);
        }

        return $this;
    }

    public function remove'.ucfirst($entity).'('.ucfirst($entity).' $'.$entity.'): self
    {
        if ($this->'.$entity.'->removeElement($'.$entity.')) {
            // set the owning side to null (unless already changed)
            if ($'.$entity.'->getDil() === $this) {
                $'.$entity.'->setDil(null);
            }
        }

        return $this;
    }';


            }
        }

        $guncelVeri = $icerikParcasi[0].$veri1.$bolum.$veri3.$icerikParcasi[1];


        $icerikParcasi = explode('

    public function getId(): ?int
    {
        return $this->id;
    }',$guncelVeri);
        $bolum = '

    public function getId(): ?int
    {
        return $this->id;
    }';

        $guncelVeri = $icerikParcasi[0].$bolum.$veri2.$icerikParcasi[1];

        $dosya2 = fopen($_SERVER['DOCUMENT_ROOT'] . '/src/Entity/Dil.php', 'w');
        fwrite($dosya2, $guncelVeri);
        fclose($dosya2);



        //SAYFA

        $dosya2 = fopen($_SERVER['DOCUMENT_ROOT'] . '/public/stokS.php', 'r');
        $icerik = fread($dosya2, filesize($_SERVER['DOCUMENT_ROOT'] . '/public/stokS.php'));
        $icerikParcasi = explode('

    public function __construct()
    {
',$icerik);
        $bolum = '

    public function __construct()
    {
';

        $veri1 = '';
        $veri2 = '';
        $veri3 = '';
        foreach ($moduller as $k=>$modul){

                $entity = $this->seo(str_replace(' ','',$modul['adi']));
                $veri3.='       $this->'.$entity.' = new ArrayCollection();
';

                $veri1.='

    /**
     * @ORM\OneToMany(targetEntity='.ucfirst($entity).'::class, mappedBy="sayfa", orphanRemoval=true)
     */
    private $'.$entity.';';

                $veri2.='

    /**
     * @return Collection|'.ucfirst($entity).'[]
     */
    public function get'.ucfirst($entity).'(): Collection
    {
        return $this->'.$entity.';
    }
    
    public function add'.ucfirst($entity).'('.ucfirst($entity).' $'.$entity.'): self
    {
        if (!$this->'.$entity.'->contains($'.$entity.')) {
            $this->'.$entity.'[] = $'.$entity.';
            $'.$entity.'->setSayfa($this);
        }

        return $this;
    }

    public function remove'.ucfirst($entity).'('.ucfirst($entity).' $'.$entity.'): self
    {
        if ($this->'.$entity.'->removeElement($'.$entity.')) {
            // set the owning side to null (unless already changed)
            if ($'.$entity.'->getSayfa() === $this) {
                $'.$entity.'->setSayfa(null);
            }
        }

        return $this;
    }';



        }

        $guncelVeri = $icerikParcasi[0].$veri1.$bolum.$veri3.$icerikParcasi[1];


        $icerikParcasi = explode('

    public function getId(): ?int
    {
        return $this->id;
    }',$guncelVeri);
        $bolum = '

    public function getId(): ?int
    {
        return $this->id;
    }';

        $guncelVeri = $icerikParcasi[0].$bolum.$veri2.$icerikParcasi[1];

        $dosya2 = fopen($_SERVER['DOCUMENT_ROOT'] . '/src/Entity/Sayfa.php', 'w');
        fwrite($dosya2, $guncelVeri);
        fclose($dosya2);



        //KATEGORİ

        $dosya2 = fopen($_SERVER['DOCUMENT_ROOT'] . '/public/stokK.php', 'r');
        $icerik = fread($dosya2, filesize($_SERVER['DOCUMENT_ROOT'] . '/public/stokK.php'));
        $icerikParcasi = explode('

    public function __construct()
    {
',$icerik);
        $bolum = '

    public function __construct()
    {
';

        $veri1 = '';
        $veri2 = '';
        $veri3 = '';
        foreach ($moduller as $k=>$modul){

                $entity = $this->seo(str_replace(' ','',$modul['adi']));
                $veri3.='       $this->'.$entity.' = new ArrayCollection();
';

                $veri1.='

    /**
     * @ORM\OneToMany(targetEntity='.ucfirst($entity).'::class, mappedBy="kategori", orphanRemoval=true)
     */
    private $'.$entity.';';

                $veri2.='

    /**
     * @return Collection|'.ucfirst($entity).'[]
     */
    public function get'.ucfirst($entity).'(): Collection
    {
        return $this->'.$entity.';
    }
    
    public function add'.ucfirst($entity).'('.ucfirst($entity).' $'.$entity.'): self
    {
        if (!$this->'.$entity.'->contains($'.$entity.')) {
            $this->'.$entity.'[] = $'.$entity.';
            $'.$entity.'->setKategori($this);
        }

        return $this;
    }

    public function remove'.ucfirst($entity).'('.ucfirst($entity).' $'.$entity.'): self
    {
        if ($this->'.$entity.'->removeElement($'.$entity.')) {
            // set the owning side to null (unless already changed)
            if ($'.$entity.'->getKategori() === $this) {
                $'.$entity.'->setKategori(null);
            }
        }

        return $this;
    }';



        }

        $guncelVeri = $icerikParcasi[0].$veri1.$bolum.$veri3.$icerikParcasi[1];


        $icerikParcasi = explode('

    public function getId(): ?int
    {
        return $this->id;
    }',$guncelVeri);
        $bolum = '

    public function getId(): ?int
    {
        return $this->id;
    }';

        $guncelVeri = $icerikParcasi[0].$bolum.$veri2.$icerikParcasi[1];

        $dosya2 = fopen($_SERVER['DOCUMENT_ROOT'] . '/src/Entity/Kategori.php', 'w');
        fwrite($dosya2, $guncelVeri);
        fclose($dosya2);


        shell_exec("php ".$_SERVER['DOCUMENT_ROOT']."/bin/console make:migration");
        shell_exec("php ".$_SERVER['DOCUMENT_ROOT']."/bin/console doctrine:migrations:migrate");



        return new Response('');
    }

    /**
     * @Route("/rv/modul/duzenleAc", name="modul_duzenleAc")
     */
    public function duzenleAc(Request $request): Response{
        $em = $this->getDoctrine()->getManager();

        $id = $request->request->get('id');

        $qb = $em->createQueryBuilder();
        $modul=$qb->select('m.adi,m.alan,m.tip,m.bosluk,m.cokluDil')
            ->from('App:Modul', 'm')
            ->where("m.id=$id")
            ->getQuery()
            ->getScalarResult();

        return $this->render('panel/modul/duzenleAc.html.twig',array('modul'=>$modul[0]));
    }

    /**
     * @Route("/rv/modul/duzenle", name="modul_duzenle")
     */
    public function duzenle(Request $request): Response
    {
        $em = $this->getDoctrine()->getManager();

        $id = $request->request->get('id');
        $adi = $request->request->get('adi');
        $alann = $request->request->get('alan'); $alan = explode(',',$alann);
        $tipp = $request->request->get('tip'); $tip = explode(',',$tipp);
        $boss = $request->request->get('bos'); $bos = explode(',',$boss);
        $cokdil = $request->request->get('cokdil');

        $veri = '';
        $veri2 = '';
        $entity = $this->seo(str_replace(' ','',$adi));
        $dosya = fopen($_SERVER['DOCUMENT_ROOT'].'/src/Entity/'.ucfirst($entity).'.php', 'w');
        $veri .='<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity
 */
class '.ucfirst($entity).'
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;
';

        $veri2 .='
    
    public function getId(): ?int
    {
        return $this->id;
    }
    ';


        foreach ($alan as $key=>$a) {
            if($a!=''){
                $a = $this->seo(str_replace(' ','',$a));
                if($bos[$key]=='true'){ $null = ', nullable=true'; $null2='?'; $null3=' = null'; } else { $null =''; $null2 =''; $null3 =''; }
                if($tip[$key]=='string'){
                    $veri.='
    /**
     * @ORM\Column(type="string", length=255'.$null.')
     */
    private $'.$a.';
    ';

                    $veri2 .='
    public function get'.ucfirst($a).'(): ?string
    {
        return $this->'.$a.';
    }

    public function set'.ucfirst($a).'('.$null2.'string $'.$a.'): self
    {
        $this->'.$a.' = $'.$a.';

        return $this;
    }';

                }
                if($tip[$key]=='integer'){
                    $veri.='
    /**
     * @ORM\Column(type="integer"'.$null.')
     */
    private $'.$a.';
    ';

                    $veri2 .='
    public function get'.ucfirst($a).'(): ?int
    {
        return $this->'.$a.';
    }

    public function set'.ucfirst($a).'('.$null2.'int $'.$a.'): self
    {
        $this->'.$a.' = $'.$a.';

        return $this;
    }';

                }
                if($tip[$key]=='text'){
                    $veri.='
    /**
     * @ORM\Column(type="text"'.$null.')
     */
    private $'.$a.';
    ';

                    $veri2 .='
    public function get'.ucfirst($a).'(): ?string
    {
        return $this->'.$a.';
    }

    public function set'.ucfirst($a).'('.$null2.'string $'.$a.'): self
    {
        $this->'.$a.' = $'.$a.';

        return $this;
    }';

                }
                if($tip[$key]=='float'){
                    $veri.='
    /**
     * @ORM\Column(type="float"'.$null.')
     */
    private $'.$a.';
    ';

                    $veri2 .='
    public function get'.ucfirst($a).'(): ?float
    {
        return $this->'.$a.';
    }

    public function set'.ucfirst($a).'('.$null2.'float $'.$a.'): self
    {
        $this->'.$a.' = $'.$a.';

        return $this;
    }';

                }
                if($tip[$key]=='datetime'){
                    $veri.='
    /**
     * @ORM\Column(type="datetime"'.$null.')
     */
    private $'.$a.';
    ';

                    $veri2 .='
    public function get'.ucfirst($a).'(): ?\DateTimeInterface
    {
        return $this->'.$a.';
    }

    public function set'.ucfirst($a).'('.$null2.'\DateTimeInterface $'.$a.'): self
    {
        $this->'.$a.' = $'.$a.';

        return $this;
    }';

                }
            }
        }



        if($cokdil==1){

            $veri.='
    /**
     * @ORM\Column(type="integer")
     */
    private $dilgrup;

    /**
     * @ORM\ManyToOne(targetEntity=Dil::class, inversedBy="'.$entity.'")
     * @ORM\JoinColumn(nullable=false)
     */
    private $dil;';

            $veri2 .='
    public function getDilgrup(): ?int
    {
        return $this->dilgrup;
    }

    public function setDilgrup(int $dilgrup): self
    {
        $this->dilgrup = $dilgrup;

        return $this;
    }

    public function getDil(): ?Dil
    {
        return $this->dil;
    }

    public function setDil(?Dil $dil): self
    {
        $this->dil = $dil;

        return $this;
    }';

        }





        $veri.='
    /**
     * @ORM\ManyToOne(targetEntity=Sayfa::class, inversedBy="'.$entity.'")
     * @ORM\JoinColumn(nullable=false)
     */
    private $sayfa;
    
    /**
     * @ORM\ManyToOne(targetEntity=Kategori::class, inversedBy="'.$entity.'")
     * @ORM\JoinColumn(nullable=true)
     */
    private $kategori;';

        $veri2 .='
    public function getSayfa(): ?Sayfa
    {
        return $this->sayfa;
    }

    public function setSayfa(?Sayfa $sayfa): self
    {
        $this->sayfa = $sayfa;

        return $this;
    }
    
    public function getKategori(): ?Kategori
    {
        return $this->kategori;
    }

    public function setKategori(?Kategori $kategori): self
    {
        $this->kategori = $kategori;

        return $this;
    }';






        $veri.='
    /**
     * @ORM\Column(type="integer", nullable=true)
     */
    private $sira;';

        $veri2 .='
    public function getSira(): ?int
    {
        return $this->sira;
    }

    public function setSira(?int $sira): self
    {
        $this->sira = $sira;

        return $this;
    }';



        $veri2 .='
}';

        fwrite($dosya, $veri.$veri2);
        fclose($dosya);




        $ss_dosya = $_SERVER['DOCUMENT_ROOT'].'/templates/modul/'.$entity.'.html.twig';
        $ss_dosyaIc = $_SERVER['DOCUMENT_ROOT'].'/templates/modul/'.$entity.'_ic.html.twig';
        $ss_dosyaKategori = $_SERVER['DOCUMENT_ROOT'].'/templates/modul/'.$entity.'_kategori.html.twig';

        if(!file_exists($ss_dosya)) {
            $dd = fopen($ss_dosya, 'w');
            $veri ="{% extends 'siteBase.html.twig' %}
{% block dil %}{% endblock %} {# tr or en #}
{% block title %}{% endblock %}
{% block keywords %}{% endblock %}
{% block description %}{% endblock %}
{% block body %}{% endblock %}
{% block javascripts %}{% endblock %}
";
            fwrite($dd, $veri);
            fclose($dd);
        }
        if(!file_exists($ss_dosyaIc)) {
            $dd = fopen($ss_dosyaIc, 'w');
            $veri ="{% extends 'siteBase.html.twig' %}
{% block dil %}{% endblock %} {# tr or en #}
{% block title %}{% endblock %}
{% block keywords %}{% endblock %}
{% block description %}{% endblock %}
{% block body %}{% endblock %}
{% block javascripts %}{% endblock %}
";
            fwrite($dd, $veri);
            fclose($dd);
        }
        if(!file_exists($ss_dosyaKategori)) {
            $dd = fopen($ss_dosyaKategori, 'w');
            $veri ="{% extends 'siteBase.html.twig' %}
{% block dil %}{% endblock %} {# tr or en #}
{% block title %}{% endblock %}
{% block keywords %}{% endblock %}
{% block description %}{% endblock %}
{% block body %}{% endblock %}
{% block javascripts %}{% endblock %}
";
            fwrite($dd, $veri);
            fclose($dd);
        }




        $qb = $em->createQueryBuilder();
        $q = $qb->update('App:Modul', 'm')
            ->set('m.adi', ':adi')
            ->set('m.tabloAdi', ':tabloAdi')
            ->set('m.alan', ':alan')
            ->set('m.tip', ':tip')
            ->set('m.bosluk', ':bosluk')
            ->set('m.cokluDil', ':cokluDil')
            ->where("m.id = $id")
            ->setParameter('adi', $adi)
            ->setParameter('tabloAdi', ucfirst($this->seo($adi)))
            ->setParameter('alan', $alann)
            ->setParameter('tip', $tipp)
            ->setParameter('bosluk', $boss)
            ->setParameter('cokluDil', $cokdil)
            ->getQuery()
            ->execute();


        $qb = $em->createQueryBuilder();
        $moduller=$qb->select('m.id,m.adi,m.alan,m.tip,m.bosluk,m.cokluDil')
            ->from('App:Modul', 'm')
            ->getQuery()
            ->getScalarResult();


        $qb = $em->createQueryBuilder();
        $moduller=$qb->select('m.id,m.adi,m.alan,m.tip,m.bosluk,m.cokluDil')
            ->from('App:Modul', 'm')
            ->getQuery()
            ->getScalarResult();

        $dosya2 = fopen($_SERVER['DOCUMENT_ROOT'] . '/public/stokD.php', 'r');
        $icerik = fread($dosya2, filesize($_SERVER['DOCUMENT_ROOT'] . '/public/stokD.php'));
        $icerikParcasi = explode('

    public function __construct()
    {
        ',$icerik);
        $bolum = '

    public function __construct()
    {
        ';

        $veri1 = '';
        $veri2 = '';
        $veri3 = '';
        foreach ($moduller as $k=>$modul){
            if($modul['cokluDil']==1){
                $entity = $this->seo(str_replace(' ','',$modul['adi']));
                $veri3.='$this->'.$entity.' = new ArrayCollection();
        ';

                $veri1.='

    /**
     * @ORM\OneToMany(targetEntity='.ucfirst($entity).'::class, mappedBy="dil", orphanRemoval=true)
     */
    private $'.$entity.';';

                $veri2.='

    /**
     * @return Collection|'.ucfirst($entity).'[]
     */
    public function get'.ucfirst($entity).'(): Collection
    {
        return $this->'.$entity.';
    }
    
    public function add'.ucfirst($entity).'('.ucfirst($entity).' $'.$entity.'): self
    {
        if (!$this->'.$entity.'->contains($'.$entity.')) {
            $this->'.$entity.'[] = $'.$entity.';
            $'.$entity.'->setDil($this);
        }

        return $this;
    }

    public function remove'.ucfirst($entity).'('.ucfirst($entity).' $'.$entity.'): self
    {
        if ($this->'.$entity.'->removeElement($'.$entity.')) {
            // set the owning side to null (unless already changed)
            if ($'.$entity.'->getDil() === $this) {
                $'.$entity.'->setDil(null);
            }
        }

        return $this;
    }';


            }
        }

        $guncelVeri = $icerikParcasi[0].$veri1.$bolum.$veri3.$icerikParcasi[1];


        $icerikParcasi = explode('

    public function getId(): ?int
    {
        return $this->id;
    }',$guncelVeri);
        $bolum = '

    public function getId(): ?int
    {
        return $this->id;
    }';

        $guncelVeri = $icerikParcasi[0].$bolum.$veri2.$icerikParcasi[1];

        $dosya2 = fopen($_SERVER['DOCUMENT_ROOT'] . '/src/Entity/Dil.php', 'w');
        fwrite($dosya2, $guncelVeri);
        fclose($dosya2);



        //SAYFA

        $dosya2 = fopen($_SERVER['DOCUMENT_ROOT'] . '/public/stokS.php', 'r');
        $icerik = fread($dosya2, filesize($_SERVER['DOCUMENT_ROOT'] . '/public/stokS.php'));
        $icerikParcasi = explode('

    public function __construct()
    {
',$icerik);
        $bolum = '

    public function __construct()
    {
';

        $veri1 = '';
        $veri2 = '';
        $veri3 = '';
        foreach ($moduller as $k=>$modul){

            $entity = $this->seo(str_replace(' ','',$modul['adi']));
            $veri3.='       $this->'.$entity.' = new ArrayCollection();
';

            $veri1.='

    /**
     * @ORM\OneToMany(targetEntity='.ucfirst($entity).'::class, mappedBy="sayfa", orphanRemoval=true)
     */
    private $'.$entity.';';

            $veri2.='

    /**
     * @return Collection|'.ucfirst($entity).'[]
     */
    public function get'.ucfirst($entity).'(): Collection
    {
        return $this->'.$entity.';
    }
    
    public function add'.ucfirst($entity).'('.ucfirst($entity).' $'.$entity.'): self
    {
        if (!$this->'.$entity.'->contains($'.$entity.')) {
            $this->'.$entity.'[] = $'.$entity.';
            $'.$entity.'->setSayfa($this);
        }

        return $this;
    }

    public function remove'.ucfirst($entity).'('.ucfirst($entity).' $'.$entity.'): self
    {
        if ($this->'.$entity.'->removeElement($'.$entity.')) {
            // set the owning side to null (unless already changed)
            if ($'.$entity.'->getSayfa() === $this) {
                $'.$entity.'->setSayfa(null);
            }
        }

        return $this;
    }';



        }

        $guncelVeri = $icerikParcasi[0].$veri1.$bolum.$veri3.$icerikParcasi[1];


        $icerikParcasi = explode('

    public function getId(): ?int
    {
        return $this->id;
    }',$guncelVeri);
        $bolum = '

    public function getId(): ?int
    {
        return $this->id;
    }';

        $guncelVeri = $icerikParcasi[0].$bolum.$veri2.$icerikParcasi[1];

        $dosya2 = fopen($_SERVER['DOCUMENT_ROOT'] . '/src/Entity/Sayfa.php', 'w');
        fwrite($dosya2, $guncelVeri);
        fclose($dosya2);



        //KATEGORİ

        $dosya2 = fopen($_SERVER['DOCUMENT_ROOT'] . '/public/stokK.php', 'r');
        $icerik = fread($dosya2, filesize($_SERVER['DOCUMENT_ROOT'] . '/public/stokK.php'));
        $icerikParcasi = explode('

    public function __construct()
    {
',$icerik);
        $bolum = '

    public function __construct()
    {
';

        $veri1 = '';
        $veri2 = '';
        $veri3 = '';
        foreach ($moduller as $k=>$modul){

            $entity = $this->seo(str_replace(' ','',$modul['adi']));
            $veri3.='       $this->'.$entity.' = new ArrayCollection();
';

            $veri1.='

    /**
     * @ORM\OneToMany(targetEntity='.ucfirst($entity).'::class, mappedBy="kategori", orphanRemoval=true)
     */
    private $'.$entity.';';

            $veri2.='

    /**
     * @return Collection|'.ucfirst($entity).'[]
     */
    public function get'.ucfirst($entity).'(): Collection
    {
        return $this->'.$entity.';
    }
    
    public function add'.ucfirst($entity).'('.ucfirst($entity).' $'.$entity.'): self
    {
        if (!$this->'.$entity.'->contains($'.$entity.')) {
            $this->'.$entity.'[] = $'.$entity.';
            $'.$entity.'->setKategori($this);
        }

        return $this;
    }

    public function remove'.ucfirst($entity).'('.ucfirst($entity).' $'.$entity.'): self
    {
        if ($this->'.$entity.'->removeElement($'.$entity.')) {
            // set the owning side to null (unless already changed)
            if ($'.$entity.'->getKategori() === $this) {
                $'.$entity.'->setKategori(null);
            }
        }

        return $this;
    }';



        }

        $guncelVeri = $icerikParcasi[0].$veri1.$bolum.$veri3.$icerikParcasi[1];


        $icerikParcasi = explode('

    public function getId(): ?int
    {
        return $this->id;
    }',$guncelVeri);
        $bolum = '

    public function getId(): ?int
    {
        return $this->id;
    }';

        $guncelVeri = $icerikParcasi[0].$bolum.$veri2.$icerikParcasi[1];

        $dosya2 = fopen($_SERVER['DOCUMENT_ROOT'] . '/src/Entity/Kategori.php', 'w');
        fwrite($dosya2, $guncelVeri);
        fclose($dosya2);



        shell_exec("php ".$_SERVER['DOCUMENT_ROOT']."/bin/console make:migration");
        shell_exec("php ".$_SERVER['DOCUMENT_ROOT']."/bin/console doctrine:migrations:migrate");





        return new Response('');
    }

}
