<?php

namespace App\Controller;

use App\Entity\Dil;
use App\Entity\Popup;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Controller\BaseController;


class PanelPopupController extends BaseController
{
    /**
     * @Route("/rv/popup", name="popup_homepage")
     */
    public function index(): Response
    {




        return $this->render('panel/popup/index.html.twig');
    }

    /**
     * @Route("/rv/popup/getir", name="popup_getir")
     */
    public function getir(): Response{
        $em = $this->getDoctrine()->getManager();

        $qb = $em->createQueryBuilder();
        $sayfalar=$qb->select('s.dilgrup,s.adi')
            ->from('App:Sayfa', 's')
            ->where('s.menu=1')
            ->orderBy('s.sira','ASC')
            ->groupBy('s.dilgrup')
            ->getQuery()
            ->getScalarResult();

        return $this->render('panel/popup/getir.html.twig',array('sayfalar'=>$sayfalar));
    }

    /**
     * @Route("/rv/popup/ac", name="popup_ac")
     */
    public function ac(Request $request): Response{
        $em = $this->getDoctrine()->getManager();

        $id = $request->request->get('id');

        $qb = $em->createQueryBuilder();
        $popup=$qb->select('s.id,s.dilgrup,s.link,s.tip,s.veri')
            ->from('App:Popup', 's')
            ->where("s.dilgrup=$id")
            ->groupBy('s.dilgrup')
            ->getQuery()
            ->getScalarResult();


        $qb = $em->createQueryBuilder();
        $diller=$qb->select('d.id,d.kisa')
            ->from('App:Dil', 'd')
            ->where("d.aktif=1")
            ->orderBy('d.id')
            ->getQuery()
            ->getScalarResult();

        return $this->render('panel/popup/ac.html.twig',array('popup'=>$popup,'diller'=>$diller));
    }

    /**
     * @Route("/rv/popup/kaydet", name="popup_kaydet")
     */
    public function kaydet(Request $request): Response
    {
        $em = $this->getDoctrine()->getManager();

        $dilgrup = $request->request->get('id');
        $tip = $request->request->get('tip');
        $videoLink = $request->request->get('videoLink');
        $link = $request->request->get('link');
        $sayfa = $request->request->get('sayfa');



        if ($dilgrup==0){

            $qb = $em->createQueryBuilder();
            $diller=$qb->select('d.id')
                ->from('App:Dil', 'd')
                ->where("d.aktif=1")
                ->orderBy('d.id')
                ->getQuery()
                ->getScalarResult();

            $son_dilgrup = $this->son_dilgrup('Popup');
            foreach ($diller as $key=>$dil){
                $dilSecim = $em->getReference(Dil::class,$dil['id']);

                if ($tip==0) {
                    $resim = 'popup_' . time() . '_';
                    move_uploaded_file($_FILES['resim' . $key]['tmp_name'], "gecici_yukleme/" . $resim . $this->uzantiBul($_FILES['resim' . $key]['type']));
                    $resim = $this->imageResizer($resim . $this->uzantiBul($_FILES['resim' . $key]['type']), $resim, 1000);
                    $this->uploadFile($resim);
                }

                $popup = new Popup();
                if ($tip==0){
                    $popup->setVeri($resim);
                }else{
                    $popup->setVeri($videoLink[$key]);
                }
                $popup->setDilgrup($son_dilgrup);
                $popup->setLink($link[$key]);
                $popup->setDil($dilSecim);
                $popup->setSayfaId($sayfa);
                $popup->setTip($tip);
                $em->persist($popup);

            }

            $em->flush();
        }else{

            $qb = $em->createQueryBuilder();
            $popupBul=$qb->select('s.veri')
                ->from('App:Popup', 's')
                ->where('s.dilgrup='.$dilgrup)
                ->getQuery()
                ->getScalarResult();

            //@unlink('uploads/'.$popupBul[0]['veri']);
            $this->deleteFile($popupBul[0]['veri']);


            $qb = $em->createQueryBuilder();
            $diller=$qb->select('d.id')
                ->from('App:Dil', 'd')
                ->where("d.aktif=1")
                ->orderBy('d.id')
                ->getQuery()
                ->getScalarResult();

            $son_dilgrup = $this->son_dilgrup('Popup');
            foreach ($diller as $key=>$dil) {
                $dilSecim = $em->getReference(Dil::class, $dil['id']);

                if ($tip == 0) {
                    $resim = 'popup_' . time() . '_';
                    move_uploaded_file($_FILES['resim' . $key]['tmp_name'], "gecici_yukleme/" . $resim . $this->uzantiBul($_FILES['resim' . $key]['type']));
                    $resim = $this->imageResizer($resim . $this->uzantiBul($_FILES['resim' . $key]['type']), $resim, 1000);
                    $this->uploadFile($resim);
                }

                $qb = $em->createQueryBuilder();
                $q = $qb->update('App:Popup', 's')
                    ->set('s.tip', ':tip')
                    ->set('s.link', ':link')
                    ->where("s.dil = ".$dil['id']." and s.dilgrup=$dilgrup")
                    ->setParameter('tip', $tip)
                    ->setParameter('link', $link)
                    ->getQuery()
                    ->execute();

                if ($tip==0){
                    $qb = $em->createQueryBuilder();
                    $q = $qb->update('App:Popup', 's')
                        ->set('s.veri', ':veri')
                        ->where("s.dil = ".$dil['id']." and s.dilgrup=$dilgrup")
                        ->setParameter('veri', $resim)
                        ->getQuery()
                        ->execute();


                }else{
                    $qb = $em->createQueryBuilder();
                    $q = $qb->update('App:Popup', 's')
                        ->set('s.veri', ':veri')
                        ->where("s.dil = ".$dil['id']." and s.dilgrup=$dilgrup")
                        ->setParameter('veri', $videoLink[$key])
                        ->getQuery()
                        ->execute();

                }

            }
        }




        return new Response('');
    }

    /**
     * @Route("/rv/popup/sil", name="popup_sil")
     */
    public function sil(Request $request): Response{
        $em = $this->getDoctrine()->getManager();

        $id = $request->request->get('id');

        $qb = $em->createQueryBuilder();
        $popupBul=$qb->select('s.veri')
            ->from('App:Popup', 's')
            ->where('s.dilgrup='.$id)
            ->getQuery()
            ->getScalarResult();

        // @unlink('uploads/'.$popupBul[0]['veri']);
        $this->deleteFile($popupBul[0]['veri']);

        $x = $em->getRepository(Popup::class)->findBy(array('dilgrup'=>$id));
        $this->removeEntity($x);
        $em->flush();


        return new Response('');
    }





}


