<?php

namespace App\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Controller\BaseController;

class PanelSabitCeviriController extends BaseController
{

    /**
     * @Route("/rv/sabitler", name="sabitler_homepage")
     */
    public function index(): Response
    {


        return $this->render('panel/sabitler/index.html.twig');
    }

    /**
     * @Route("/rv/sabitler/getir", name="sabitler_getir")
     */
    public function getir(): Response{
        $em = $this->getDoctrine()->getManager();

        $qb = $em->createQueryBuilder();
        $sabitler=$qb->select('c.id,c.deger,c.trId')
            ->from('App:Ceviri', 'c')
            ->join('c.dil', 'd')
            ->where('d.id=1')
            ->getQuery()
            ->getScalarResult();

        return $this->render('panel/sabitler/getir.html.twig',array('sabitler'=>$sabitler));
    }

    /**
     * @Route("/rv/sabitler/kaydet", name="sabitler_kaydet")
     */
    public function kaydet(Request $veri): Response{
        $em = $this->getDoctrine()->getManager();

        $deger = $veri->request->get('deger');
        $id = $veri->request->get('id');


        $qb = $em->createQueryBuilder();
        $q = $qb->update('App:Ceviri', 'c')
            ->set('c.deger', ':deger')
            ->where("c.id = ".$id)
            ->setParameter('deger', $deger)
            ->getQuery()
            ->execute();


        return new Response('');

    }



}


