<?php

namespace App\Controller;

use App\Entity\Dil;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Controller\BaseController;
use App\Entity\Slider;

class PanelSliderController extends BaseController
{
    /**
     * @Route("/rv/slider", name="slider_homepage")
     */
    public function index(): Response
    {


        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $diller=$qb->select('d.id,d.kisa')
            ->from('App:Dil', 'd')
            ->where("d.aktif=1")
            ->orderBy('d.id')
            ->getQuery()
            ->getScalarResult();


        return $this->render('panel/slider/index.html.twig',array('diller'=>$diller));
    }

    /**
     * @Route("/rv/slider/getir", name="slider_getir")
     */
    public function getir(): Response{
        $em = $this->getDoctrine()->getManager();

        $qb = $em->createQueryBuilder();
        $sliders=$qb->select('s.id,s.baslik,s.aciklama,s.resim,s.dilgrup,d.kisa as dKisa')
            ->from('App:Slider', 's')
            ->join('s.dil', 'd')
            ->orderBy('s.sira','ASC')
            ->groupBy('s.dilgrup')
            ->getQuery()
            ->getScalarResult();

        return $this->render('panel/slider/getir.html.twig',array('sliders'=>$sliders));
    }

    /**
     * @Route("/rv/slider/ekle", name="slider_ekle")
     */
    public function ekle(Request $request): Response
    {
        $em = $this->getDoctrine()->getManager();

        $baslik = $request->request->get('baslik');
        $aciklama = $request->request->get('aciklama');



        $qb = $em->createQueryBuilder();
        $diller=$qb->select('d.id')
            ->from('App:Dil', 'd')
            ->where("d.aktif=1")
            ->orderBy('d.id')
            ->getQuery()
            ->getScalarResult();

        $son_dilgrup = $this->son_dilgrup('Slider');
        foreach ($diller as $key=>$dil){
            $dilSecim = $em->getReference(Dil::class,$dil['id']);

            $resim='slider_'.time().'_'.$dil['id'];
            move_uploaded_file($_FILES['resim'.$key]['tmp_name'], "gecici_yukleme/".$resim.$this->uzantiBul($_FILES['resim'.$key]['type']));
            $resim  = $this->imageResizer($resim.$this->uzantiBul($_FILES['resim'.$key]['type']),$resim,1500);
            $this->uploadFile($resim);

            $slider = new Slider();
            $slider->setBaslik($baslik[$key]);
            $slider->setAciklama($aciklama[$key]);
            $slider->setDil($dilSecim);
            $slider->setDilgrup($son_dilgrup);
            $slider->setResim($resim);
            $slider->setSira(0);
            $em->persist($slider);

        }





        $em->flush();
        return new Response('');
    }

    /**
     * @Route("/rv/slider/duzenleAc", name="slider_duzenleAc")
     */
    public function duzenleAc(Request $request): Response{
        $em = $this->getDoctrine()->getManager();

        $id = $request->request->get('id');
        $qb = $em->createQueryBuilder();
        $slider=$qb->select('s.id,s.dilgrup,s.baslik,s.aciklama,s.resim')
            ->from('App:Slider', 's')
            ->where("s.dilgrup=$id")
            ->orderBy('s.dil')
            ->getQuery()
            ->getScalarResult();


        $qb = $em->createQueryBuilder();
        $diller=$qb->select('d.id,d.kisa')
            ->from('App:Dil', 'd')
            ->where("d.aktif=1")
            ->orderBy('d.id')
            ->getQuery()
            ->getScalarResult();

        return $this->render('panel/slider/duzenleAc.html.twig',array('slider'=>$slider,'diller'=>$diller));
    }

    /**
     * @Route("/rv/slider/duzenle", name="slider_duzenle")
     */
    public function duzenle(Request $request): Response
    {
        $em = $this->getDoctrine()->getManager();

        $dilgrup = $request->request->get('id');
        $baslik = $request->request->get('baslik');
        $aciklama = $request->request->get('aciklama');


        $qb = $em->createQueryBuilder();
        $diller=$qb->select('d.id')
            ->from('App:Dil', 'd')
            ->where("d.aktif=1")
            ->orderBy('d.id')
            ->getQuery()
            ->getScalarResult();


        foreach ($diller as $key=>$dil){
            $dilSecim = $em->getReference(Dil::class,$dil['id']);


            $qb = $em->createQueryBuilder();
            $sliderBul=$qb->select('s.resim')
                ->from('App:Slider', 's')
                ->join('s.dil','d')
                ->where('s.dilgrup='.$dilgrup.' and d.id='.$dil['id'])
                ->getQuery()
                ->getScalarResult();


            if (!empty($_FILES['resim'.$key]['name'])) {
                $resim = 'slider_' . time() . '_'.$dil['id'];
                move_uploaded_file($_FILES['resim'.$key]['tmp_name'], "gecici_yukleme/" . $resim . $this->uzantiBul($_FILES['resim'.$key]['type']));

                $resim  = $this->imageResizer($resim.$this->uzantiBul($_FILES['resim'.$key]['type']),$resim,1500);
                $this->uploadFile($resim);
                //@unlink('uploads/'.$sliderBul[0]['resim']);
                $this->deleteFile($sliderBul[0]['resim']);
            } else{
                $resim = $sliderBul[0]['resim'];
            }


            $qb = $em->createQueryBuilder();
            $q = $qb->update('App:Slider', 's')
                ->set('s.baslik', ':baslik')
                ->set('s.dil', ':dil')
                ->set('s.dilgrup', ':dilgrup')
                ->set('s.aciklama', ':aciklama')
                ->set('s.resim', ':resim')
                ->where("s.dil = ".$dil['id']." and s.dilgrup=$dilgrup")
                ->setParameter('baslik', $baslik[$key])
                ->setParameter('dil', $dilSecim)
                ->setParameter('dilgrup', $dilgrup)
                ->setParameter('aciklama', $aciklama[$key])
                ->setParameter('resim', $resim)
                ->getQuery()
                ->execute();

        }





        return new Response('');
    }

    /**
     * @Route("/rv/slider/sil", name="slider_sil")
     */
    public function sil(Request $request): Response{
        $em = $this->getDoctrine()->getManager();

        $id = $request->request->get('id');

        $qb = $em->createQueryBuilder();
        $sliderBul=$qb->select('s.resim')
            ->from('App:Slider', 's')
            ->where('s.dilgrup='.$id)
            ->getQuery()
            ->getScalarResult();

        foreach ($sliderBul as $ss){
            if (!empty($ss['resim'])){
                //@unlink('uploads/'.$sayfaBul[0]['bannerUrl']);
                $this->deleteFile($ss['resim']);
            }
        }


        $x = $em->getRepository(Slider::class)->findBy(array('dilgrup'=>$id));
        $this->removeEntity($x);
        $em->flush();


        return new Response('');
    }

    /**
     * @Route("/rv/slider/sirala", name="slider_sirala")
     */
    public function sirala(Request $request): Response
    {
        $em = $this->getDoctrine()->getManager();
        $listItem = $request->request->get('listItem');

        foreach ($listItem as $sira=>$id){
            $qb = $em->createQueryBuilder();
            $q = $qb->update('App:Slider', 's')
                ->set('s.sira', ':sira')
                ->where("s.dilgrup=$id")
                ->setParameter('sira', $sira)
                ->getQuery()
                ->execute();
        }

        return new Response('');
    }

}


