<?php

namespace App\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Controller\BaseController;

class PanelSosyalAgController extends BaseController
{
    /**
     * @Route("/rv/sosyal_ag", name="sosyal_ag_homepage")
     */
    public function index(): Response
    {


        $em = $this->getDoctrine()->getManager();

        $qb = $em->createQueryBuilder();
        $sosyal_aglar=$qb->select('s.id,s.ad,s.url')
            ->from('App:SosyalAg', 's')
            ->getQuery()
            ->getScalarResult();

        return $this->render('panel/sosyalag/index.html.twig',array('sosyal_aglar'=>$sosyal_aglar));
    }

    /**
     * @Route("/rv/sosyal_ag/kaydet", name="sosyal_ag_kaydet")
     */
    public function kaydet(Request $request): Response{
        $em = $this->getDoctrine()->getManager();

        $id = $request->request->get('id');
        $url = $request->request->get('url'); if (empty($url)){$url=null;}


        $qb = $em->createQueryBuilder();
        $q = $qb->update('App:SosyalAg', 's')
            ->set('s.url', ':url')
            ->where("s.id = $id")
            ->setParameter('url', $url)
            ->getQuery()
            ->execute();

        return new Response('');

    }

}


