<?php

namespace App\Controller;

use Gumlet\ImageResize;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Controller\BaseController;


class PanelTekVeriController extends BaseController
{
    /**
     * @Route("/rv/tekveri/{dilgrup}", name="tekveri_homepage")
     */
    public function index($dilgrup): Response
    {


        $em = $this->getDoctrine()->getManager();

        $dilgrupBul = $this->dilgrupBul('Sayfa',$dilgrup);

        $qb = $em->createQueryBuilder();
        $sayfa=$qb->select('s.id,s.adi,m.alan,m.tip,m.bosluk,m.cokluDil,m.tabloAdi,s.dilgrup,s.seo,s.title,s.description')
            ->from('App:Sayfa', 's')
            ->join('s.modul', 'm')
            ->where('s.dilgrup='.$dilgrupBul)
            ->getQuery()
            ->getScalarResult();

        $alanlar = explode(',',$sayfa[0]['alan']);
        $tipler = explode(',',$sayfa[0]['tip']);
        $bosluklar = explode(',',$sayfa[0]['bosluk']);



        $qb = $em->createQueryBuilder();
        $diller=$qb->select('d.id,d.kisa')
            ->from('App:Dil', 'd')
            ->where("d.aktif=1")
            ->orderBy('d.id')
            ->getQuery()
            ->getScalarResult();

        foreach ($tipler as $key=>$tip) {
            $alan[] = 't.'.$this->seo(str_replace(' ', '', $alanlar[$key]));
        }
        $alan = implode(',',$alan);

        if ($sayfa[0]['cokluDil']==1) {
            $qb = $em->createQueryBuilder();
            $veriler = $qb->select($alan . ',t.dilgrup')
                ->from('App:' . $sayfa[0]['tabloAdi'], 't')
                ->join('t.sayfa','s')
                ->where('s.id=' . $dilgrup)
                ->orderBy('t.dil')
                ->getQuery()
                ->getScalarResult();
        }else{
            $qb = $em->createQueryBuilder();
            $veriler = $qb->select($alan . ',t.dilgrup')
                ->from('App:' . $sayfa[0]['tabloAdi'], 't')
                ->join('t.sayfa','s')
                ->where('s.id=' . $dilgrup)
                ->getQuery()
                ->getScalarResult();
        }



        return $this->render('panel/icerik/tekveri/index.html.twig',array('sayfa'=>$sayfa,'diller'=>$diller,'veriler'=>$veriler));

    }

    /**
     * @Route("/rv/tekveri/{dilgrup}/kaydet/{vDilgrup}", name="tekveri_kaydet")
     */
    public function kaydet($dilgrup,$vDilgrup,Request $request): Response{
        $em = $this->getDoctrine()->getManager();

        $qb = $em->createQueryBuilder();
        $sayfa=$qb->select('s.adi,m.alan,m.tip,m.bosluk,m.cokluDil,s.dilgrup,m.adi as madi,m.tabloAdi,s.resimBoyut')
            ->from('App:Sayfa', 's')
            ->join('s.modul', 'm')
            ->where('s.id='.$dilgrup)
            ->getQuery()
            ->getScalarResult();
        if ($sayfa[0]['resimBoyut']!='') {
            $sResimBoyut = explode('x', $sayfa[0]['resimBoyut']);
        }

        $qb = $em->createQueryBuilder();
        $diller=$qb->select('d.id,d.kisa')
            ->from('App:Dil', 'd')
            ->where("d.aktif=1")
            ->orderBy('d.id')
            ->getQuery()
            ->getScalarResult();


        $alanlar = explode(',',$sayfa[0]['alan']);
        $tipler = explode(',',$sayfa[0]['tip']);
        $bosluklar = explode(',',$sayfa[0]['bosluk']);



        $resim = '';
        $resimler = '';
        $resimVar = 0 ;
        $dResim = [];
        $dResimVar = [];
        //resim yüklemeleri tamam!
        foreach ($tipler as $key=>$tip){
            if($this->seo($alanlar[$key])=='resim'){
                if($bosluklar[$key]=='false'){


                    $resim=$this->seo($sayfa[0]['adi']).'_'.time().'_'.rand(100000,999999);
                    move_uploaded_file($_FILES['rr_'.$this->seo($alanlar[$key])]['tmp_name'], "gecici_yukleme/".$resim.$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));

                    if ($sayfa[0]['resimBoyut']!='') {
                        $image = new ImageResize('gecici_yukleme/' .$resim.$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));
                        $image->resize($sResimBoyut[0], $sResimBoyut[1], $allow_enlarge = True);
                        $image->save('gecici_yukleme/' .$resim.$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));
                    }

                    $resim= $this->imageResizer($resim.$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']),$resim);
                    $this->uploadFile($resim);

                    $resimVar=1;
                }else{
                    if (!empty($_FILES['rr_'.$this->seo($alanlar[$key])]['name'])) {

                        $resim=$this->seo($sayfa[0]['adi']).'_'.time().'_'.rand(100000,999999);
                        move_uploaded_file($_FILES['rr_'.$this->seo($alanlar[$key])]['tmp_name'], "gecici_yukleme/".$resim.$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));


                        if ($sayfa[0]['resimBoyut']!='') {
                            $image = new ImageResize('gecici_yukleme/' .$resim.$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));
                            $image->resize($sResimBoyut[0], $sResimBoyut[1], $allow_enlarge = True);
                            $image->save('gecici_yukleme/' .$resim.$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));
                        }


                        $resim= $this->imageResizer($resim.$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']),$resim);
                        $this->uploadFile($resim);

                        $resimVar=1;
                    }
                }
            }
            elseif ($this->seo($alanlar[$key])=='resimler'){
                if (!empty($_FILES['rr_'.$this->seo($alanlar[$key])]['name'])) {
                    for ($i = 0; $i < count($_FILES['rr_' . $this->seo($alanlar[$key])]['name']); $i++) {
                        $x = $this->seo($sayfa[0]['adi']) . '_' . time() . '_' . rand(100000, 999999);
                        move_uploaded_file($_FILES['rr_' . $this->seo($alanlar[$key])]['tmp_name'][$i], "gecici_yukleme/" . $x . $this->uzantiBul($_FILES['rr_' . $this->seo($alanlar[$key])]['type'][$i]));

                        if ($sayfa[0]['resimBoyut']!='') {
                            $image = new ImageResize('gecici_yukleme/' .$x . $this->uzantiBul($_FILES['rr_' . $this->seo($alanlar[$key])]['type'][$i]));
                            $image->resize($sResimBoyut[0], $sResimBoyut[1], $allow_enlarge = True);
                            $image->save('gecici_yukleme/' .$x . $this->uzantiBul($_FILES['rr_' . $this->seo($alanlar[$key])]['type'][$i]));
                        }


                        $x = $this->imageResizer($x . $this->uzantiBul($_FILES['rr_' . $this->seo($alanlar[$key])]['type'][$i]), $x);
                        $this->uploadFile($x);

                        $resimler .= $x . ',';
                    }
                }
            }
            elseif(strpos($this->seo($alanlar[$key]),'resim')==true){
                if (!empty($_FILES['rr_'.$this->seo($alanlar[$key])]['name'])) {
                    $dResim[$key]=$this->seo($sayfa[0]['adi']).'_'.time().'_'.rand(100000,999999);
                    move_uploaded_file($_FILES['rr_'.$this->seo($alanlar[$key])]['tmp_name'], "gecici_yukleme/".$dResim[$key].$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));

                    if ($sayfa[0]['resimBoyut']!='') {
                        $image = new ImageResize('gecici_yukleme/' .$dResim[$key].$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));
                        $image->resize($sResimBoyut[0], $sResimBoyut[1], $allow_enlarge = True);
                        $image->save('gecici_yukleme/' .$dResim[$key].$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']));
                    }


                    $dResim[$key] = $this->imageResizer($dResim[$key].$this->uzantiBul($_FILES['rr_'.$this->seo($alanlar[$key])]['type']),$dResim[$key]);
                    $this->uploadFile($dResim[$key]);
                    $dResimVar[$key]=1;
                }else{
                    $dResimVar[$key]=0;
                }
            }
        }

        if(empty($resim)){ $resim=null; } else{ $resim = str_replace('.belirsiz','.jpg',$resim); }
        if(empty($resimler)){ $resimler=null; } else{ $resimler = str_replace('.belirsiz','.jpg',$resimler); }
        foreach ($dResim as $keyy=>$dR){
            if(empty($dR)){ $dResim[$keyy]=null; } else{ $dResim[$keyy] = str_replace('.belirsiz','.jpg',$dR); }
        }


        $sAlanlar = '';
        foreach ($alanlar as $a){
            $sAlanlar.=',t.'.$this->seo(str_replace(' ','',$a));
        }

        if($resimVar==1){
            $qb = $em->createQueryBuilder();
            $bulunanVeri=$qb->select('t.id'.$sAlanlar)
                ->from('App:'.$sayfa[0]['tabloAdi'], 't')
                ->join('t.sayfa','s')
                ->where('s.id='.$dilgrup.' and t.dilgrup='.$vDilgrup)
                ->orderBy('t.dil')
                ->getQuery()
                ->getScalarResult();

            if(strstr($bulunanVeri[0]['resim'], ',')) {
                $resimlerim = explode(',', $bulunanVeri[0]['resim']);
                foreach ($resimlerim as $r) {
                    if ($r != '') {
                        //@unlink('uploads/' . $r);
                        $this->deleteFile($r);
                    }
                }
            }else{
               // @unlink('uploads/' . $bulunanVeri[0]['resim']);
                $this->deleteFile($bulunanVeri[0]['resim']);
            }
        }else{
            $qb = $em->createQueryBuilder();
            $bulunanVeri=$qb->select('t.id'.$sAlanlar)
                ->from('App:'.$sayfa[0]['tabloAdi'], 't')
                ->join('t.sayfa','s')
                ->where('s.id='.$dilgrup.' and t.dilgrup='.$vDilgrup)
                ->orderBy('t.dil')
                ->getQuery()
                ->getScalarResult();
        }

        $s_dilgrup = $this->son_dilgrup($sayfa[0]['tabloAdi']);
        foreach ($diller as $key2=>$dil){
            if(count($bulunanVeri)>0) {
                $qb = $em->createQueryBuilder();
                $guncelVeri = $qb->update('App:'.$sayfa[0]['tabloAdi'], 't');

            }
            $veri = [];
            $alan = [];
            foreach ($tipler as $key=>$tip){
                $alan[]=$this->seo(str_replace(' ','',$alanlar[$key]));
                $asilAlan=$this->seo(str_replace(' ','',$alanlar[$key]));

                if($this->seo($alanlar[$key])=='resim'){
                    if(empty($resim)){ $veri[]= 'NULL'; }
                    else{
                        $veri[]="'".$resim."'";
                        if(count($bulunanVeri)>0) {
                            $guncelVeri->set('t.' . $asilAlan, ':' . $asilAlan);
                            $guncelVeri->setParameter($asilAlan, $resim);
                        }
                    }

                }
                elseif ($this->seo($alanlar[$key])=='resimler'){
                    if(empty($resimler)){ $veri[]= 'NULL'; }
                    else{
                        $veri[]="'".$resimler."'";
                        if(count($bulunanVeri)>0) {
                            $guncelVeri->set('t.' . $asilAlan, ':' . $asilAlan);
                            $guncelVeri->setParameter($asilAlan, $bulunanVeri[0]['resimler'].$resimler);
                        }
                    }

                }
                elseif(strpos($this->seo($alanlar[$key]),'resim')==true){
                    if($dResimVar[$key]==1) {
                       // @unlink('uploads/' . $bulunanVeri[0][$asilAlan]);
                        $this->deleteFile($bulunanVeri[0][$asilAlan]);
                    }
                    if(!empty($dResim[$key])){
                        if(count($bulunanVeri)>0) {
                            $guncelVeri->set('t.' . $asilAlan, ':' . $asilAlan);
                            $guncelVeri->setParameter($asilAlan, $dResim[$key]);
                        }
                    }
                }
                elseif ($this->seo($alanlar[$key])=='seo-url'){
                    $veri[]="'".$this->seo($request->request->get($this->seo($alanlar[$key]))[$key2])."'";
                    if(count($bulunanVeri)>0) {
                        $guncelVeri->set('t.' . $asilAlan, ':' . $asilAlan);
                        $guncelVeri->setParameter($asilAlan, $this->seo($request->request->get($this->seo($alanlar[$key]))[$key2],$dil['id']));
                    }
                }
                elseif ($tip=='datetime'){
                    $v = $request->request->get($this->seo($alanlar[$key]))[$key2];
                    if(empty($v)){
                        $veri[]= 'NULL';
                        if(count($bulunanVeri)>0) {
                            $guncelVeri->set('t.' . $asilAlan, ':' . $asilAlan);
                            $guncelVeri->setParameter($asilAlan, null);
                        }
                    }else {
                        $suan = new \DateTime('now');
                        $v = explode('/', $v);
                        $v = $v[2] . '-' . $v[1] . '-' . $v[0] . ' ' . $suan->format('H:i:s');
                        $vv = new \DateTime($v[2] . '-' . $v[1] . '-' . $v[0] . ' ' . $suan->format('H:i:s'));
                        $veri[]="'".$v."'";
                        if(count($bulunanVeri)>0) {
                            $guncelVeri->set('t.' . $asilAlan, ':' . $asilAlan);
                            $guncelVeri->setParameter($asilAlan, $vv);
                        }
                    }
                }
                else{
                    $v = $request->request->get($this->seo($alanlar[$key]))[$key2];
                    $v = htmlentities($v, ENT_QUOTES, "UTF-8");
                    if(empty($v)){
                        $veri[]= 'NULL';
                        if(count($bulunanVeri)>0) {
                            $guncelVeri->set('t.' . $asilAlan, ':' . $asilAlan);
                            $guncelVeri->setParameter($asilAlan, null);
                        }
                    }else{
                        $veri[]="'".$v."'";
                        if(count($bulunanVeri)>0) {
                            $guncelVeri->set('t.' . $asilAlan, ':' . $asilAlan);
                            $guncelVeri->setParameter($asilAlan, $v);
                        }
                    }

                }
            }
            $veri = implode(',',$veri);
            $alan = implode(',',$alan);


            if(count($bulunanVeri)==0){
                $RAW_QUERY = "INSERT INTO ".$this->seo(str_replace(' ','',$sayfa[0]['madi']))."(dil_id,dilgrup,sayfa_id,".$alan.") VALUES(".$dil['id'].",$s_dilgrup,$dilgrup,$veri)";
                $statement = $em->getConnection()->prepare($RAW_QUERY);
                $statement->execute();
            }else{
                $guncelVeri->where("t.id = ".$bulunanVeri[$key2]['id'])
                    ->getQuery()
                    ->execute();
            }




        }



        return new Response('');
    }

    /**
     * @Route("/rv/tekveri/{dilgrup}/gorsel_sil", name="tekveri_gorsel_sil")
     */
    public function gorsel_sil($dilgrup, Request $request): Response{
        $em = $this->getDoctrine()->getManager();
        $vDilgrup = $request->request->get('dilgrup');
        $adi = $request->request->get('adi');

        $qb = $em->createQueryBuilder();
        $sayfa=$qb->select('m.tabloAdi')
            ->from('App:Sayfa', 's')
            ->join('s.modul', 'm')
            ->where('s.id='.$dilgrup)
            ->getQuery()
            ->getScalarResult();

        $qb = $em->createQueryBuilder();
        $veri=$qb->select('v.id,v.resimler')
            ->from('App:'.$sayfa[0]['tabloAdi'], 'v')
            ->join('v.sayfa','s')
            ->where('s.id='.$dilgrup.' and v.dilgrup='.$vDilgrup)
            ->getQuery()
            ->getScalarResult();
        $yeni_resimler='';
        $resimler = explode(',',$veri[0]['resimler']);
        foreach ($resimler as $resim){
            if(!empty($resim)) {
                if ($adi != $resim) {
                    $yeni_resimler .= $resim . ',';
                }
            }
        }
        //@unlink('uploads/'.$adi);
        $this->deleteFile($adi);

        $qb = $em->createQueryBuilder();
        $q = $qb->update('App:'.$sayfa[0]['tabloAdi'], 's')
            ->set('s.resimler', ':resimler')
            ->where("s.dilgrup=$vDilgrup")
            ->setParameter('resimler', $yeni_resimler)
            ->getQuery()
            ->execute();

        return new Response('');


    }

    /**
     * @Route("/rv/tekveri/{dilgrup}/gorsel_sirala", name="tekveri_gorsel_sirala")
     */
    public function gorsel_sirala($dilgrup, Request $request): Response
    {
        $em = $this->getDoctrine()->getManager();
        $vDilgrup = $request->request->get('dilgrup');
        $resimler = $request->request->get('resimler');

        $qb = $em->createQueryBuilder();
        $sayfa=$qb->select('m.tabloAdi')
            ->from('App:Sayfa', 's')
            ->join('s.modul', 'm')
            ->where('s.id='.$dilgrup)
            ->getQuery()
            ->getScalarResult();


        $qb = $em->createQueryBuilder();
        $q = $qb->update('App:'.$sayfa[0]['tabloAdi'], 's')
            ->set('s.resimler', ':resimler')
            ->where("s.dilgrup=$vDilgrup")
            ->setParameter('resimler', $resimler)
            ->getQuery()
            ->execute();


        return new Response('');
    }


}


