<?php

namespace App\Controller;

use App\Controller\BaseController;
use App\Entity\Form;
use App\Entity\FormKayit;
use phpDocumentor\Reflection\Types\This;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Mailer\MailerInterface;
use Symfony\Component\Mime\Address;
use Symfony\Component\Mime\Email;
use Symfony\Component\Routing\Annotation\Route;

class SiteDefaultController extends BaseController
{

    /**
     * @Route("/form-kayit", name="site_formKayit")
     */
    public function formKayit(Request $veri, MailerInterface $mailer):Response{

        if ($this->get('session')->get('dil')==''){
            $this->get('session')->set('dil',$this->varsayilanDil());
        }



        $em = $this->getDoctrine()->getManager();
        $id = $veri->request->get('id');

        $captcha=$veri->request->get("captcha");

        if($captcha==$this->get('session')->get('captcha'))
        {

            $qb = $em->createQueryBuilder();
            $form=$qb->select('f.adi,f.tip,f.veri,f.alan,f.zorunlu,f.eposta')
                ->from('App:Form', 'f')
                ->where("f.id =".$id)
                ->getQuery()
                ->getScalarResult();

            $tipler = explode('~',$form[0]['tip']);
            $alanlar = explode('~',$form[0]['alan']);

            $kayit=[];
            $eposta_metin='';

            foreach ($tipler as $key=>$tip){

                if($tip=='input'){
                    $kayit[] = $veri->request->get($this->seo($alanlar[$key]));
                    $eposta_metin .= '<b>'.$alanlar[$key].'</b>: '.$veri->request->get($this->seo($alanlar[$key])).'<br>';
                }
                elseif($tip=='inputPhone'){
                    $kayit[] = $veri->request->get($this->seo($alanlar[$key]));
                    $eposta_metin .= '<b>'.$alanlar[$key].'</b>: '.$veri->request->get($this->seo($alanlar[$key])).'<br>';
                }
                elseif($tip=='inputEmail'){
                    $kayit[] = $veri->request->get($this->seo($alanlar[$key]));
                    $eposta_metin .= '<b>'.$alanlar[$key].'</b>: '.$veri->request->get($this->seo($alanlar[$key])).'<br>';
                }
                elseif($tip=='inputNumeric'){
                    $kayit[] = $veri->request->get($this->seo($alanlar[$key]));
                    $eposta_metin .= '<b>'.$alanlar[$key].'</b>: '.$veri->request->get($this->seo($alanlar[$key])).'<br>';
                }
                elseif($tip=='inputPrice'){
                    $kayit[] = $veri->request->get($this->seo($alanlar[$key]));
                    $eposta_metin .= '<b>'.$alanlar[$key].'</b>: '.$veri->request->get($this->seo($alanlar[$key])).'<br>';
                }
                elseif($tip=='inputDate'){
                    $kayit[] = $veri->request->get($this->seo($alanlar[$key]));
                    $eposta_metin .= '<b>'.$alanlar[$key].'</b>: '.$veri->request->get($this->seo($alanlar[$key])).'<br>';
                }
                elseif($tip=='textarea'){
                    $kayit[] = $veri->request->get($this->seo($alanlar[$key]));
                    $eposta_metin .= '<b>'.$alanlar[$key].'</b>: '.$veri->request->get($this->seo($alanlar[$key])).'<br>';
                }
                elseif($tip=='select'){
                    $kayit[] = $veri->request->get($this->seo($alanlar[$key]));
                    $eposta_metin .= '<b>'.$alanlar[$key].'</b>: '.$veri->request->get($this->seo($alanlar[$key])).'<br>';
                }
                elseif($tip=='checkbox'){
                    $kayit[] = implode(',',$veri->request->get($this->seo($alanlar[$key])));
                    $eposta_metin .= '<b>'.$alanlar[$key].'</b>: '.implode(',',$veri->request->get($this->seo($alanlar[$key]))).'<br>';
                }
                elseif($tip=='radio'){
                    $kayit[] = $veri->request->get($this->seo($alanlar[$key]));
                    $eposta_metin .= '<b>'.$alanlar[$key].'</b>: '.$veri->request->get($this->seo($alanlar[$key])).'<br>';
                }
                elseif($tip=='file'){
                    if (!empty($_FILES[$this->seo($alanlar[$key])]['name'])) {
                        $dosya = $this->seo($this->seo($alanlar[$key])) . '_' . time() . '_' . $this->uzantiBul($_FILES[$this->seo($alanlar[$key])]['type']);
                        move_uploaded_file($_FILES[$this->seo($alanlar[$key])]['tmp_name'], "uploads/" . $dosya . "");
                        $kayit[] = $dosya;
                        $eposta_metin .= '<b>'.$alanlar[$key].'</b>: <a target="_blank" href="'.$this->ayarlar('siteYolu').'uploads/'.$dosya.'"><img src="'.$this->ayarlar('siteYolu').'uploads/'.$dosya.'"></a><br>';
                    }else{
                        $kayit[] = '';
                        $eposta_metin .= '<b>'.$alanlar[$key].'</b>:';
                    }

                }

            }

            $ff = $em->getReference(Form::class,$id);
            $formKayit = new FormKayit();
            $formKayit->setForm($ff);
            $formKayit->setOkuma(0);
            $formKayit->setTarih(new \DateTime('now'));
            $formKayit->setKayit(implode('~',$kayit));
            $em->persist($formKayit);
            $em->flush();

            if ($form[0]['eposta']==1){


                $email = (new Email())
                    ->from(new Address($this->ayarlar('sistemPosta'),$this->ayarlar('siteAdi')))
                    ->to(new Address($this->iletisimBilgileri('eposta'),$this->ayarlar('siteAdi')))
                    //->cc('cc@example.com')
                    //->bcc('bcc@example.com')
                    //->replyTo('fabien@example.com')
                    ->priority(Email::PRIORITY_HIGH)
                    ->subject($form[0]['adi'].' - '.$this->ayarlar('siteAdi'))
                    //->text('Sending emails is fun again!')
                    ->html($this->renderView('mail/formMail.html.twig',array('konu'=>$form[0]['adi'],'icerik'=>$eposta_metin)));
                $mailer->send($email);


            }

            $status=1;
        }
        else {
            $status=0;
        }

        return $this->render('siteBase/formReturn.html.twig',array('status'=>$status,'referer'=>$_SERVER['HTTP_REFERER']));
    }

    /**
     * @Route("/captcha", name="site_captcha")
     */
    public function captcha():Response{

        if ($this->get('session')->get('dil')=='') {
            $this->get('session')->set('dil', $this->varsayilanDil());
        }


        $em = $this->getDoctrine()->getManager();


        $kod = strtoupper(substr(md5(uniqid(rand(0, 6))), 0, 6));


        $this->get('session')->set('captcha',$kod);


        $kod_uzunluk = strlen($kod);
        $genislik = imagefontwidth(5) * $kod_uzunluk;
        $yukseklik = imagefontheight(5);

        $resim = imagecreate($genislik, $yukseklik);

        $arka_renk = imagecolorallocate($resim, 0, 0, 0);
        $yazi_renk = imagecolorallocate($resim, 255, 255, 255);
        imagefill($resim, 0, 0, $arka_renk);

        imagestring($resim, 5, 0, 0, $kod, $yazi_renk);

        imagepng($resim);

        $headers = array(
            'Content-Type'     => 'image/webp',
        );
        return new Response("", 200, $headers);

    }

    /**
     * @Route("/onlineodeme_pos", name="site_onlineodeme_pos")
     */
    public function onlineodeme_pos(Request $request):Response{
        $em = $this->getDoctrine()->getManager();
        $tutar = $request->request->get('tutar');
        $adsoyad = $request->request->get('adsoyad');
        $eposta = $request->request->get('eposta');
        $telefon = $request->request->get('telefon');
        $firmaadi = $request->request->get('firmaadi');
        $aciklama = $request->request->get('aciklama');

        $bilgiler = [];
        $bilgiler['tutar'] = $tutar;
        $bilgiler['adsoyad'] = $adsoyad;
        $bilgiler['eposta'] = $eposta;
        $bilgiler['telefon'] = $telefon;
        $bilgiler['firmaadi'] = $firmaadi;
        $bilgiler['aciklama'] = $aciklama;

        $this->get('session')->set('odemeBilgiler',$bilgiler);



        ## 1. ADIM için örnek kodlar ##

        ####################### DÜZENLEMESİ ZORUNLU ALANLAR #######################
        #
        ## API Entegrasyon Bilgileri - Mağaza paneline giriş yaparak BİLGİ sayfasından alabilirsiniz.
        $merchant_id 	= '153532';
        $merchant_key 	= 'Ruh8929XRpRZZCDf';
        $merchant_salt	= '9z5mgpCPP2n6NGsK';
        #
        ## Müşterinizin sitenizde kayıtlı veya form vasıtasıyla aldığınız eposta adresi
        $email = $eposta;
        #
        ## Tahsil edilecek tutar.
        $payment_amount	= doubleval($tutar)*100; //9.99 için 9.99 * 100 = 999 gönderilmelidir.
        //$payment_amount	= 100; //9.99 için 9.99 * 100 = 999 gönderilmelidir.
        #
        ## Sipariş numarası: Her işlemde benzersiz olmalıdır!! Bu bilgi bildirim sayfanıza yapılacak bildirimde geri gönderilir.
        $merchant_oid = rand(0,9999999);
        #
        ## Müşterinizin sitenizde kayıtlı veya form aracılığıyla aldığınız ad ve soyad bilgisi
        $user_name = $adsoyad;
        #
        ## Müşterinizin sitenizde kayıtlı veya form aracılığıyla aldığınız adres bilgisi
        $user_address = "Merkezefendi/DENİZLİ";
        #
        ## Müşterinizin sitenizde kayıtlı veya form aracılığıyla aldığınız telefon bilgisi
        $user_phone = $telefon;
        #
        ## Başarılı ödeme sonrası müşterinizin yönlendirileceği sayfa
        ## !!! Bu sayfa siparişi onaylayacağınız sayfa değildir! Yalnızca müşterinizi bilgilendireceğiniz sayfadır!
        ## !!! Siparişi onaylayacağız sayfa "Bildirim URL" sayfasıdır (Bakınız: 2.ADIM Klasörü).
        $merchant_ok_url = "https://rvyazilim.com/online-odeme?s=1";
        #
        ## Ödeme sürecinde beklenmedik bir hata oluşması durumunda müşterinizin yönlendirileceği sayfa
        ## !!! Bu sayfa siparişi iptal edeceğiniz sayfa değildir! Yalnızca müşterinizi bilgilendireceğiniz sayfadır!
        ## !!! Siparişi iptal edeceğiniz sayfa "Bildirim URL" sayfasıdır (Bakınız: 2.ADIM Klasörü).
        $merchant_fail_url = "https://rvyazilim.com/online-odeme?s=0";
        #
        ## Müşterinin sepet/sipariş içeriği
        // $user_basket = $paket[0]['adi'].' Paket ('.$sure.' Aylık)';
        #
        /* ÖRNEK $user_basket oluşturma - Ürün adedine göre array'leri çoğaltabilirsiniz */
        $user_basket = base64_encode(json_encode(array('Cari Ödeme')));

        $user_basket = base64_encode(json_encode(array(
            array('Cari Ödeme', $tutar, 1), // 1. ürün (Ürün Ad - Birim Fiyat - Adet)
        )));
        ############################################################################################

        ## Kullanıcının IP adresi
        if( isset( $_SERVER["HTTP_CLIENT_IP"] ) ) {
            $ip = $_SERVER["HTTP_CLIENT_IP"];
        } elseif( isset( $_SERVER["HTTP_X_FORWARDED_FOR"] ) ) {
            $ip = $_SERVER["HTTP_X_FORWARDED_FOR"];
        } else {
            $ip = $_SERVER["REMOTE_ADDR"];
        }

        ## !!! Eğer bu örnek kodu sunucuda değil local makinanızda çalıştırıyorsanız
        ## buraya dış ip adresinizi (https://www.whatismyip.com/) yazmalısınız. Aksi halde geçersiz paytr_token hatası alırsınız.
        $user_ip=$ip;
        ##

        ## İşlem zaman aşımı süresi - dakika cinsinden
        $timeout_limit = "30";

        ## Hata mesajlarının ekrana basılması için entegrasyon ve test sürecinde 1 olarak bırakın. Daha sonra 0 yapabilirsiniz.
        $debug_on = 1;

        ## Mağaza canlı modda iken test işlem yapmak için 1 olarak gönderilebilir.
        $test_mode = 0;

        $no_installment	= 1; // Taksit yapılmasını istemiyorsanız, sadece tek çekim sunacaksanız 1 yapın

        ## Sayfada görüntülenecek taksit adedini sınırlamak istiyorsanız uygun şekilde değiştirin.
        ## Sıfır (0) gönderilmesi durumunda yürürlükteki en fazla izin verilen taksit geçerli olur.
        $max_installment = 0;

        $currency = "TL";

        ####### Bu kısımda herhangi bir değişiklik yapmanıza gerek yoktur. #######
        $hash_str = $merchant_id .$user_ip .$merchant_oid .$email .$payment_amount .$user_basket.$no_installment.$max_installment.$currency.$test_mode;
        $paytr_token=base64_encode(hash_hmac('sha256',$hash_str.$merchant_salt,$merchant_key,true));
        $post_vals=array(
            'merchant_id'=>$merchant_id,
            'user_ip'=>$user_ip,
            'merchant_oid'=>$merchant_oid,
            'email'=>$email,
            'payment_amount'=>$payment_amount,
            'paytr_token'=>$paytr_token,
            'user_basket'=>$user_basket,
            'debug_on'=>$debug_on,
            'no_installment'=>$no_installment,
            'max_installment'=>$max_installment,
            'user_name'=>$user_name,
            'user_address'=>$user_address,
            'user_phone'=>$user_phone,
            'merchant_ok_url'=>$merchant_ok_url,
            'merchant_fail_url'=>$merchant_fail_url,
            'timeout_limit'=>$timeout_limit,
            'currency'=>$currency,
            'test_mode'=>$test_mode
        );

        $ch=curl_init();
        curl_setopt($ch, CURLOPT_URL, "https://www.paytr.com/odeme/api/get-token");
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1) ;
        curl_setopt($ch, CURLOPT_POSTFIELDS, $post_vals);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_FRESH_CONNECT, true);
        curl_setopt($ch, CURLOPT_TIMEOUT, 20);
        $result = @curl_exec($ch);

        if(curl_errno($ch))
            die("PAYTR IFRAME connection error. err:".curl_error($ch));

        curl_close($ch);

        $result=json_decode($result,1);

        if($result['status']=='success')
            $token=$result['token'];
        else
            die("PAYTR IFRAME failed. reason:".$result['reason']);
        #########################################################################
        return $this->render('siteBase/onlineodeme_pos.html.twig', array('token' => $token));




    }

    /**
     * @Route("/payBildirim", name="site_payBildirim")
     */
    public function payBildirim(Request $request):Response{

        $em = $this->getDoctrine()->getManager();


        $merchant_key 	= 'Ruh8929XRpRZZCDf';
        $merchant_salt	= '9z5mgpCPP2n6NGsK';

        $hash = base64_encode( hash_hmac('sha256', $request->request->get('merchant_oid').$merchant_salt.$request->request->get('status').$request->request->get('total_amount'), $merchant_key, true) );

        if( $hash != $request->request->get('hash'))
            die('PAYTR notification failed: bad hash');


        if( $request->request->get('status') == 'success' ) {

            $postaIcerik2 = 'Az önce yapılan ödeme başarılı oldu.';


            $message = \Swift_Message::newInstance()
                ->setSubject('Ödeme başarılı.')
                ->setFrom(array($this->ayarlar('sistemPosta')=>$this->ayarlar('siteAdi')))
                ->setTo('destek@rvyazilim.com')
                ->setBody($this->renderView('mail/formMail.html.twig', array('konu' => 'Ödeme başarılı.','icerik'=>$postaIcerik2)), 'text/html');
            $this->get('mailer')->send($message);

        }
        else {

            $postaIcerik = 'Az önce yapılan ödeme başarısız oldu.';
            $message = \Swift_Message::newInstance()
                ->setSubject('Ödeme başarısız.')
                ->setFrom(array($this->ayarlar('sistemPosta')=>$this->ayarlar('siteAdi')))
                ->setTo('destek@rvyazilim.com')
                ->setBody($this->renderView('mail/formMail.html.twig', array('konu' => 'Ödeme başarısız.','icerik'=>$postaIcerik)), 'text/html');
            $this->get('mailer')->send($message);


        }

        echo 'OK';
        exit;
    }

    /**
     * @Route("/robots.txt", name="site_robots")
     */
    public function robots():Response
    {
        $siteyolu = $this->ayarlar('siteYolu');

        $veri='User-Agent: *
Allow: 
Disallow: /rv/

Sitemap: '.$siteyolu.'sitemap.xml';


        $response = new Response($veri);
        $response->headers->set('Content-Type', 'txt');

        return $response;
    }

    /**
     * @Route("/sitemap.xml", name="site_map")
     */
    public function map():Response
    {
        $em = $this->getDoctrine()->getManager();
        $suan = new \DateTime('now');
        $siteyolu = $this->ayarlar('siteYolu');


        $veri='<?xml version="1.0" encoding="UTF-8"?>
<urlset
      xmlns="http://www.sitemaps.org/schemas/sitemap/0.9"
      xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
      xsi:schemaLocation="http://www.sitemaps.org/schemas/sitemap/0.9
            http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd">';

        // Sitenin Kendisi
        if ($this->dilSay()>1) {
            $qb = $em->createQueryBuilder();
            $diller=$qb->select("d.kisa")
                ->from('App:Dil', 'd')
                ->where('d.aktif=1')
                ->orderBy('d.id','asc')
                ->getQuery()
                ->getScalarResult();

            foreach ($diller as $dil){
                $veri .= '<url>
                      <loc>' . $siteyolu.$dil['kisa'].'</loc>
                      <lastmod>' . $suan->format('Y-m-d') . 'T' . $suan->format('H:i:s') . '+00:00</lastmod>
                      <priority>1.00</priority>
                    </url>';
            }

        }else{
            $veri .= '<url> 
                      <loc>' . $siteyolu.'</loc>
                      <lastmod>' . $suan->format('Y-m-d') . 'T' . $suan->format('H:i:s') . '+00:00</lastmod>
                      <priority>1.00</priority>
                    </url>';
        }


        // Sayfalar
        $qb = $em->createQueryBuilder();
        $sayfalar=$qb->select('d.kisa as dKisa,s.seo')
            ->from('App:Sayfa', 's')
            ->join('s.dil', 'd')
            ->join('s.modul', 'm')
            ->where('s.menu=1')
            ->orderBy('s.sira','ASC')
            ->getQuery()
            ->getScalarResult();
        foreach ($sayfalar as $sayfa){

            if ($this->dilSay()>1) {
                $veri .= '<url>
                      <loc>' . $siteyolu .$sayfa['dKisa'].'/'.$sayfa['seo'].'</loc>
                      <lastmod>' . $suan->format('Y-m-d') . 'T' . $suan->format('H:i:s') . '+00:00</lastmod>
                      <priority>1.00</priority>
                    </url>';
            }else{
                $veri .= '<url> 
                      <loc>' . $siteyolu.$sayfa['seo'].'</loc>
                      <lastmod>' . $suan->format('Y-m-d') . 'T' . $suan->format('H:i:s') . '+00:00</lastmod>
                      <priority>1.00</priority>
                    </url>';
            }

        }

        // Kategoriler
        $qb = $em->createQueryBuilder();
        $kategoriler=$qb->select('d.id as did,s.dilgrup as sayfaId,k.dilgrup,k.seourl,d.kisa as dKisa')
            ->from('App:Kategori', 'k')
            ->join('k.sayfa','s')
            ->join('k.dil','d')
            ->where('k.ustid=0')
            ->orderBy('k.sira','ASC')
            ->getQuery()
            ->getScalarResult();
        foreach ($kategoriler as $kategori){
            $qb = $em->createQueryBuilder();
            $sayfa=$qb->select('s.seo')
                ->from('App:Sayfa', 's')
                ->join('s.dil', 'd')
                ->where('s.dilgrup='.$kategori['sayfaId'].' and d.id='.$kategori['did'])
                ->getQuery()
                ->getScalarResult();

            if ($this->dilSay()>1) {
                $veri .= '<url>
                      <loc>' . $siteyolu .$kategori['dKisa'].'/'.$sayfa[0]['seo'].'/'.$kategori['seourl'].'</loc>
                      <lastmod>' . $suan->format('Y-m-d') . 'T' . $suan->format('H:i:s') . '+00:00</lastmod>
                      <priority>0.80</priority>
                    </url>';
            }else{
                $veri .= '<url> 
                      <loc>' . $siteyolu.$sayfa[0]['seo'].'/'.$kategori['seourl'].'</loc>
                      <lastmod>' . $suan->format('Y-m-d') . 'T' . $suan->format('H:i:s') . '+00:00</lastmod>
                      <priority>0.80</priority>
                    </url>';
            }

            $altKategori = $this->altKategoriListeSiteMap($kategori['dilgrup'],$sayfa[0]['seo'],$kategori['did']);
            $veri .= $altKategori;

        }


        // İçerikler
        $qb = $em->createQueryBuilder();
        $sayfalar=$qb->select('s.id,d.kisa as dKisa,s.seo,s.kategori,s.tekVeri,s.icIcerik,m.tabloAdi,s.dilgrup')
            ->from('App:Sayfa', 's')
            ->join('s.dil', 'd')
            ->join('s.modul', 'm')
            ->where('s.menu=1')
            ->orderBy('s.sira','ASC')
            ->groupBy('s.dilgrup')
            ->getQuery()
            ->getScalarResult();


        foreach ($sayfalar as $sayfa) {
            if($sayfa['kategori']==1){
                $priority='0.70';
            }else{
                $priority='0.80';
            }

            if ($sayfa['tekVeri']==0 and $sayfa['icIcerik']=='1'){

                $qb = $em->createQueryBuilder();
                $icerikler=$qb->select('t.seourl,t.dilgrup,d.kisa as dKisa,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                    ->from('App:'.$sayfa['tabloAdi'], 't')
                    ->leftjoin('t.kategori','k')
                    ->join('t.sayfa','s')
                    ->join('t.dil','d')
                    ->where('s.id='.$sayfa['id'])
                    ->orderBy('t.sira','ASC')
                    ->getQuery()
                    ->getScalarResult();



                foreach ($icerikler as $icerik){
                    $qb = $em->createQueryBuilder();
                    $icSayfa=$qb->select('s.seo')
                        ->from('App:Sayfa', 's')
                        ->join('s.dil', 'd')
                        ->where('s.dilgrup='.$icerik['sayfaId'].' and d.id='.$icerik['did'])
                        ->getQuery()
                        ->getScalarResult();
                    $araLink = '';
                    if($sayfa['kategori']==1){
                        $araLink = $this->altKategoriGeriYaz($icerik['kategoriId'],$icerik['did']);
                    }

                    if ($this->dilSay()>1) {
                        $veri .= '<url>
                          <loc>' . $siteyolu .$icerik['dKisa'].'/'.$icSayfa[0]['seo'].'/'.$araLink.$icerik['seourl'].'</loc>
                          <lastmod>' . $suan->format('Y-m-d') . 'T' . $suan->format('H:i:s') . '+00:00</lastmod>
                          <priority>'.$priority.'</priority>
                        </url>';
                    }else{
                        $veri .= '<url> 
                          <loc>' . $siteyolu.$icSayfa[0]['seo'].'/'.$araLink.$icerik['seourl'].'</loc>
                          <lastmod>' . $suan->format('Y-m-d') . 'T' . $suan->format('H:i:s') . '+00:00</lastmod>
                          <priority>'.$priority.'</priority>
                        </url>';
                    }
                }



            }
        }




        $veri.='</urlset>';

        $response = new Response($veri);
        $response->headers->set('Content-Type', 'xml');

        return $response;
    }

    /**
     * @Route("/", name="site_homepage")
     */
    public function index():Response
    {
        if ($this->dilSay()>1){
            return $this->redirectToRoute('site_homepage_dil',['dil'=>$this->varsayilanDil()['kisa']]);
        }

        if ($this->get('session')->get('dil')=='') {
            $this->get('session')->set('dil', $this->varsayilanDil());
        }
        ////////////////////


        return $this->render('modul/index.html.twig');
    }

    /**
     * @Route("/{dil}", name="site_homepage_dil")
     */
    public function indexDil($dil):Response
    {
        if ($this->dilSay()<2){
            return $this->redirectToRoute('site_homepage');
        }

        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $dill=$qb->select('d.id,d.kisa,d.uzun')
            ->from('App:Dil', 'd')
            ->where("d.kisa='$dil' and d.aktif=1")
            ->orderBy('d.aktif','DESC')
            ->getQuery()
            ->getScalarResult();
        if(count($dill)>0){
            $dil = $dill[0]['id'];
            $this->get('session')->set('dil',$dill[0]);
        }else{
            return $this->redirect($this->ayarlar('siteYolu'));
        }
        //////////////////////




        return $this->render('modul/index.html.twig');
    }

    /**
     * @Route("/{dil}/{seo1}", name="site_sayfa1")
     */
    public function sayfa1($dil,$seo1):Response
    {

        if ($this->dilSay()<2){
            return $this->redirectToRoute('site_homepage');
        }

        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $dill=$qb->select('d.id,d.kisa,d.uzun')
            ->from('App:Dil', 'd')
            ->where("d.kisa='$dil' and d.aktif=1")
            ->orderBy('d.aktif','DESC')
            ->getQuery()
            ->getScalarResult();
        if(count($dill)>0){
            $dil = $dill[0]['id'];
            $this->get('session')->set('dil',$dill[0]);
        }else{
            return $this->redirect($this->ayarlar('siteYolu'));
        }
        //////////////////////

        $em = $this->getDoctrine()->getManager();

        if ($this->get('session')->get('dil') == '') {
            $this->get('session')->set('dil', $this->varsayilanDil());
        }

        $suankiDil = $this->get('session')->get('dil');

        /* if($suankiDil['kisa']!=$dil){
             return $this->redirect($this->ayarlar('siteYolu'));
         }*/


        $qb = $em->createQueryBuilder();
        $sayfa = $qb->select('s.id,s.adi,s.bannerDurum,s.bannerUrl,s.title,s.keywords,s.description,s.dilgrup,s.seo,s.kategori,s.tekVeri,s.icIcerik,m.tabloAdi,m.alan,s.description,m.adi as madi')
            ->from('App:Sayfa', 's')
            ->join('s.dil', 'd')
            ->join('s.modul', 'm')
            ->where("s.seo ='$seo1' and d.id=" . $suankiDil['id'])
            ->orderBy('s.sira', 'ASC')
            ->getQuery()
            ->getScalarResult();


        /*   if(count($sayfa)==0){
               return $this->redirect($this->ayarlar('siteYolu'));
           }*/

        $sayfa = $sayfa[0];
        $sId= $this->IdBul('Sayfa',$sayfa['dilgrup']);

        $sayfaAlan = explode(',', $sayfa['alan']);
        $icerikalani = [];
        foreach ($sayfaAlan as $sA) {
            $icerikalani[] = 't.' . $this->seo(str_replace(' ', '', $sA));
        }


        $view = $this->seo(str_replace(' ', '', $sayfa['madi']));
        $kategoriler = '';
        $icerikler= '';
        //Sayfa
        if($sayfa['kategori']==0){
            $qb = $em->createQueryBuilder();
            $icerikler = $qb->select(implode(',',$icerikalani).',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                ->from('App:' . $sayfa['tabloAdi'], 't')
                ->leftjoin('t.kategori', 'k')
                ->join('t.dil', 'd')
                ->join('t.sayfa', 's')
                ->where("s.id='" .$sId. "' and d.id=" . $suankiDil['id'])
                ->addOrderBy('t.sira', 'ASC')
                ->addOrderBy('t.id', 'DESC')
                ->getQuery()
                ->getScalarResult();
        }else{
            $qb = $em->createQueryBuilder();
            $kategoriler = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId')
                ->from('App:Kategori', 'k')
                ->join('k.dil', 'd')
                ->join('k.sayfa', 's')
                ->where("s.id='" .$sId. "' and k.ustid=0 and d.id=" . $suankiDil['id'])
                ->orderBy('k.sira', 'ASC')
                ->getQuery()
                ->getScalarResult();
        }

        return $this->render('modul/'.$view.'.html.twig',array('sayfa'=>$sayfa,'kategoriler'=>$kategoriler,'icerikler'=>$icerikler));
    }


    /**
     * @Route("/{dil}/{seo1}/{seo2}", name="site_sayfa2")
     */
    public function sayfa2($dil,$seo1,$seo2):Response
    {

        if ($this->dilSay()<2){
            return $this->redirectToRoute('site_homepage');
        }

        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $dill=$qb->select('d.id,d.kisa,d.uzun')
            ->from('App:Dil', 'd')
            ->where("d.kisa='$dil' and d.aktif=1")
            ->orderBy('d.aktif','DESC')
            ->getQuery()
            ->getScalarResult();
        if(count($dill)>0){
            $dil = $dill[0]['id'];
            $this->get('session')->set('dil',$dill[0]);
        }else{
            return $this->redirect($this->ayarlar('siteYolu'));
        }
        //////////////////////
        $em = $this->getDoctrine()->getManager();
        if ($this->get('session')->get('dil') == '') {
            $this->get('session')->set('dil', $this->varsayilanDil());
        }

        $suankiDil = $this->get('session')->get('dil');

        /* if($suankiDil['kisa']!=$dil){
             return $this->redirect($this->ayarlar('siteYolu'));
         }*/


        $qb = $em->createQueryBuilder();
        $sayfa = $qb->select('s.id,s.adi,s.bannerDurum,s.bannerUrl,s.title,s.keywords,s.description,s.dilgrup,s.seo,s.kategori,s.tekVeri,s.icIcerik,m.tabloAdi,m.alan,s.description,m.adi as madi')
            ->from('App:Sayfa', 's')
            ->join('s.dil', 'd')
            ->join('s.modul', 'm')
            ->where("s.seo ='$seo1' and d.id=" . $suankiDil['id'])
            ->orderBy('s.sira', 'ASC')
            ->getQuery()
            ->getScalarResult();


        /*   if(count($sayfa)==0){
               return $this->redirect($this->ayarlar('siteYolu'));
           }*/

        $sayfa = $sayfa[0];
        $sId= $this->IdBul('Sayfa',$sayfa['dilgrup']);

        $sayfaAlan = explode(',', $sayfa['alan']);
        $icerikalani = [];
        foreach ($sayfaAlan as $sA) {
            $icerikalani[] = 't.' . $this->seo(str_replace(' ', '', $sA));
        }


        $view = $this->seo(str_replace(' ', '', $sayfa['madi']));

        if($sayfa['kategori']==0) {
            // Sayfa İçi
            $qb = $em->createQueryBuilder();
            $icerik = $qb->select(implode(',',$icerikalani).',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                ->from('App:' . $sayfa['tabloAdi'], 't')
                ->leftjoin('t.kategori', 'k')
                ->join('t.sayfa', 's')
                ->join('t.dil', 'd')
                ->where("t.seourl='" .$seo2. "' and d.id=" . $suankiDil['id'])
                ->addOrderBy('t.sira', 'ASC')
                ->addOrderBy('t.id', 'DESC')
                ->getQuery()
                ->getScalarResult();
            if(count($icerik)==0){
                return $this->redirect($this->ayarlar('siteYolu'));
            }
            return $this->render('modul/'.$view.'_ic.html.twig',array('sayfa'=>$sayfa,'icerik'=>$icerik[0]));
        } else {

            $qb = $em->createQueryBuilder();
            $kategori = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId,k.id')
                ->from('App:Kategori', 'k')
                ->join('k.sayfa', 's')
                ->join('k.dil', 'd')
                ->where("k.seourl='" .$seo2. "' and d.id=" . $suankiDil['id'])
                ->orderBy('k.sira', 'ASC')
                ->getQuery()
                ->getScalarResult();

            if(count($kategori)==0){


                $qb = $em->createQueryBuilder();
                $kategori = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId,k.id')
                    ->from('App:Kategori', 'k')
                    ->join('k.sayfa', 's')
                    ->join('k.dil', 'd')
                    ->where("k.seourl='" .$seo1. "' and d.id=" . $suankiDil['id'])
                    ->orderBy('k.sira', 'ASC')
                    ->getQuery()
                    ->getScalarResult();

                $kId = $this->IdBul('Kategori',$kategori[0]['dilgrup']);

                $qb = $em->createQueryBuilder();
                $icerik = $qb->select(implode(',', $icerikalani) . ',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                    ->from('App:' . $sayfa['tabloAdi'], 't')
                    ->leftjoin('t.kategori', 'k')
                    ->join('t.sayfa', 's')
                    ->join('t.dil', 'd')
                    ->where("k.id=" . $kId . " and t.seourl='".$seo2."' and d.id=" . $suankiDil['id'])
                    ->addOrderBy('t.sira', 'ASC')
                    ->addOrderBy('t.id', 'DESC')
                    ->getQuery()
                    ->getScalarResult();

                if(count($kategori)<1 and count($icerik)<1){
                    return $this->redirect($this->ayarlar('siteYolu'));
                }

                return $this->render('modul/' . $view . '_ic.html.twig', array('sayfa' => $sayfa, 'kategori' => $kategori[0], 'icerik' => $icerik[0]));

            } else {
                $kId = $this->IdBul('Kategori',$kategori[0]['dilgrup']);

                $qb = $em->createQueryBuilder();
                $kategoriler = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId')
                    ->from('App:Kategori', 'k')
                    ->join('k.sayfa', 's')
                    ->join('k.dil', 'd')
                    ->where("k.ustid=" . $kategori[0]['dilgrup'] . " and d.id=" . $suankiDil['id'])
                    ->orderBy('k.sira', 'ASC')
                    ->getQuery()
                    ->getScalarResult();

                $qb = $em->createQueryBuilder();
                $icerikler = $qb->select(implode(',', $icerikalani) . ',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                    ->from('App:' . $sayfa['tabloAdi'], 't')
                    ->leftjoin('t.kategori', 'k')
                    ->join('t.sayfa', 's')
                    ->join('t.dil', 'd')
                    ->where("k.id=" . $kId . " and d.id=" . $suankiDil['id'])
                    ->addOrderBy('t.sira', 'ASC')
                    ->addOrderBy('t.id', 'DESC')
                    ->getQuery()
                    ->getScalarResult();


                return $this->render('modul/' . $view . '_kategori.html.twig', array('sayfa' => $sayfa, 'kategori' => $kategori[0], 'icerikler' => $icerikler, 'kategoriler' => $kategoriler));

            }
        }


    }



    /**
     * @Route("/{dil}/{seo1}/{seo2}/{seo3}", name="site_sayfa3")
     */
    public function sayfa3($dil,$seo1,$seo2,$seo3):Response
    {

        if ($this->dilSay()<2){
            return $this->redirectToRoute('site_homepage');
        }

        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $dill=$qb->select('d.id,d.kisa,d.uzun')
            ->from('App:Dil', 'd')
            ->where("d.kisa='$dil' and d.aktif=1")
            ->orderBy('d.aktif','DESC')
            ->getQuery()
            ->getScalarResult();
        if(count($dill)>0){
            $dil = $dill[0]['id'];
            $this->get('session')->set('dil',$dill[0]);
        }else{
            return $this->redirect($this->ayarlar('siteYolu'));
        }
        //////////////////////
        $em = $this->getDoctrine()->getManager();
        if ($this->get('session')->get('dil') == '') {
            $this->get('session')->set('dil', $this->varsayilanDil());
        }

        $suankiDil = $this->get('session')->get('dil');

        /* if($suankiDil['kisa']!=$dil){
             return $this->redirect($this->ayarlar('siteYolu'));
         }*/


        $qb = $em->createQueryBuilder();
        $sayfa = $qb->select('s.id,s.adi,s.bannerDurum,s.bannerUrl,s.title,s.keywords,s.description,s.dilgrup,s.seo,s.kategori,s.tekVeri,s.icIcerik,m.tabloAdi,m.alan,s.description,m.adi as madi')
            ->from('App:Sayfa', 's')
            ->join('s.dil', 'd')
            ->join('s.modul', 'm')
            ->where("s.seo ='$seo1' and d.id=" . $suankiDil['id'])
            ->orderBy('s.sira', 'ASC')
            ->getQuery()
            ->getScalarResult();


        /*   if(count($sayfa)==0){
               return $this->redirect($this->ayarlar('siteYolu'));
           }*/

        $sayfa = $sayfa[0];
        $sId= $this->IdBul('Sayfa',$sayfa['dilgrup']);

        $sayfaAlan = explode(',', $sayfa['alan']);
        $icerikalani = [];
        foreach ($sayfaAlan as $sA) {
            $icerikalani[] = 't.' . $this->seo(str_replace(' ', '', $sA));
        }


        $view = $this->seo(str_replace(' ', '', $sayfa['madi']));

        if($sayfa['kategori']==0) {
            // Sayfa İçi
            $qb = $em->createQueryBuilder();
            $icerik = $qb->select(implode(',',$icerikalani).',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                ->from('App:' . $sayfa['tabloAdi'], 't')
                ->leftjoin('t.kategori', 'k')
                ->join('t.sayfa', 's')
                ->join('t.dil', 'd')
                ->where("t.seourl='" .$seo3. "' and d.id=" . $suankiDil['id'])
                ->addOrderBy('t.sira', 'ASC')
                ->addOrderBy('t.id', 'DESC')
                ->getQuery()
                ->getScalarResult();
            if(count($icerik)==0){
                return $this->redirect($this->ayarlar('siteYolu'));
            }
            return $this->render('modul/'.$view.'_ic.html.twig',array('sayfa'=>$sayfa,'icerik'=>$icerik[0]));
        } else {

            $qb = $em->createQueryBuilder();
            $kategori = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId,k.id')
                ->from('App:Kategori', 'k')
                ->join('k.sayfa', 's')
                ->join('k.dil', 'd')
                ->where("k.seourl='" .$seo3. "' and d.id=" . $suankiDil['id'])
                ->orderBy('k.sira', 'ASC')
                ->getQuery()
                ->getScalarResult();

            if(count($kategori)==0){


                $qb = $em->createQueryBuilder();
                $kategori = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId,k.id')
                    ->from('App:Kategori', 'k')
                    ->join('k.sayfa', 's')
                    ->join('k.dil', 'd')
                    ->where("k.seourl='" .$seo2. "' and d.id=" . $suankiDil['id'])
                    ->orderBy('k.sira', 'ASC')
                    ->getQuery()
                    ->getScalarResult();

                $kId = $this->IdBul('Kategori',$kategori[0]['dilgrup']);

                $qb = $em->createQueryBuilder();
                $icerik = $qb->select(implode(',', $icerikalani) . ',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                    ->from('App:' . $sayfa['tabloAdi'], 't')
                    ->leftjoin('t.kategori', 'k')
                    ->join('t.sayfa', 's')
                    ->join('t.dil', 'd')
                    ->where("k.id=" . $kId . " and t.seourl='".$seo3."' and d.id=" . $suankiDil['id'])
                    ->addOrderBy('t.sira', 'ASC')
                    ->addOrderBy('t.id', 'DESC')
                    ->getQuery()
                    ->getScalarResult();

                if(count($kategori)<1 and count($icerik)<1){
                    return $this->redirect($this->ayarlar('siteYolu'));
                }

                return $this->render('modul/' . $view . '_ic.html.twig', array('sayfa' => $sayfa, 'kategori' => $kategori[0], 'icerik' => $icerik[0]));

            } else {
                $kId = $this->IdBul('Kategori',$kategori[0]['dilgrup']);

                $qb = $em->createQueryBuilder();
                $kategoriler = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId')
                    ->from('App:Kategori', 'k')
                    ->join('k.sayfa', 's')
                    ->join('k.dil', 'd')
                    ->where("k.ustid=" . $kategori[0]['dilgrup'] . " and d.id=" . $suankiDil['id'])
                    ->orderBy('k.sira', 'ASC')
                    ->getQuery()
                    ->getScalarResult();

                $qb = $em->createQueryBuilder();
                $icerikler = $qb->select(implode(',', $icerikalani) . ',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                    ->from('App:' . $sayfa['tabloAdi'], 't')
                    ->leftjoin('t.kategori', 'k')
                    ->join('t.sayfa', 's')
                    ->join('t.dil', 'd')
                    ->where("k.id=" . $kId . " and d.id=" . $suankiDil['id'])
                    ->addOrderBy('t.sira', 'ASC')
                    ->addOrderBy('t.id', 'DESC')
                    ->getQuery()
                    ->getScalarResult();


                return $this->render('modul/' . $view . '_kategori.html.twig', array('sayfa' => $sayfa, 'kategori' => $kategori[0], 'icerikler' => $icerikler, 'kategoriler' => $kategoriler));

            }
        }


    }


    /**
     * @Route("/{dil}/{seo1}/{seo2}/{seo3}/{seo4}", name="site_sayfa4")
     */
    public function sayfa4($dil,$seo1,$seo2,$seo3,$seo4):Response
    {

        if ($this->dilSay()<2){
            return $this->redirectToRoute('site_homepage');
        }

        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $dill=$qb->select('d.id,d.kisa,d.uzun')
            ->from('App:Dil', 'd')
            ->where("d.kisa='$dil' and d.aktif=1")
            ->orderBy('d.aktif','DESC')
            ->getQuery()
            ->getScalarResult();
        if(count($dill)>0){
            $dil = $dill[0]['id'];
            $this->get('session')->set('dil',$dill[0]);
        }else{
            return $this->redirect($this->ayarlar('siteYolu'));
        }
        //////////////////////
        $em = $this->getDoctrine()->getManager();
        if ($this->get('session')->get('dil') == '') {
            $this->get('session')->set('dil', $this->varsayilanDil());
        }

        $suankiDil = $this->get('session')->get('dil');

        /* if($suankiDil['kisa']!=$dil){
             return $this->redirect($this->ayarlar('siteYolu'));
         }*/


        $qb = $em->createQueryBuilder();
        $sayfa = $qb->select('s.id,s.adi,s.bannerDurum,s.bannerUrl,s.title,s.keywords,s.description,s.dilgrup,s.seo,s.kategori,s.tekVeri,s.icIcerik,m.tabloAdi,m.alan,s.description,m.adi as madi')
            ->from('App:Sayfa', 's')
            ->join('s.dil', 'd')
            ->join('s.modul', 'm')
            ->where("s.seo ='$seo1' and d.id=" . $suankiDil['id'])
            ->orderBy('s.sira', 'ASC')
            ->getQuery()
            ->getScalarResult();


        /*   if(count($sayfa)==0){
               return $this->redirect($this->ayarlar('siteYolu'));
           }*/

        $sayfa = $sayfa[0];
        $sId= $this->IdBul('Sayfa',$sayfa['dilgrup']);

        $sayfaAlan = explode(',', $sayfa['alan']);
        $icerikalani = [];
        foreach ($sayfaAlan as $sA) {
            $icerikalani[] = 't.' . $this->seo(str_replace(' ', '', $sA));
        }


        $view = $this->seo(str_replace(' ', '', $sayfa['madi']));

        if($sayfa['kategori']==0) {
            // Sayfa İçi
            $qb = $em->createQueryBuilder();
            $icerik = $qb->select(implode(',',$icerikalani).',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                ->from('App:' . $sayfa['tabloAdi'], 't')
                ->leftjoin('t.kategori', 'k')
                ->join('t.sayfa', 's')
                ->join('t.dil', 'd')
                ->where("t.seourl='" .$seo4. "' and d.id=" . $suankiDil['id'])
                ->addOrderBy('t.sira', 'ASC')
                ->addOrderBy('t.id', 'DESC')
                ->getQuery()
                ->getScalarResult();
            if(count($icerik)==0){
                return $this->redirect($this->ayarlar('siteYolu'));
            }
            return $this->render('modul/'.$view.'_ic.html.twig',array('sayfa'=>$sayfa,'icerik'=>$icerik[0]));
        } else {

            $qb = $em->createQueryBuilder();
            $kategori = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId,k.id')
                ->from('App:Kategori', 'k')
                ->join('k.sayfa', 's')
                ->join('k.dil', 'd')
                ->where("k.seourl='" .$seo4. "' and d.id=" . $suankiDil['id'])
                ->orderBy('k.sira', 'ASC')
                ->getQuery()
                ->getScalarResult();

            if(count($kategori)==0){


                $qb = $em->createQueryBuilder();
                $kategori = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId,k.id')
                    ->from('App:Kategori', 'k')
                    ->join('k.sayfa', 's')
                    ->join('k.dil', 'd')
                    ->where("k.seourl='" .$seo3. "' and d.id=" . $suankiDil['id'])
                    ->orderBy('k.sira', 'ASC')
                    ->getQuery()
                    ->getScalarResult();

                $kId = $this->IdBul('Kategori',$kategori[0]['dilgrup']);

                $qb = $em->createQueryBuilder();
                $icerik = $qb->select(implode(',', $icerikalani) . ',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                    ->from('App:' . $sayfa['tabloAdi'], 't')
                    ->leftjoin('t.kategori', 'k')
                    ->join('t.sayfa', 's')
                    ->join('t.dil', 'd')
                    ->where("k.id=" . $kId . " and t.seourl='".$seo4."' and d.id=" . $suankiDil['id'])
                    ->addOrderBy('t.sira', 'ASC')
                    ->addOrderBy('t.id', 'DESC')
                    ->getQuery()
                    ->getScalarResult();

                if(count($kategori)<1 and count($icerik)<1){
                    return $this->redirect($this->ayarlar('siteYolu'));
                }

                return $this->render('modul/' . $view . '_ic.html.twig', array('sayfa' => $sayfa, 'kategori' => $kategori[0], 'icerik' => $icerik[0]));

            } else {
                $kId = $this->IdBul('Kategori',$kategori[0]['dilgrup']);

                $qb = $em->createQueryBuilder();
                $kategoriler = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId')
                    ->from('App:Kategori', 'k')
                    ->join('k.sayfa', 's')
                    ->join('k.dil', 'd')
                    ->where("k.ustid=" . $kategori[0]['dilgrup'] . " and d.id=" . $suankiDil['id'])
                    ->orderBy('k.sira', 'ASC')
                    ->getQuery()
                    ->getScalarResult();

                $qb = $em->createQueryBuilder();
                $icerikler = $qb->select(implode(',', $icerikalani) . ',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                    ->from('App:' . $sayfa['tabloAdi'], 't')
                    ->leftjoin('t.kategori', 'k')
                    ->join('t.sayfa', 's')
                    ->join('t.dil', 'd')
                    ->where("k.id=" . $kId . " and d.id=" . $suankiDil['id'])
                    ->addOrderBy('t.sira', 'ASC')
                    ->addOrderBy('t.id', 'DESC')
                    ->getQuery()
                    ->getScalarResult();


                return $this->render('modul/' . $view . '_kategori.html.twig', array('sayfa' => $sayfa, 'kategori' => $kategori[0], 'icerikler' => $icerikler, 'kategoriler' => $kategoriler));

            }
        }


    }


    /**
     * @Route("/{dil}/{seo1}/{seo2}/{seo3}/{seo4}/{seo5}", name="site_sayfa5")
     */
    public function sayfa5($dil,$seo1,$seo2,$seo3,$seo4,$seo5):Response
    {

        if ($this->dilSay()<2){
            return $this->redirectToRoute('site_homepage');
        }

        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $dill=$qb->select('d.id,d.kisa,d.uzun')
            ->from('App:Dil', 'd')
            ->where("d.kisa='$dil' and d.aktif=1")
            ->orderBy('d.aktif','DESC')
            ->getQuery()
            ->getScalarResult();
        if(count($dill)>0){
            $dil = $dill[0]['id'];
            $this->get('session')->set('dil',$dill[0]);
        }else{
            return $this->redirect($this->ayarlar('siteYolu'));
        }
        //////////////////////
        $em = $this->getDoctrine()->getManager();
        if ($this->get('session')->get('dil') == '') {
            $this->get('session')->set('dil', $this->varsayilanDil());
        }

        $suankiDil = $this->get('session')->get('dil');

        /* if($suankiDil['kisa']!=$dil){
             return $this->redirect($this->ayarlar('siteYolu'));
         }*/


        $qb = $em->createQueryBuilder();
        $sayfa = $qb->select('s.id,s.adi,s.bannerDurum,s.bannerUrl,s.title,s.keywords,s.description,s.dilgrup,s.seo,s.kategori,s.tekVeri,s.icIcerik,m.tabloAdi,m.alan,s.description,m.adi as madi')
            ->from('App:Sayfa', 's')
            ->join('s.dil', 'd')
            ->join('s.modul', 'm')
            ->where("s.seo ='$seo1' and d.id=" . $suankiDil['id'])
            ->orderBy('s.sira', 'ASC')
            ->getQuery()
            ->getScalarResult();


        /*   if(count($sayfa)==0){
               return $this->redirect($this->ayarlar('siteYolu'));
           }*/

        $sayfa = $sayfa[0];
        $sId= $this->IdBul('Sayfa',$sayfa['dilgrup']);

        $sayfaAlan = explode(',', $sayfa['alan']);
        $icerikalani = [];
        foreach ($sayfaAlan as $sA) {
            $icerikalani[] = 't.' . $this->seo(str_replace(' ', '', $sA));
        }


        $view = $this->seo(str_replace(' ', '', $sayfa['madi']));

        if($sayfa['kategori']==0) {
            // Sayfa İçi
            $qb = $em->createQueryBuilder();
            $icerik = $qb->select(implode(',',$icerikalani).',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                ->from('App:' . $sayfa['tabloAdi'], 't')
                ->leftjoin('t.kategori', 'k')
                ->join('t.sayfa', 's')
                ->join('t.dil', 'd')
                ->where("t.seourl='" .$seo5. "' and d.id=" . $suankiDil['id'])
                ->addOrderBy('t.sira', 'ASC')
                ->addOrderBy('t.id', 'DESC')
                ->getQuery()
                ->getScalarResult();
            if(count($icerik)==0){
                return $this->redirect($this->ayarlar('siteYolu'));
            }
            return $this->render('modul/'.$view.'_ic.html.twig',array('sayfa'=>$sayfa,'icerik'=>$icerik[0]));
        } else {

            $qb = $em->createQueryBuilder();
            $kategori = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId,k.id')
                ->from('App:Kategori', 'k')
                ->join('k.sayfa', 's')
                ->join('k.dil', 'd')
                ->where("k.seourl='" .$seo5. "' and d.id=" . $suankiDil['id'])
                ->orderBy('k.sira', 'ASC')
                ->getQuery()
                ->getScalarResult();

            if(count($kategori)==0){


                $qb = $em->createQueryBuilder();
                $kategori = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId,k.id')
                    ->from('App:Kategori', 'k')
                    ->join('k.sayfa', 's')
                    ->join('k.dil', 'd')
                    ->where("k.seourl='" .$seo4. "' and d.id=" . $suankiDil['id'])
                    ->orderBy('k.sira', 'ASC')
                    ->getQuery()
                    ->getScalarResult();

                $kId = $this->IdBul('Kategori',$kategori[0]['dilgrup']);

                $qb = $em->createQueryBuilder();
                $icerik = $qb->select(implode(',', $icerikalani) . ',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                    ->from('App:' . $sayfa['tabloAdi'], 't')
                    ->leftjoin('t.kategori', 'k')
                    ->join('t.sayfa', 's')
                    ->join('t.dil', 'd')
                    ->where("k.id=" . $kId . " and t.seourl='".$seo5."' and d.id=" . $suankiDil['id'])
                    ->addOrderBy('t.sira', 'ASC')
                    ->addOrderBy('t.id', 'DESC')
                    ->getQuery()
                    ->getScalarResult();

                if(count($kategori)<1 and count($icerik)<1){
                    return $this->redirect($this->ayarlar('siteYolu'));
                }

                return $this->render('modul/' . $view . '_ic.html.twig', array('sayfa' => $sayfa, 'kategori' => $kategori[0], 'icerik' => $icerik[0]));

            } else {
                $kId = $this->IdBul('Kategori',$kategori[0]['dilgrup']);

                $qb = $em->createQueryBuilder();
                $kategoriler = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId')
                    ->from('App:Kategori', 'k')
                    ->join('k.sayfa', 's')
                    ->join('k.dil', 'd')
                    ->where("k.ustid=" . $kategori[0]['dilgrup'] . " and d.id=" . $suankiDil['id'])
                    ->orderBy('k.sira', 'ASC')
                    ->getQuery()
                    ->getScalarResult();

                $qb = $em->createQueryBuilder();
                $icerikler = $qb->select(implode(',', $icerikalani) . ',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                    ->from('App:' . $sayfa['tabloAdi'], 't')
                    ->leftjoin('t.kategori', 'k')
                    ->join('t.sayfa', 's')
                    ->join('t.dil', 'd')
                    ->where("k.id=" . $kId . " and d.id=" . $suankiDil['id'])
                    ->addOrderBy('t.sira', 'ASC')
                    ->addOrderBy('t.id', 'DESC')
                    ->getQuery()
                    ->getScalarResult();


                return $this->render('modul/' . $view . '_kategori.html.twig', array('sayfa' => $sayfa, 'kategori' => $kategori[0], 'icerikler' => $icerikler, 'kategoriler' => $kategoriler));

            }
        }


    }


    /**
     * @Route("/{dil}/{seo1}/{seo2}/{seo3}/{seo4}/{seo5}/{seo6}", name="site_sayfa6")
     */
    public function sayfa6($dil,$seo1,$seo2,$seo3,$seo4,$seo5,$seo6):Response
    {

        if ($this->dilSay()<2){
            return $this->redirectToRoute('site_homepage');
        }

        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $dill=$qb->select('d.id,d.kisa,d.uzun')
            ->from('App:Dil', 'd')
            ->where("d.kisa='$dil' and d.aktif=1")
            ->orderBy('d.aktif','DESC')
            ->getQuery()
            ->getScalarResult();
        if(count($dill)>0){
            $dil = $dill[0]['id'];
            $this->get('session')->set('dil',$dill[0]);
        }else{
            return $this->redirect($this->ayarlar('siteYolu'));
        }
        //////////////////////
        $em = $this->getDoctrine()->getManager();
        if ($this->get('session')->get('dil') == '') {
            $this->get('session')->set('dil', $this->varsayilanDil());
        }

        $suankiDil = $this->get('session')->get('dil');

        /* if($suankiDil['kisa']!=$dil){
             return $this->redirect($this->ayarlar('siteYolu'));
         }*/


        $qb = $em->createQueryBuilder();
        $sayfa = $qb->select('s.id,s.adi,s.bannerDurum,s.bannerUrl,s.title,s.keywords,s.description,s.dilgrup,s.seo,s.kategori,s.tekVeri,s.icIcerik,m.tabloAdi,m.alan,s.description,m.adi as madi')
            ->from('App:Sayfa', 's')
            ->join('s.dil', 'd')
            ->join('s.modul', 'm')
            ->where("s.seo ='$seo1' and d.id=" . $suankiDil['id'])
            ->orderBy('s.sira', 'ASC')
            ->getQuery()
            ->getScalarResult();


        /*   if(count($sayfa)==0){
               return $this->redirect($this->ayarlar('siteYolu'));
           }*/

        $sayfa = $sayfa[0];
        $sId= $this->IdBul('Sayfa',$sayfa['dilgrup']);

        $sayfaAlan = explode(',', $sayfa['alan']);
        $icerikalani = [];
        foreach ($sayfaAlan as $sA) {
            $icerikalani[] = 't.' . $this->seo(str_replace(' ', '', $sA));
        }


        $view = $this->seo(str_replace(' ', '', $sayfa['madi']));

        if($sayfa['kategori']==0) {
            // Sayfa İçi
            $qb = $em->createQueryBuilder();
            $icerik = $qb->select(implode(',',$icerikalani).',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                ->from('App:' . $sayfa['tabloAdi'], 't')
                ->leftjoin('t.kategori', 'k')
                ->join('t.sayfa', 's')
                ->join('t.dil', 'd')
                ->where("t.seourl='" .$seo6. "' and d.id=" . $suankiDil['id'])
                ->addOrderBy('t.sira', 'ASC')
                ->addOrderBy('t.id', 'DESC')
                ->getQuery()
                ->getScalarResult();
            if(count($icerik)==0){
                return $this->redirect($this->ayarlar('siteYolu'));
            }
            return $this->render('modul/'.$view.'_ic.html.twig',array('sayfa'=>$sayfa,'icerik'=>$icerik[0]));
        } else {

            $qb = $em->createQueryBuilder();
            $kategori = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId,k.id')
                ->from('App:Kategori', 'k')
                ->join('k.sayfa', 's')
                ->join('k.dil', 'd')
                ->where("k.seourl='" .$seo6. "' and d.id=" . $suankiDil['id'])
                ->orderBy('k.sira', 'ASC')
                ->getQuery()
                ->getScalarResult();

            if(count($kategori)==0){


                $qb = $em->createQueryBuilder();
                $kategori = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId,k.id')
                    ->from('App:Kategori', 'k')
                    ->join('k.sayfa', 's')
                    ->join('k.dil', 'd')
                    ->where("k.seourl='" .$seo5. "' and d.id=" . $suankiDil['id'])
                    ->orderBy('k.sira', 'ASC')
                    ->getQuery()
                    ->getScalarResult();

                $kId = $this->IdBul('Kategori',$kategori[0]['dilgrup']);

                $qb = $em->createQueryBuilder();
                $icerik = $qb->select(implode(',', $icerikalani) . ',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                    ->from('App:' . $sayfa['tabloAdi'], 't')
                    ->leftjoin('t.kategori', 'k')
                    ->join('t.sayfa', 's')
                    ->join('t.dil', 'd')
                    ->where("k.id=" . $kId . " and t.seourl='".$seo6."' and d.id=" . $suankiDil['id'])
                    ->addOrderBy('t.sira', 'ASC')
                    ->addOrderBy('t.id', 'DESC')
                    ->getQuery()
                    ->getScalarResult();

                if(count($kategori)<1 and count($icerik)<1){
                    return $this->redirect($this->ayarlar('siteYolu'));
                }

                return $this->render('modul/' . $view . '_ic.html.twig', array('sayfa' => $sayfa, 'kategori' => $kategori[0], 'icerik' => $icerik[0]));

            } else {
                $kId = $this->IdBul('Kategori',$kategori[0]['dilgrup']);

                $qb = $em->createQueryBuilder();
                $kategoriler = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId')
                    ->from('App:Kategori', 'k')
                    ->join('k.sayfa', 's')
                    ->join('k.dil', 'd')
                    ->where("k.ustid=" . $kategori[0]['dilgrup'] . " and d.id=" . $suankiDil['id'])
                    ->orderBy('k.sira', 'ASC')
                    ->getQuery()
                    ->getScalarResult();

                $qb = $em->createQueryBuilder();
                $icerikler = $qb->select(implode(',', $icerikalani) . ',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                    ->from('App:' . $sayfa['tabloAdi'], 't')
                    ->leftjoin('t.kategori', 'k')
                    ->join('t.sayfa', 's')
                    ->join('t.dil', 'd')
                    ->where("k.id=" . $kId . " and d.id=" . $suankiDil['id'])
                    ->addOrderBy('t.sira', 'ASC')
                    ->addOrderBy('t.id', 'DESC')
                    ->getQuery()
                    ->getScalarResult();


                return $this->render('modul/' . $view . '_kategori.html.twig', array('sayfa' => $sayfa, 'kategori' => $kategori[0], 'icerikler' => $icerikler, 'kategoriler' => $kategoriler));

            }
        }


    }



    /**
     * @Route("/{dil}/{seo1}/{seo2}/{seo3}/{seo4}/{seo5}/{seo6}/{seo7}", name="site_sayfa7")
     */
    public function sayfa7($dil,$seo1,$seo2,$seo3,$seo4,$seo5,$seo6,$seo7):Response
    {

        if ($this->dilSay()<2){
            return $this->redirectToRoute('site_homepage');
        }

        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $dill=$qb->select('d.id,d.kisa,d.uzun')
            ->from('App:Dil', 'd')
            ->where("d.kisa='$dil' and d.aktif=1")
            ->orderBy('d.aktif','DESC')
            ->getQuery()
            ->getScalarResult();
        if(count($dill)>0){
            $dil = $dill[0]['id'];
            $this->get('session')->set('dil',$dill[0]);
        }else{
            return $this->redirect($this->ayarlar('siteYolu'));
        }
        //////////////////////
        $em = $this->getDoctrine()->getManager();
        if ($this->get('session')->get('dil') == '') {
            $this->get('session')->set('dil', $this->varsayilanDil());
        }

        $suankiDil = $this->get('session')->get('dil');

        /* if($suankiDil['kisa']!=$dil){
             return $this->redirect($this->ayarlar('siteYolu'));
         }*/


        $qb = $em->createQueryBuilder();
        $sayfa = $qb->select('s.id,s.adi,s.bannerDurum,s.bannerUrl,s.title,s.keywords,s.description,s.dilgrup,s.seo,s.kategori,s.tekVeri,s.icIcerik,m.tabloAdi,m.alan,s.description,m.adi as madi')
            ->from('App:Sayfa', 's')
            ->join('s.dil', 'd')
            ->join('s.modul', 'm')
            ->where("s.seo ='$seo1' and d.id=" . $suankiDil['id'])
            ->orderBy('s.sira', 'ASC')
            ->getQuery()
            ->getScalarResult();


        /*   if(count($sayfa)==0){
               return $this->redirect($this->ayarlar('siteYolu'));
           }*/

        $sayfa = $sayfa[0];
        $sId= $this->IdBul('Sayfa',$sayfa['dilgrup']);

        $sayfaAlan = explode(',', $sayfa['alan']);
        $icerikalani = [];
        foreach ($sayfaAlan as $sA) {
            $icerikalani[] = 't.' . $this->seo(str_replace(' ', '', $sA));
        }


        $view = $this->seo(str_replace(' ', '', $sayfa['madi']));

        if($sayfa['kategori']==0) {
            // Sayfa İçi
            $qb = $em->createQueryBuilder();
            $icerik = $qb->select(implode(',',$icerikalani).',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                ->from('App:' . $sayfa['tabloAdi'], 't')
                ->leftjoin('t.kategori', 'k')
                ->join('t.sayfa', 's')
                ->join('t.dil', 'd')
                ->where("t.seourl='" .$seo7. "' and d.id=" . $suankiDil['id'])
                ->addOrderBy('t.sira', 'ASC')
                ->addOrderBy('t.id', 'DESC')
                ->getQuery()
                ->getScalarResult();
            if(count($icerik)==0){
                return $this->redirect($this->ayarlar('siteYolu'));
            }
            return $this->render('modul/'.$view.'_ic.html.twig',array('sayfa'=>$sayfa,'icerik'=>$icerik[0]));
        } else {

            $qb = $em->createQueryBuilder();
            $kategori = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId,k.id')
                ->from('App:Kategori', 'k')
                ->join('k.sayfa', 's')
                ->join('k.dil', 'd')
                ->where("k.seourl='" .$seo7. "' and d.id=" . $suankiDil['id'])
                ->orderBy('k.sira', 'ASC')
                ->getQuery()
                ->getScalarResult();

            if(count($kategori)==0){


                $qb = $em->createQueryBuilder();
                $kategori = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId,k.id')
                    ->from('App:Kategori', 'k')
                    ->join('k.sayfa', 's')
                    ->join('k.dil', 'd')
                    ->where("k.seourl='" .$seo6. "' and d.id=" . $suankiDil['id'])
                    ->orderBy('k.sira', 'ASC')
                    ->getQuery()
                    ->getScalarResult();

                $kId = $this->IdBul('Kategori',$kategori[0]['dilgrup']);

                $qb = $em->createQueryBuilder();
                $icerik = $qb->select(implode(',', $icerikalani) . ',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                    ->from('App:' . $sayfa['tabloAdi'], 't')
                    ->leftjoin('t.kategori', 'k')
                    ->join('t.sayfa', 's')
                    ->join('t.dil', 'd')
                    ->where("k.id=" . $kId . " and t.seourl='".$seo7."' and d.id=" . $suankiDil['id'])
                    ->addOrderBy('t.sira', 'ASC')
                    ->addOrderBy('t.id', 'DESC')
                    ->getQuery()
                    ->getScalarResult();

                if(count($kategori)<1 and count($icerik)<1){
                    return $this->redirect($this->ayarlar('siteYolu'));
                }

                return $this->render('modul/' . $view . '_ic.html.twig', array('sayfa' => $sayfa, 'kategori' => $kategori[0], 'icerik' => $icerik[0]));

            } else {
                $kId = $this->IdBul('Kategori',$kategori[0]['dilgrup']);

                $qb = $em->createQueryBuilder();
                $kategoriler = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId')
                    ->from('App:Kategori', 'k')
                    ->join('k.sayfa', 's')
                    ->join('k.dil', 'd')
                    ->where("k.ustid=" . $kategori[0]['dilgrup'] . " and d.id=" . $suankiDil['id'])
                    ->orderBy('k.sira', 'ASC')
                    ->getQuery()
                    ->getScalarResult();

                $qb = $em->createQueryBuilder();
                $icerikler = $qb->select(implode(',', $icerikalani) . ',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                    ->from('App:' . $sayfa['tabloAdi'], 't')
                    ->leftjoin('t.kategori', 'k')
                    ->join('t.sayfa', 's')
                    ->join('t.dil', 'd')
                    ->where("k.id=" . $kId . " and d.id=" . $suankiDil['id'])
                    ->addOrderBy('t.sira', 'ASC')
                    ->addOrderBy('t.id', 'DESC')
                    ->getQuery()
                    ->getScalarResult();


                return $this->render('modul/' . $view . '_kategori.html.twig', array('sayfa' => $sayfa, 'kategori' => $kategori[0], 'icerikler' => $icerikler, 'kategoriler' => $kategoriler));

            }
        }


    }



    /**
     * @Route("/{dil}/{seo1}/{seo2}/{seo3}/{seo4}/{seo5}/{seo6}/{seo7}/{seo8}", name="site_sayfa8")
     */
    public function sayfa8($dil,$seo1,$seo2,$seo3,$seo4,$seo5,$seo6,$seo7,$seo8):Response
    {

        if ($this->dilSay()<2){
            return $this->redirectToRoute('site_homepage');
        }

        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $dill=$qb->select('d.id,d.kisa,d.uzun')
            ->from('App:Dil', 'd')
            ->where("d.kisa='$dil' and d.aktif=1")
            ->orderBy('d.aktif','DESC')
            ->getQuery()
            ->getScalarResult();
        if(count($dill)>0){
            $dil = $dill[0]['id'];
            $this->get('session')->set('dil',$dill[0]);
        }else{
            return $this->redirect($this->ayarlar('siteYolu'));
        }
        //////////////////////
        $em = $this->getDoctrine()->getManager();
        if ($this->get('session')->get('dil') == '') {
            $this->get('session')->set('dil', $this->varsayilanDil());
        }

        $suankiDil = $this->get('session')->get('dil');

        /* if($suankiDil['kisa']!=$dil){
             return $this->redirect($this->ayarlar('siteYolu'));
         }*/


        $qb = $em->createQueryBuilder();
        $sayfa = $qb->select('s.id,s.adi,s.bannerDurum,s.bannerUrl,s.title,s.keywords,s.description,s.dilgrup,s.seo,s.kategori,s.tekVeri,s.icIcerik,m.tabloAdi,m.alan,s.description,m.adi as madi')
            ->from('App:Sayfa', 's')
            ->join('s.dil', 'd')
            ->join('s.modul', 'm')
            ->where("s.seo ='$seo1' and d.id=" . $suankiDil['id'])
            ->orderBy('s.sira', 'ASC')
            ->getQuery()
            ->getScalarResult();


        /*   if(count($sayfa)==0){
               return $this->redirect($this->ayarlar('siteYolu'));
           }*/

        $sayfa = $sayfa[0];
        $sId= $this->IdBul('Sayfa',$sayfa['dilgrup']);

        $sayfaAlan = explode(',', $sayfa['alan']);
        $icerikalani = [];
        foreach ($sayfaAlan as $sA) {
            $icerikalani[] = 't.' . $this->seo(str_replace(' ', '', $sA));
        }


        $view = $this->seo(str_replace(' ', '', $sayfa['madi']));

        if($sayfa['kategori']==0) {
            // Sayfa İçi
            $qb = $em->createQueryBuilder();
            $icerik = $qb->select(implode(',',$icerikalani).',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                ->from('App:' . $sayfa['tabloAdi'], 't')
                ->leftjoin('t.kategori', 'k')
                ->join('t.sayfa', 's')
                ->join('t.dil', 'd')
                ->where("t.seourl='" .$seo8. "' and d.id=" . $suankiDil['id'])
                ->addOrderBy('t.sira', 'ASC')
                ->addOrderBy('t.id', 'DESC')
                ->getQuery()
                ->getScalarResult();
            if(count($icerik)==0){
                return $this->redirect($this->ayarlar('siteYolu'));
            }
            return $this->render('modul/'.$view.'_ic.html.twig',array('sayfa'=>$sayfa,'icerik'=>$icerik[0]));
        } else {

            $qb = $em->createQueryBuilder();
            $kategori = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId,k.id')
                ->from('App:Kategori', 'k')
                ->join('k.sayfa', 's')
                ->join('k.dil', 'd')
                ->where("k.seourl='" .$seo8. "' and d.id=" . $suankiDil['id'])
                ->orderBy('k.sira', 'ASC')
                ->getQuery()
                ->getScalarResult();

            if(count($kategori)==0){


                $qb = $em->createQueryBuilder();
                $kategori = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId,k.id')
                    ->from('App:Kategori', 'k')
                    ->join('k.sayfa', 's')
                    ->join('k.dil', 'd')
                    ->where("k.seourl='" .$seo7. "' and d.id=" . $suankiDil['id'])
                    ->orderBy('k.sira', 'ASC')
                    ->getQuery()
                    ->getScalarResult();

                $kId = $this->IdBul('Kategori',$kategori[0]['dilgrup']);

                $qb = $em->createQueryBuilder();
                $icerik = $qb->select(implode(',', $icerikalani) . ',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                    ->from('App:' . $sayfa['tabloAdi'], 't')
                    ->leftjoin('t.kategori', 'k')
                    ->join('t.sayfa', 's')
                    ->join('t.dil', 'd')
                    ->where("k.id=" . $kId . " and t.seourl='".$seo8."' and d.id=" . $suankiDil['id'])
                    ->addOrderBy('t.sira', 'ASC')
                    ->addOrderBy('t.id', 'DESC')
                    ->getQuery()
                    ->getScalarResult();

                if(count($kategori)<1 and count($icerik)<1){
                    return $this->redirect($this->ayarlar('siteYolu'));
                }

                return $this->render('modul/' . $view . '_ic.html.twig', array('sayfa' => $sayfa, 'kategori' => $kategori[0], 'icerik' => $icerik[0]));

            } else {
                $kId = $this->IdBul('Kategori',$kategori[0]['dilgrup']);

                $qb = $em->createQueryBuilder();
                $kategoriler = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId')
                    ->from('App:Kategori', 'k')
                    ->join('k.sayfa', 's')
                    ->join('k.dil', 'd')
                    ->where("k.ustid=" . $kategori[0]['dilgrup'] . " and d.id=" . $suankiDil['id'])
                    ->orderBy('k.sira', 'ASC')
                    ->getQuery()
                    ->getScalarResult();

                $qb = $em->createQueryBuilder();
                $icerikler = $qb->select(implode(',', $icerikalani) . ',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                    ->from('App:' . $sayfa['tabloAdi'], 't')
                    ->leftjoin('t.kategori', 'k')
                    ->join('t.sayfa', 's')
                    ->join('t.dil', 'd')
                    ->where("k.id=" . $kId . " and d.id=" . $suankiDil['id'])
                    ->addOrderBy('t.sira', 'ASC')
                    ->addOrderBy('t.id', 'DESC')
                    ->getQuery()
                    ->getScalarResult();


                return $this->render('modul/' . $view . '_kategori.html.twig', array('sayfa' => $sayfa, 'kategori' => $kategori[0], 'icerikler' => $icerikler, 'kategoriler' => $kategoriler));

            }
        }


    }



    /**
     * @Route("/{dil}/{seo1}/{seo2}/{seo3}/{seo4}/{seo5}/{seo6}/{seo7}/{seo8}/{seo9}", name="site_sayfa9")
     */
    public function sayfa9($dil,$seo1,$seo2,$seo3,$seo4,$seo5,$seo6,$seo7,$seo8,$seo9):Response
    {

        if ($this->dilSay()<2){
            return $this->redirectToRoute('site_homepage');
        }

        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $dill=$qb->select('d.id,d.kisa,d.uzun')
            ->from('App:Dil', 'd')
            ->where("d.kisa='$dil' and d.aktif=1")
            ->orderBy('d.aktif','DESC')
            ->getQuery()
            ->getScalarResult();
        if(count($dill)>0){
            $dil = $dill[0]['id'];
            $this->get('session')->set('dil',$dill[0]);
        }else{
            return $this->redirect($this->ayarlar('siteYolu'));
        }
        //////////////////////
        $em = $this->getDoctrine()->getManager();
        if ($this->get('session')->get('dil') == '') {
            $this->get('session')->set('dil', $this->varsayilanDil());
        }

        $suankiDil = $this->get('session')->get('dil');

        /* if($suankiDil['kisa']!=$dil){
             return $this->redirect($this->ayarlar('siteYolu'));
         }*/


        $qb = $em->createQueryBuilder();
        $sayfa = $qb->select('s.id,s.adi,s.bannerDurum,s.bannerUrl,s.title,s.keywords,s.description,s.dilgrup,s.seo,s.kategori,s.tekVeri,s.icIcerik,m.tabloAdi,m.alan,s.description,m.adi as madi')
            ->from('App:Sayfa', 's')
            ->join('s.dil', 'd')
            ->join('s.modul', 'm')
            ->where("s.seo ='$seo1' and d.id=" . $suankiDil['id'])
            ->orderBy('s.sira', 'ASC')
            ->getQuery()
            ->getScalarResult();


        /*   if(count($sayfa)==0){
               return $this->redirect($this->ayarlar('siteYolu'));
           }*/

        $sayfa = $sayfa[0];
        $sId= $this->IdBul('Sayfa',$sayfa['dilgrup']);

        $sayfaAlan = explode(',', $sayfa['alan']);
        $icerikalani = [];
        foreach ($sayfaAlan as $sA) {
            $icerikalani[] = 't.' . $this->seo(str_replace(' ', '', $sA));
        }


        $view = $this->seo(str_replace(' ', '', $sayfa['madi']));

        if($sayfa['kategori']==0) {
            // Sayfa İçi
            $qb = $em->createQueryBuilder();
            $icerik = $qb->select(implode(',',$icerikalani).',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                ->from('App:' . $sayfa['tabloAdi'], 't')
                ->leftjoin('t.kategori', 'k')
                ->join('t.sayfa', 's')
                ->join('t.dil', 'd')
                ->where("t.seourl='" .$seo9. "' and d.id=" . $suankiDil['id'])
                ->addOrderBy('t.sira', 'ASC')
                ->addOrderBy('t.id', 'DESC')
                ->getQuery()
                ->getScalarResult();
            if(count($icerik)==0){
                return $this->redirect($this->ayarlar('siteYolu'));
            }
            return $this->render('modul/'.$view.'_ic.html.twig',array('sayfa'=>$sayfa,'icerik'=>$icerik[0]));
        } else {

            $qb = $em->createQueryBuilder();
            $kategori = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId,k.id')
                ->from('App:Kategori', 'k')
                ->join('k.sayfa', 's')
                ->join('k.dil', 'd')
                ->where("k.seourl='" .$seo9. "' and d.id=" . $suankiDil['id'])
                ->orderBy('k.sira', 'ASC')
                ->getQuery()
                ->getScalarResult();

            if(count($kategori)==0){


                $qb = $em->createQueryBuilder();
                $kategori = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId,k.id')
                    ->from('App:Kategori', 'k')
                    ->join('k.sayfa', 's')
                    ->join('k.dil', 'd')
                    ->where("k.seourl='" .$seo8. "' and d.id=" . $suankiDil['id'])
                    ->orderBy('k.sira', 'ASC')
                    ->getQuery()
                    ->getScalarResult();

                $kId = $this->IdBul('Kategori',$kategori[0]['dilgrup']);

                $qb = $em->createQueryBuilder();
                $icerik = $qb->select(implode(',', $icerikalani) . ',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                    ->from('App:' . $sayfa['tabloAdi'], 't')
                    ->leftjoin('t.kategori', 'k')
                    ->join('t.sayfa', 's')
                    ->join('t.dil', 'd')
                    ->where("k.id=" . $kId . " and t.seourl='".$seo9."' and d.id=" . $suankiDil['id'])
                    ->addOrderBy('t.sira', 'ASC')
                    ->addOrderBy('t.id', 'DESC')
                    ->getQuery()
                    ->getScalarResult();

                if(count($kategori)<1 and count($icerik)<1){
                    return $this->redirect($this->ayarlar('siteYolu'));
                }

                return $this->render('modul/' . $view . '_ic.html.twig', array('sayfa' => $sayfa, 'kategori' => $kategori[0], 'icerik' => $icerik[0]));

            } else {
                $kId = $this->IdBul('Kategori',$kategori[0]['dilgrup']);

                $qb = $em->createQueryBuilder();
                $kategoriler = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId')
                    ->from('App:Kategori', 'k')
                    ->join('k.sayfa', 's')
                    ->join('k.dil', 'd')
                    ->where("k.ustid=" . $kategori[0]['dilgrup'] . " and d.id=" . $suankiDil['id'])
                    ->orderBy('k.sira', 'ASC')
                    ->getQuery()
                    ->getScalarResult();

                $qb = $em->createQueryBuilder();
                $icerikler = $qb->select(implode(',', $icerikalani) . ',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                    ->from('App:' . $sayfa['tabloAdi'], 't')
                    ->leftjoin('t.kategori', 'k')
                    ->join('t.sayfa', 's')
                    ->join('t.dil', 'd')
                    ->where("k.id=" . $kId . " and d.id=" . $suankiDil['id'])
                    ->addOrderBy('t.sira', 'ASC')
                    ->addOrderBy('t.id', 'DESC')
                    ->getQuery()
                    ->getScalarResult();


                return $this->render('modul/' . $view . '_kategori.html.twig', array('sayfa' => $sayfa, 'kategori' => $kategori[0], 'icerikler' => $icerikler, 'kategoriler' => $kategoriler));

            }
        }


    }




    /**
     * @Route("/{dil}/{seo1}/{seo2}/{seo3}/{seo4}/{seo5}/{seo6}/{seo7}/{seo8}/{seo9}/{seo10}", name="site_sayfa10")
     */
    public function sayfa10($dil,$seo1,$seo2,$seo3,$seo4,$seo5,$seo6,$seo7,$seo8,$seo9,$seo10):Response
    {

        if ($this->dilSay()<2){
            return $this->redirectToRoute('site_homepage');
        }

        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $dill=$qb->select('d.id,d.kisa,d.uzun')
            ->from('App:Dil', 'd')
            ->where("d.kisa='$dil' and d.aktif=1")
            ->orderBy('d.aktif','DESC')
            ->getQuery()
            ->getScalarResult();
        if(count($dill)>0){
            $dil = $dill[0]['id'];
            $this->get('session')->set('dil',$dill[0]);
        }else{
            return $this->redirect($this->ayarlar('siteYolu'));
        }
        //////////////////////
        $em = $this->getDoctrine()->getManager();
        if ($this->get('session')->get('dil') == '') {
            $this->get('session')->set('dil', $this->varsayilanDil());
        }

        $suankiDil = $this->get('session')->get('dil');

        /* if($suankiDil['kisa']!=$dil){
             return $this->redirect($this->ayarlar('siteYolu'));
         }*/


        $qb = $em->createQueryBuilder();
        $sayfa = $qb->select('s.id,s.adi,s.bannerDurum,s.bannerUrl,s.title,s.keywords,s.description,s.dilgrup,s.seo,s.kategori,s.tekVeri,s.icIcerik,m.tabloAdi,m.alan,s.description,m.adi as madi')
            ->from('App:Sayfa', 's')
            ->join('s.dil', 'd')
            ->join('s.modul', 'm')
            ->where("s.seo ='$seo1' and d.id=" . $suankiDil['id'])
            ->orderBy('s.sira', 'ASC')
            ->getQuery()
            ->getScalarResult();


        /*   if(count($sayfa)==0){
               return $this->redirect($this->ayarlar('siteYolu'));
           }*/

        $sayfa = $sayfa[0];
        $sId= $this->IdBul('Sayfa',$sayfa['dilgrup']);

        $sayfaAlan = explode(',', $sayfa['alan']);
        $icerikalani = [];
        foreach ($sayfaAlan as $sA) {
            $icerikalani[] = 't.' . $this->seo(str_replace(' ', '', $sA));
        }


        $view = $this->seo(str_replace(' ', '', $sayfa['madi']));

        if($sayfa['kategori']==0) {
            // Sayfa İçi
            $qb = $em->createQueryBuilder();
            $icerik = $qb->select(implode(',',$icerikalani).',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                ->from('App:' . $sayfa['tabloAdi'], 't')
                ->leftjoin('t.kategori', 'k')
                ->join('t.sayfa', 's')
                ->join('t.dil', 'd')
                ->where("t.seourl='" .$seo10. "' and d.id=" . $suankiDil['id'])
                ->addOrderBy('t.sira', 'ASC')
                ->addOrderBy('t.id', 'DESC')
                ->getQuery()
                ->getScalarResult();
            if(count($icerik)==0){
                return $this->redirect($this->ayarlar('siteYolu'));
            }
            return $this->render('modul/'.$view.'_ic.html.twig',array('sayfa'=>$sayfa,'icerik'=>$icerik[0]));
        } else {

            $qb = $em->createQueryBuilder();
            $kategori = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId,k.id')
                ->from('App:Kategori', 'k')
                ->join('k.sayfa', 's')
                ->join('k.dil', 'd')
                ->where("k.seourl='" .$seo10. "' and d.id=" . $suankiDil['id'])
                ->orderBy('k.sira', 'ASC')
                ->getQuery()
                ->getScalarResult();

            if(count($kategori)==0){


                $qb = $em->createQueryBuilder();
                $kategori = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId,k.id')
                    ->from('App:Kategori', 'k')
                    ->join('k.sayfa', 's')
                    ->join('k.dil', 'd')
                    ->where("k.seourl='" .$seo9. "' and d.id=" . $suankiDil['id'])
                    ->orderBy('k.sira', 'ASC')
                    ->getQuery()
                    ->getScalarResult();

                $kId = $this->IdBul('Kategori',$kategori[0]['dilgrup']);

                $qb = $em->createQueryBuilder();
                $icerik = $qb->select(implode(',', $icerikalani) . ',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                    ->from('App:' . $sayfa['tabloAdi'], 't')
                    ->leftjoin('t.kategori', 'k')
                    ->join('t.sayfa', 's')
                    ->join('t.dil', 'd')
                    ->where("k.id=" . $kId . " and t.seourl='".$seo10."' and d.id=" . $suankiDil['id'])
                    ->addOrderBy('t.sira', 'ASC')
                    ->addOrderBy('t.id', 'DESC')
                    ->getQuery()
                    ->getScalarResult();

                if(count($kategori)<1 and count($icerik)<1){
                    return $this->redirect($this->ayarlar('siteYolu'));
                }

                return $this->render('modul/' . $view . '_ic.html.twig', array('sayfa' => $sayfa, 'kategori' => $kategori[0], 'icerik' => $icerik[0]));

            } else {
                $kId = $this->IdBul('Kategori',$kategori[0]['dilgrup']);

                $qb = $em->createQueryBuilder();
                $kategoriler = $qb->select('k.dilgrup,k.adi,k.seourl,k.title,k.keywords,k.description,k.ustid,k.resim,s.dilgrup as sayfaId')
                    ->from('App:Kategori', 'k')
                    ->join('k.sayfa', 's')
                    ->join('k.dil', 'd')
                    ->where("k.ustid=" . $kategori[0]['dilgrup'] . " and d.id=" . $suankiDil['id'])
                    ->orderBy('k.sira', 'ASC')
                    ->getQuery()
                    ->getScalarResult();

                $qb = $em->createQueryBuilder();
                $icerikler = $qb->select(implode(',', $icerikalani) . ',t.dilgrup,k.dilgrup as kategoriId,d.id as did,s.dilgrup as sayfaId')
                    ->from('App:' . $sayfa['tabloAdi'], 't')
                    ->leftjoin('t.kategori', 'k')
                    ->join('t.sayfa', 's')
                    ->join('t.dil', 'd')
                    ->where("k.id=" . $kId . " and d.id=" . $suankiDil['id'])
                    ->addOrderBy('t.sira', 'ASC')
                    ->addOrderBy('t.id', 'DESC')
                    ->getQuery()
                    ->getScalarResult();


                return $this->render('modul/' . $view . '_kategori.html.twig', array('sayfa' => $sayfa, 'kategori' => $kategori[0], 'icerikler' => $icerikler, 'kategoriler' => $kategoriler));

            }
        }


    }


}
