<?php

namespace App\Entity;

use App\Repository\AyarlarRepository;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=AyarlarRepository::class)
 */
class Ayarlar
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $siteAdi;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $siteYolu;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $logo;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $beyazLogo;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $favicon;

    /**
     * @ORM\Column(type="text", nullable=true)
     */
    private $ozelHead;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $title;

    /**
     * @ORM\Column(type="text", nullable=true)
     */
    private $keywords;

    /**
     * @ORM\Column(type="text", nullable=true)
     */
    private $description;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $region;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $placeName;

    /**
     * @ORM\Column(type="boolean")
     */
    private $whatsapp;

    /**
     * @ORM\Column(type="boolean")
     */
    private $bEposta;

    /**
     * @ORM\Column(type="boolean")
     */
    private $debug;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $sistemPosta;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $slider;

    /**
     * @ORM\Column(type="boolean")
     */
    private $hataPage;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $position;

    /**
     * @ORM\ManyToOne(targetEntity=Dil::class, inversedBy="ayarlar")
     * @ORM\JoinColumn(nullable=false)
     */
    private $dil;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $uploadFolder;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getSiteAdi(): ?string
    {
        return $this->siteAdi;
    }

    public function setSiteAdi(string $siteAdi): self
    {
        $this->siteAdi = $siteAdi;

        return $this;
    }

    public function getSiteYolu(): ?string
    {
        return $this->siteYolu;
    }

    public function setSiteYolu(string $siteYolu): self
    {
        $this->siteYolu = $siteYolu;

        return $this;
    }

    public function getLogo(): ?string
    {
        return $this->logo;
    }

    public function setLogo(string $logo): self
    {
        $this->logo = $logo;

        return $this;
    }

    public function getBeyazLogo(): ?string
    {
        return $this->beyazLogo;
    }

    public function setBeyazLogo(string $beyazLogo): self
    {
        $this->beyazLogo = $beyazLogo;

        return $this;
    }

    public function getFavicon(): ?string
    {
        return $this->favicon;
    }

    public function setFavicon(string $favicon): self
    {
        $this->favicon = $favicon;

        return $this;
    }

    public function getOzelHead(): ?string
    {
        return $this->ozelHead;
    }

    public function setOzelHead(?string $ozelHead): self
    {
        $this->ozelHead = $ozelHead;

        return $this;
    }

    public function getTitle(): ?string
    {
        return $this->title;
    }

    public function setTitle(?string $title): self
    {
        $this->title = $title;

        return $this;
    }

    public function getKeywords(): ?string
    {
        return $this->keywords;
    }

    public function setKeywords(?string $keywords): self
    {
        $this->keywords = $keywords;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(?string $description): self
    {
        $this->description = $description;

        return $this;
    }

    public function getRegion(): ?string
    {
        return $this->region;
    }

    public function setRegion(?string $region): self
    {
        $this->region = $region;

        return $this;
    }

    public function getPlaceName(): ?string
    {
        return $this->placeName;
    }

    public function setPlaceName(?string $placeName): self
    {
        $this->placeName = $placeName;

        return $this;
    }

    public function getWhatsapp(): ?bool
    {
        return $this->whatsapp;
    }

    public function setWhatsapp(bool $whatsapp): self
    {
        $this->whatsapp = $whatsapp;

        return $this;
    }

    public function getBEposta(): ?bool
    {
        return $this->bEposta;
    }

    public function setBEposta(bool $bEposta): self
    {
        $this->bEposta = $bEposta;

        return $this;
    }

    public function getDebug(): ?bool
    {
        return $this->debug;
    }

    public function setDebug(bool $debug): self
    {
        $this->debug = $debug;

        return $this;
    }

    public function getSistemPosta(): ?string
    {
        return $this->sistemPosta;
    }

    public function setSistemPosta(?string $sistemPosta): self
    {
        $this->sistemPosta = $sistemPosta;

        return $this;
    }

    public function getSlider(): ?string
    {
        return $this->slider;
    }

    public function setSlider(?string $slider): self
    {
        $this->slider = $slider;

        return $this;
    }

    public function getHataPage(): ?bool
    {
        return $this->hataPage;
    }

    public function setHataPage(bool $hataPage): self
    {
        $this->hataPage = $hataPage;

        return $this;
    }

    public function getPosition(): ?string
    {
        return $this->position;
    }

    public function setPosition(?string $position): self
    {
        $this->position = $position;

        return $this;
    }

    public function getDil(): ?Dil
    {
        return $this->dil;
    }

    public function setDil(?Dil $dil): self
    {
        $this->dil = $dil;

        return $this;
    }

    public function getUploadFolder(): ?string
    {
        return $this->uploadFolder;
    }

    public function setUploadFolder(?string $uploadFolder): self
    {
        $this->uploadFolder = $uploadFolder;

        return $this;
    }
}
