<?php

namespace App\Entity;

use App\Repository\DilRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=DilRepository::class)
 */
class Dil
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $kisa;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $uzun;

    /**
     * @ORM\Column(type="boolean", nullable=true)
     */
    private $varsayilan;

    /**
     * @ORM\Column(type="boolean", nullable=true)
     */
    private $aktif;

    /**
     * @ORM\OneToMany(targetEntity=Ayarlar::class, mappedBy="dil", orphanRemoval=true)
     */
    private $ayarlar;

    /**
     * @ORM\OneToMany(targetEntity=Ceviri::class, mappedBy="dil", orphanRemoval=true)
     */
    private $ceviri;

    /**
     * @ORM\OneToMany(targetEntity=Kategori::class, mappedBy="dil", orphanRemoval=true)
     */
    private $kategori;

    /**
     * @ORM\OneToMany(targetEntity=Sayfa::class, mappedBy="dil", orphanRemoval=true)
     */
    private $sayfa;

    /**
     * @ORM\OneToMany(targetEntity=Slider::class, mappedBy="dil", orphanRemoval=true)
     */
    private $slider;

    /**
     * @ORM\OneToMany(targetEntity=Popup::class, mappedBy="dil", orphanRemoval=true)
     */
    private $popup;

    /**
     * @ORM\OneToMany(targetEntity=Kurumsal::class, mappedBy="dil", orphanRemoval=true)
     */
    private $kurumsal;

    /**
     * @ORM\OneToMany(targetEntity=Iletisim::class, mappedBy="dil", orphanRemoval=true)
     */
    private $iletisim;

    /**
     * @ORM\OneToMany(targetEntity=Hizmetler::class, mappedBy="dil", orphanRemoval=true)
     */
    private $hizmetler;

    /**
     * @ORM\OneToMany(targetEntity=Footermetin::class, mappedBy="dil", orphanRemoval=true)
     */
    private $footermetin;

    /**
     * @ORM\OneToMany(targetEntity=Bossayfa::class, mappedBy="dil", orphanRemoval=true)
     */
    private $bossayfa;

    /**
     * @ORM\OneToMany(targetEntity=Haberler::class, mappedBy="dil", orphanRemoval=true)
     */
    private $haberler;

    public function __construct()
    {
        $this->kurumsal = new ArrayCollection();
        $this->iletisim = new ArrayCollection();
        $this->hizmetler = new ArrayCollection();
        $this->footermetin = new ArrayCollection();
        $this->bossayfa = new ArrayCollection();
        $this->haberler = new ArrayCollection();
        $this->ayarlar = new ArrayCollection();
        $this->ceviri = new ArrayCollection();
        $this->kategori = new ArrayCollection();
        $this->sayfa = new ArrayCollection();
        $this->slider = new ArrayCollection();
        $this->popup = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    /**
     * @return Collection|Kurumsal[]
     */
    public function getKurumsal(): Collection
    {
        return $this->kurumsal;
    }
    
    public function addKurumsal(Kurumsal $kurumsal): self
    {
        if (!$this->kurumsal->contains($kurumsal)) {
            $this->kurumsal[] = $kurumsal;
            $kurumsal->setDil($this);
        }

        return $this;
    }

    public function removeKurumsal(Kurumsal $kurumsal): self
    {
        if ($this->kurumsal->removeElement($kurumsal)) {
            // set the owning side to null (unless already changed)
            if ($kurumsal->getDil() === $this) {
                $kurumsal->setDil(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Iletisim[]
     */
    public function getIletisim(): Collection
    {
        return $this->iletisim;
    }
    
    public function addIletisim(Iletisim $iletisim): self
    {
        if (!$this->iletisim->contains($iletisim)) {
            $this->iletisim[] = $iletisim;
            $iletisim->setDil($this);
        }

        return $this;
    }

    public function removeIletisim(Iletisim $iletisim): self
    {
        if ($this->iletisim->removeElement($iletisim)) {
            // set the owning side to null (unless already changed)
            if ($iletisim->getDil() === $this) {
                $iletisim->setDil(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Hizmetler[]
     */
    public function getHizmetler(): Collection
    {
        return $this->hizmetler;
    }
    
    public function addHizmetler(Hizmetler $hizmetler): self
    {
        if (!$this->hizmetler->contains($hizmetler)) {
            $this->hizmetler[] = $hizmetler;
            $hizmetler->setDil($this);
        }

        return $this;
    }

    public function removeHizmetler(Hizmetler $hizmetler): self
    {
        if ($this->hizmetler->removeElement($hizmetler)) {
            // set the owning side to null (unless already changed)
            if ($hizmetler->getDil() === $this) {
                $hizmetler->setDil(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Footermetin[]
     */
    public function getFootermetin(): Collection
    {
        return $this->footermetin;
    }
    
    public function addFootermetin(Footermetin $footermetin): self
    {
        if (!$this->footermetin->contains($footermetin)) {
            $this->footermetin[] = $footermetin;
            $footermetin->setDil($this);
        }

        return $this;
    }

    public function removeFootermetin(Footermetin $footermetin): self
    {
        if ($this->footermetin->removeElement($footermetin)) {
            // set the owning side to null (unless already changed)
            if ($footermetin->getDil() === $this) {
                $footermetin->setDil(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Bossayfa[]
     */
    public function getBossayfa(): Collection
    {
        return $this->bossayfa;
    }
    
    public function addBossayfa(Bossayfa $bossayfa): self
    {
        if (!$this->bossayfa->contains($bossayfa)) {
            $this->bossayfa[] = $bossayfa;
            $bossayfa->setDil($this);
        }

        return $this;
    }

    public function removeBossayfa(Bossayfa $bossayfa): self
    {
        if ($this->bossayfa->removeElement($bossayfa)) {
            // set the owning side to null (unless already changed)
            if ($bossayfa->getDil() === $this) {
                $bossayfa->setDil(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Haberler[]
     */
    public function getHaberler(): Collection
    {
        return $this->haberler;
    }
    
    public function addHaberler(Haberler $haberler): self
    {
        if (!$this->haberler->contains($haberler)) {
            $this->haberler[] = $haberler;
            $haberler->setDil($this);
        }

        return $this;
    }

    public function removeHaberler(Haberler $haberler): self
    {
        if ($this->haberler->removeElement($haberler)) {
            // set the owning side to null (unless already changed)
            if ($haberler->getDil() === $this) {
                $haberler->setDil(null);
            }
        }

        return $this;
    }

    public function getKisa(): ?string
    {
        return $this->kisa;
    }

    public function setKisa(string $kisa): self
    {
        $this->kisa = $kisa;

        return $this;
    }

    public function getUzun(): ?string
    {
        return $this->uzun;
    }

    public function setUzun(string $uzun): self
    {
        $this->uzun = $uzun;

        return $this;
    }

    public function getVarsayilan(): ?bool
    {
        return $this->varsayilan;
    }

    public function setVarsayilan(?bool $varsayilan): self
    {
        $this->varsayilan = $varsayilan;

        return $this;
    }

    public function getAktif(): ?bool
    {
        return $this->aktif;
    }

    public function setAktif(?bool $aktif): self
    {
        $this->aktif = $aktif;

        return $this;
    }

    /**
     * @return Collection|Ayarlar[]
     */
    public function getAyarlar(): Collection
    {
        return $this->ayarlar;
    }

    public function addAyarlar(Ayarlar $ayarlar): self
    {
        if (!$this->ayarlar->contains($ayarlar)) {
            $this->ayarlar[] = $ayarlar;
            $ayarlar->setDil($this);
        }

        return $this;
    }

    public function removeAyarlar(Ayarlar $ayarlar): self
    {
        if ($this->ayarlar->removeElement($ayarlar)) {
            // set the owning side to null (unless already changed)
            if ($ayarlar->getDil() === $this) {
                $ayarlar->setDil(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Ceviri[]
     */
    public function getCeviri(): Collection
    {
        return $this->ceviri;
    }

    public function addCevirus(Ceviri $cevirus): self
    {
        if (!$this->ceviri->contains($cevirus)) {
            $this->ceviri[] = $cevirus;
            $cevirus->setDil($this);
        }

        return $this;
    }

    public function removeCevirus(Ceviri $cevirus): self
    {
        if ($this->ceviri->removeElement($cevirus)) {
            // set the owning side to null (unless already changed)
            if ($cevirus->getDil() === $this) {
                $cevirus->setDil(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Kategori[]
     */
    public function getKategori(): Collection
    {
        return $this->kategori;
    }

    public function addKategori(Kategori $kategori): self
    {
        if (!$this->kategori->contains($kategori)) {
            $this->kategori[] = $kategori;
            $kategori->setDil($this);
        }

        return $this;
    }

    public function removeKategori(Kategori $kategori): self
    {
        if ($this->kategori->removeElement($kategori)) {
            // set the owning side to null (unless already changed)
            if ($kategori->getDil() === $this) {
                $kategori->setDil(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Sayfa[]
     */
    public function getSayfa(): Collection
    {
        return $this->sayfa;
    }

    public function addSayfa(Sayfa $sayfa): self
    {
        if (!$this->sayfa->contains($sayfa)) {
            $this->sayfa[] = $sayfa;
            $sayfa->setDil($this);
        }

        return $this;
    }

    public function removeSayfa(Sayfa $sayfa): self
    {
        if ($this->sayfa->removeElement($sayfa)) {
            // set the owning side to null (unless already changed)
            if ($sayfa->getDil() === $this) {
                $sayfa->setDil(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Slider[]
     */
    public function getSlider(): Collection
    {
        return $this->slider;
    }

    public function addSlider(Slider $slider): self
    {
        if (!$this->slider->contains($slider)) {
            $this->slider[] = $slider;
            $slider->setDil($this);
        }

        return $this;
    }

    public function removeSlider(Slider $slider): self
    {
        if ($this->slider->removeElement($slider)) {
            // set the owning side to null (unless already changed)
            if ($slider->getDil() === $this) {
                $slider->setDil(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Popup[]
     */
    public function getPopup(): Collection
    {
        return $this->popup;
    }

    public function addPopup(Popup $popup): self
    {
        if (!$this->popup->contains($popup)) {
            $this->popup[] = $popup;
            $popup->setDil($this);
        }

        return $this;
    }

    public function removePopup(Popup $popup): self
    {
        if ($this->popup->removeElement($popup)) {
            // set the owning side to null (unless already changed)
            if ($popup->getDil() === $this) {
                $popup->setDil(null);
            }
        }

        return $this;
    }
}
