<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity
 */
class Footermetin
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="text")
     */
    private $kurumsalaciklama;
    
    /**
     * @ORM\Column(type="integer")
     */
    private $dilgrup;

    /**
     * @ORM\ManyToOne(targetEntity=Dil::class, inversedBy="footermetin")
     * @ORM\JoinColumn(nullable=false)
     */
    private $dil;
    /**
     * @ORM\ManyToOne(targetEntity=Sayfa::class, inversedBy="footermetin")
     * @ORM\JoinColumn(nullable=false)
     */
    private $sayfa;
    
    /**
     * @ORM\ManyToOne(targetEntity=Kategori::class, inversedBy="footermetin")
     * @ORM\JoinColumn(nullable=true)
     */
    private $kategori;
    /**
     * @ORM\Column(type="integer", nullable=true)
     */
    private $sira;
    
    public function getId(): ?int
    {
        return $this->id;
    }
    
    public function getKurumsalaciklama(): ?string
    {
        return $this->kurumsalaciklama;
    }

    public function setKurumsalaciklama(string $kurumsalaciklama): self
    {
        $this->kurumsalaciklama = $kurumsalaciklama;

        return $this;
    }
    public function getDilgrup(): ?int
    {
        return $this->dilgrup;
    }

    public function setDilgrup(int $dilgrup): self
    {
        $this->dilgrup = $dilgrup;

        return $this;
    }

    public function getDil(): ?Dil
    {
        return $this->dil;
    }

    public function setDil(?Dil $dil): self
    {
        $this->dil = $dil;

        return $this;
    }
    public function getSayfa(): ?Sayfa
    {
        return $this->sayfa;
    }

    public function setSayfa(?Sayfa $sayfa): self
    {
        $this->sayfa = $sayfa;

        return $this;
    }
    
    public function getKategori(): ?Kategori
    {
        return $this->kategori;
    }

    public function setKategori(?Kategori $kategori): self
    {
        $this->kategori = $kategori;

        return $this;
    }
    public function getSira(): ?int
    {
        return $this->sira;
    }

    public function setSira(?int $sira): self
    {
        $this->sira = $sira;

        return $this;
    }
}