<?php

namespace App\Entity;

use App\Repository\FormRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=FormRepository::class)
 */
class Form
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $adi;

    /**
     * @ORM\Column(type="text")
     */
    private $tip;

    /**
     * @ORM\Column(type="text", nullable=true)
     */
    private $veri;

    /**
     * @ORM\Column(type="text")
     */
    private $alan;

    /**
     * @ORM\Column(type="boolean")
     */
    private $eposta;

    /**
     * @ORM\Column(type="text", nullable=true)
     */
    private $zorunlu;

    /**
     * @ORM\OneToMany(targetEntity=FormKayit::class, mappedBy="form", orphanRemoval=true)
     */
    private $formKayit;

    public function __construct()
    {
        $this->formKayit = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getAdi(): ?string
    {
        return $this->adi;
    }

    public function setAdi(string $adi): self
    {
        $this->adi = $adi;

        return $this;
    }

    public function getTip(): ?string
    {
        return $this->tip;
    }

    public function setTip(string $tip): self
    {
        $this->tip = $tip;

        return $this;
    }

    public function getVeri(): ?string
    {
        return $this->veri;
    }

    public function setVeri(?string $veri): self
    {
        $this->veri = $veri;

        return $this;
    }

    public function getAlan(): ?string
    {
        return $this->alan;
    }

    public function setAlan(string $alan): self
    {
        $this->alan = $alan;

        return $this;
    }

    public function getEposta(): ?bool
    {
        return $this->eposta;
    }

    public function setEposta(bool $eposta): self
    {
        $this->eposta = $eposta;

        return $this;
    }

    public function getZorunlu(): ?string
    {
        return $this->zorunlu;
    }

    public function setZorunlu(?string $zorunlu): self
    {
        $this->zorunlu = $zorunlu;

        return $this;
    }

    /**
     * @return Collection|FormKayit[]
     */
    public function getFormKayit(): Collection
    {
        return $this->formKayit;
    }

    public function addFormKayit(FormKayit $formKayit): self
    {
        if (!$this->formKayit->contains($formKayit)) {
            $this->formKayit[] = $formKayit;
            $formKayit->setForm($this);
        }

        return $this;
    }

    public function removeFormKayit(FormKayit $formKayit): self
    {
        if ($this->formKayit->removeElement($formKayit)) {
            // set the owning side to null (unless already changed)
            if ($formKayit->getForm() === $this) {
                $formKayit->setForm(null);
            }
        }

        return $this;
    }
}
