<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity
 */
class Hizmetler
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $seourl;
    
    /**
     * @ORM\Column(type="string", length=255)
     */
    private $sayfabasligi;
    
    /**
     * @ORM\Column(type="text", nullable=true)
     */
    private $anahtarkelimeler;
    
    /**
     * @ORM\Column(type="text", nullable=true)
     */
    private $sayfaaciklamasi;
    
    /**
     * @ORM\Column(type="string", length=255)
     */
    private $adi;
    
    /**
     * @ORM\Column(type="text", nullable=true)
     */
    private $metin;
    
    /**
     * @ORM\Column(type="text")
     */
    private $resim;
    
    /**
     * @ORM\Column(type="integer")
     */
    private $dilgrup;

    /**
     * @ORM\ManyToOne(targetEntity=Dil::class, inversedBy="hizmetler")
     * @ORM\JoinColumn(nullable=false)
     */
    private $dil;
    /**
     * @ORM\ManyToOne(targetEntity=Sayfa::class, inversedBy="hizmetler")
     * @ORM\JoinColumn(nullable=false)
     */
    private $sayfa;
    
    /**
     * @ORM\ManyToOne(targetEntity=Kategori::class, inversedBy="hizmetler")
     * @ORM\JoinColumn(nullable=true)
     */
    private $kategori;
    /**
     * @ORM\Column(type="integer", nullable=true)
     */
    private $sira;
    
    public function getId(): ?int
    {
        return $this->id;
    }
    
    public function getSeourl(): ?string
    {
        return $this->seourl;
    }

    public function setSeourl(string $seourl): self
    {
        $this->seourl = $seourl;

        return $this;
    }
    public function getSayfabasligi(): ?string
    {
        return $this->sayfabasligi;
    }

    public function setSayfabasligi(string $sayfabasligi): self
    {
        $this->sayfabasligi = $sayfabasligi;

        return $this;
    }
    public function getAnahtarkelimeler(): ?string
    {
        return $this->anahtarkelimeler;
    }

    public function setAnahtarkelimeler(?string $anahtarkelimeler): self
    {
        $this->anahtarkelimeler = $anahtarkelimeler;

        return $this;
    }
    public function getSayfaaciklamasi(): ?string
    {
        return $this->sayfaaciklamasi;
    }

    public function setSayfaaciklamasi(?string $sayfaaciklamasi): self
    {
        $this->sayfaaciklamasi = $sayfaaciklamasi;

        return $this;
    }
    public function getAdi(): ?string
    {
        return $this->adi;
    }

    public function setAdi(string $adi): self
    {
        $this->adi = $adi;

        return $this;
    }
    public function getMetin(): ?string
    {
        return $this->metin;
    }

    public function setMetin(?string $metin): self
    {
        $this->metin = $metin;

        return $this;
    }
    public function getResim(): ?string
    {
        return $this->resim;
    }

    public function setResim(string $resim): self
    {
        $this->resim = $resim;

        return $this;
    }
    public function getDilgrup(): ?int
    {
        return $this->dilgrup;
    }

    public function setDilgrup(int $dilgrup): self
    {
        $this->dilgrup = $dilgrup;

        return $this;
    }

    public function getDil(): ?Dil
    {
        return $this->dil;
    }

    public function setDil(?Dil $dil): self
    {
        $this->dil = $dil;

        return $this;
    }
    public function getSayfa(): ?Sayfa
    {
        return $this->sayfa;
    }

    public function setSayfa(?Sayfa $sayfa): self
    {
        $this->sayfa = $sayfa;

        return $this;
    }
    
    public function getKategori(): ?Kategori
    {
        return $this->kategori;
    }

    public function setKategori(?Kategori $kategori): self
    {
        $this->kategori = $kategori;

        return $this;
    }
    public function getSira(): ?int
    {
        return $this->sira;
    }

    public function setSira(?int $sira): self
    {
        $this->sira = $sira;

        return $this;
    }
}