<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity
 */
class Iletisim
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="text")
     */
    private $adres;
    
    /**
     * @ORM\Column(type="string", length=255)
     */
    private $telefon;
    
    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $gsm;
    
    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $fax;
    
    /**
     * @ORM\Column(type="string", length=255)
     */
    private $eposta;
    
    /**
     * @ORM\Column(type="text", nullable=true)
     */
    private $harita;
    
    /**
     * @ORM\Column(type="integer")
     */
    private $dilgrup;

    /**
     * @ORM\ManyToOne(targetEntity=Dil::class, inversedBy="iletisim")
     * @ORM\JoinColumn(nullable=false)
     */
    private $dil;
    /**
     * @ORM\ManyToOne(targetEntity=Sayfa::class, inversedBy="iletisim")
     * @ORM\JoinColumn(nullable=false)
     */
    private $sayfa;
    
    /**
     * @ORM\ManyToOne(targetEntity=Kategori::class, inversedBy="iletisim")
     * @ORM\JoinColumn(nullable=true)
     */
    private $kategori;
    /**
     * @ORM\Column(type="integer", nullable=true)
     */
    private $sira;
    
    public function getId(): ?int
    {
        return $this->id;
    }
    
    public function getAdres(): ?string
    {
        return $this->adres;
    }

    public function setAdres(string $adres): self
    {
        $this->adres = $adres;

        return $this;
    }
    public function getTelefon(): ?string
    {
        return $this->telefon;
    }

    public function setTelefon(string $telefon): self
    {
        $this->telefon = $telefon;

        return $this;
    }
    public function getGsm(): ?string
    {
        return $this->gsm;
    }

    public function setGsm(?string $gsm): self
    {
        $this->gsm = $gsm;

        return $this;
    }
    public function getFax(): ?string
    {
        return $this->fax;
    }

    public function setFax(?string $fax): self
    {
        $this->fax = $fax;

        return $this;
    }
    public function getEposta(): ?string
    {
        return $this->eposta;
    }

    public function setEposta(string $eposta): self
    {
        $this->eposta = $eposta;

        return $this;
    }
    public function getHarita(): ?string
    {
        return $this->harita;
    }

    public function setHarita(?string $harita): self
    {
        $this->harita = $harita;

        return $this;
    }
    public function getDilgrup(): ?int
    {
        return $this->dilgrup;
    }

    public function setDilgrup(int $dilgrup): self
    {
        $this->dilgrup = $dilgrup;

        return $this;
    }

    public function getDil(): ?Dil
    {
        return $this->dil;
    }

    public function setDil(?Dil $dil): self
    {
        $this->dil = $dil;

        return $this;
    }
    public function getSayfa(): ?Sayfa
    {
        return $this->sayfa;
    }

    public function setSayfa(?Sayfa $sayfa): self
    {
        $this->sayfa = $sayfa;

        return $this;
    }
    
    public function getKategori(): ?Kategori
    {
        return $this->kategori;
    }

    public function setKategori(?Kategori $kategori): self
    {
        $this->kategori = $kategori;

        return $this;
    }
    public function getSira(): ?int
    {
        return $this->sira;
    }

    public function setSira(?int $sira): self
    {
        $this->sira = $sira;

        return $this;
    }
}