<?php

namespace App\Entity;

use App\Repository\ModulRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=ModulRepository::class)
 */
class Modul
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $adi;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $tabloAdi;

    /**
     * @ORM\Column(type="text")
     */
    private $alan;

    /**
     * @ORM\Column(type="text")
     */
    private $tip;

    /**
     * @ORM\Column(type="text")
     */
    private $bosluk;

    /**
     * @ORM\Column(type="boolean")
     */
    private $cokluDil;

    /**
     * @ORM\OneToMany(targetEntity=Sayfa::class, mappedBy="modul", orphanRemoval=true)
     */
    private $sayfa;

    /**
     * @ORM\OneToMany(targetEntity=Tasarim::class, mappedBy="modul")
     */
    private $tasarim;

    public function __construct()
    {
        $this->sayfa = new ArrayCollection();
        $this->tasarim = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getAdi(): ?string
    {
        return $this->adi;
    }

    public function setAdi(string $adi): self
    {
        $this->adi = $adi;

        return $this;
    }

    public function getTabloAdi(): ?string
    {
        return $this->tabloAdi;
    }

    public function setTabloAdi(string $tabloAdi): self
    {
        $this->tabloAdi = $tabloAdi;

        return $this;
    }

    public function getAlan(): ?string
    {
        return $this->alan;
    }

    public function setAlan(string $alan): self
    {
        $this->alan = $alan;

        return $this;
    }

    public function getTip(): ?string
    {
        return $this->tip;
    }

    public function setTip(string $tip): self
    {
        $this->tip = $tip;

        return $this;
    }

    public function getBosluk(): ?string
    {
        return $this->bosluk;
    }

    public function setBosluk(string $bosluk): self
    {
        $this->bosluk = $bosluk;

        return $this;
    }

    public function getCokluDil(): ?bool
    {
        return $this->cokluDil;
    }

    public function setCokluDil(bool $cokluDil): self
    {
        $this->cokluDil = $cokluDil;

        return $this;
    }

    /**
     * @return Collection|Sayfa[]
     */
    public function getSayfa(): Collection
    {
        return $this->sayfa;
    }

    public function addSayfa(Sayfa $sayfa): self
    {
        if (!$this->sayfa->contains($sayfa)) {
            $this->sayfa[] = $sayfa;
            $sayfa->setModul($this);
        }

        return $this;
    }

    public function removeSayfa(Sayfa $sayfa): self
    {
        if ($this->sayfa->removeElement($sayfa)) {
            // set the owning side to null (unless already changed)
            if ($sayfa->getModul() === $this) {
                $sayfa->setModul(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection<int, Tasarim>
     */
    public function getTasarim(): Collection
    {
        return $this->tasarim;
    }

    public function addTasarim(Tasarim $tasarim): self
    {
        if (!$this->tasarim->contains($tasarim)) {
            $this->tasarim[] = $tasarim;
            $tasarim->setModul($this);
        }

        return $this;
    }

    public function removeTasarim(Tasarim $tasarim): self
    {
        if ($this->tasarim->removeElement($tasarim)) {
            // set the owning side to null (unless already changed)
            if ($tasarim->getModul() === $this) {
                $tasarim->setModul(null);
            }
        }

        return $this;
    }
}
