<?php

namespace App\Entity;

use App\Repository\PopupRepository;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=PopupRepository::class)
 */
class Popup
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=1000)
     */
    private $veri;

    /**
     * @ORM\Column(type="boolean")
     */
    private $tip;

    /**
     * @ORM\Column(type="string", length=1000, nullable=true)
     */
    private $link;

    /**
     * @ORM\Column(type="integer")
     */
    private $dilgrup;

    /**
     * @ORM\ManyToOne(targetEntity=Dil::class, inversedBy="popup")
     * @ORM\JoinColumn(nullable=false)
     */
    private $dil;

    /**
     * @ORM\Column(type="integer", nullable=true)
     */
    private $sayfaId;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getVeri(): ?string
    {
        return $this->veri;
    }

    public function setVeri(string $veri): self
    {
        $this->veri = $veri;

        return $this;
    }

    public function getTip(): ?bool
    {
        return $this->tip;
    }

    public function setTip(bool $tip): self
    {
        $this->tip = $tip;

        return $this;
    }

    public function getLink(): ?string
    {
        return $this->link;
    }

    public function setLink(?string $link): self
    {
        $this->link = $link;

        return $this;
    }

    public function getDilgrup(): ?int
    {
        return $this->dilgrup;
    }

    public function setDilgrup(int $dilgrup): self
    {
        $this->dilgrup = $dilgrup;

        return $this;
    }

    public function getDil(): ?Dil
    {
        return $this->dil;
    }

    public function setDil(?Dil $dil): self
    {
        $this->dil = $dil;

        return $this;
    }

    public function getSayfaId(): ?int
    {
        return $this->sayfaId;
    }

    public function setSayfaId(?int $sayfaId): self
    {
        $this->sayfaId = $sayfaId;

        return $this;
    }
}
