<?php

namespace App\Entity;

use App\Repository\SliderRepository;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=SliderRepository::class)
 */
class Slider
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $resim;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $baslik;

    /**
     * @ORM\Column(type="text", nullable=true)
     */
    private $aciklama;

    /**
     * @ORM\Column(type="integer")
     */
    private $dilgrup;

    /**
     * @ORM\Column(type="integer")
     */
    private $sira;

    /**
     * @ORM\ManyToOne(targetEntity=Dil::class, inversedBy="slider")
     * @ORM\JoinColumn(nullable=false)
     */
    private $dil;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getResim(): ?string
    {
        return $this->resim;
    }

    public function setResim(string $resim): self
    {
        $this->resim = $resim;

        return $this;
    }

    public function getBaslik(): ?string
    {
        return $this->baslik;
    }

    public function setBaslik(?string $baslik): self
    {
        $this->baslik = $baslik;

        return $this;
    }

    public function getAciklama(): ?string
    {
        return $this->aciklama;
    }

    public function setAciklama(?string $aciklama): self
    {
        $this->aciklama = $aciklama;

        return $this;
    }

    public function getDilgrup(): ?int
    {
        return $this->dilgrup;
    }

    public function setDilgrup(int $dilgrup): self
    {
        $this->dilgrup = $dilgrup;

        return $this;
    }

    public function getSira(): ?int
    {
        return $this->sira;
    }

    public function setSira(int $sira): self
    {
        $this->sira = $sira;

        return $this;
    }

    public function getDil(): ?Dil
    {
        return $this->dil;
    }

    public function setDil(?Dil $dil): self
    {
        $this->dil = $dil;

        return $this;
    }
}
