<?php

namespace App\Repository;

use App\Entity\SosyalAg;
use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Doctrine\ORM\Exception\ORMException;
use Doctrine\ORM\OptimisticLockException;
use Doctrine\Persistence\ManagerRegistry;

/**
 * @extends ServiceEntityRepository<SosyalAg>
 *
 * @method SosyalAg|null find($id, $lockMode = null, $lockVersion = null)
 * @method SosyalAg|null findOneBy(array $criteria, array $orderBy = null)
 * @method SosyalAg[]    findAll()
 * @method SosyalAg[]    findBy(array $criteria, array $orderBy = null, $limit = null, $offset = null)
 */
class SosyalAgRepository extends ServiceEntityRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, SosyalAg::class);
    }

    /**
     * @throws ORMException
     * @throws OptimisticLockException
     */
    public function add(SosyalAg $entity, bool $flush = false): void
    {
        $this->_em->persist($entity);
        if ($flush) {
            $this->_em->flush();
        }
    }

    /**
     * @throws ORMException
     * @throws OptimisticLockException
     */
    public function remove(SosyalAg $entity, bool $flush = false): void
    {
        $this->_em->remove($entity);
        if ($flush) {
            $this->_em->flush();
        }
    }

//    /**
//     * @return SosyalAg[] Returns an array of SosyalAg objects
//     */
//    public function findByExampleField($value): array
//    {
//        return $this->createQueryBuilder('s')
//            ->andWhere('s.exampleField = :val')
//            ->setParameter('val', $value)
//            ->orderBy('s.id', 'ASC')
//            ->setMaxResults(10)
//            ->getQuery()
//            ->getResult()
//        ;
//    }

//    public function findOneBySomeField($value): ?SosyalAg
//    {
//        return $this->createQueryBuilder('s')
//            ->andWhere('s.exampleField = :val')
//            ->setParameter('val', $value)
//            ->getQuery()
//            ->getOneOrNullResult()
//        ;
//    }
}
